GNU bug report logs - #38529
Make --pure the default for `guix environment'?

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: guix; Reported by: Pierre Neidhardt <mail@HIDDEN>; dated Sun, 8 Dec 2019 15:43:02 UTC; Maintainer for guix is bug-guix@HIDDEN.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 21:32:57 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 16:32:57 2019
Received: from localhost ([127.0.0.1]:33541 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1im2en-0001D8-5X
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 16:32:57 -0500
Received: from mail-qk1-f180.google.com ([209.85.222.180]:39230)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1im2el-0001Cw-IA
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 16:32:55 -0500
Received: by mail-qk1-f180.google.com with SMTP id c16so27177210qko.6
 for <38529 <at> debbugs.gnu.org>; Mon, 30 Dec 2019 13:32:55 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=2wpZbKfr2st4dGcLn517s4ltjk3b6s4Epx1KrVEvGEY=;
 b=maqKlu2ldlb6QXJLTyEQyINrJNukWpzRy69AfhMki/fskDwayoLRG3bR2pQ9O0P5gs
 HA8+PVPGTAQ0ccvJ9BL3VwU4skypJNGy8B28WgGk0r72n5mnXp+jKVIbadV0SRFlMqSm
 06/WVMOdYc3q3TMalmNZu9kUr0GvNGKnFSz8TDW19EF+12UK69n57PPNwgelZUz0SjGW
 wrtiNufc/mgbR6BKspaSaSeT84TuQg7pTSbMWCMsYxZm4ligwUbu6X4WEzKxatTfKloF
 0BS9MRY/rJn/zgmr5sfV5jESNVE9/3Mj1t9cwjeI16GXXmJIM1J9bP7GUgi/Mo8p5mhY
 OZEQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=2wpZbKfr2st4dGcLn517s4ltjk3b6s4Epx1KrVEvGEY=;
 b=PQkE89hxTjbHKRnmMm9xg7Jl2RQwsNOXK4z8cOGJ+ohQSsUIcH5GopY53stRMo8a7i
 wCmsnKsF1bGS31lHi3/JgH7vSn6D5fYZ8b0css9V9gGpjJsxLRzU1QrOxOxh+eVfMOMq
 xRgA+A4YI5GykQItabkFOKuIJost+MwIs7HX60/V/zraVT20SyIhTGvWODgrMFqovi38
 yslAx9QjDyQ7tPs3uClE9HY0T3VPGevbwvg0x81fm0yjSMPCMCfm6Z8/qqwqguwYd+JG
 wRVA5blHcml+/R9YBLO9Vebv4NcjrbVSztT2RqGIqsvOIjKy7ao9+P5lYJs83ECfg7Wl
 pOpA==
X-Gm-Message-State: APjAAAX7BXardw4vVw7YXGmL6hw0qFLDayvwLUirLIiPhXlq03rSj+j4
 hunESCfEhC0ta9D7atCramsg5d3wuCrJx+Drq0NtfQ==
X-Google-Smtp-Source: APXvYqy78kYseZjH8g8RJvOT7qQmJq+8sohVxAW4HXXpdhT4h/QwXp7sInV/y1rTf02hPa3olj5RJ+PuqMCfjsNIYFQ=
X-Received: by 2002:a37:a451:: with SMTP id n78mr51322384qke.304.1577741570015; 
 Mon, 30 Dec 2019 13:32:50 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
 <87blrqp2pp.fsf@HIDDEN> <878smu85kw.fsf@HIDDEN>
 <CAJ3okZ3jjB8kRRN3xqv7VWn0ba_Qwm8jDWUUiodXi+NtQwWsLA@HIDDEN>
 <87tv5h7t0j.fsf@HIDDEN>
 <CAJ3okZ2WVmPprrGw4xnzpRYzBeMXMPVnaTgG00=DicTaRFRMmw@HIDDEN>
 <87eewlo6yp.fsf@HIDDEN>
In-Reply-To: <87eewlo6yp.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Mon, 30 Dec 2019 22:32:38 +0100
Message-ID: <CAJ3okZ1+m-6AM=vs=62EE88TeTqm41vZ8KfwYQYo+MWTmxn66w@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Ricardo Wurmus <rekado@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>,
 GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Ricardo,

Thank you for your input.

On Mon, 30 Dec 2019 at 22:10, Ricardo Wurmus <rekado@HIDDEN> wrote:

> zimoun <zimon.toutoune@HIDDEN> writes:

> > What about "guix spawn"?
>
> =E2=80=9Cspawn=E2=80=9D is a very generic verb, much like =E2=80=9Center=
=E2=80=9D (enter what?) or
> =E2=80=9Cmake=E2=80=9D.

My English is not good enough to see the drawback. :-)


Well, my personal flavor is:

>    to contain (=E2=80=A6the resulting process in a possibly leaky environ=
ment)
>    to join (=E2=80=A6all these packages to form a new whole)
>    context
>    union


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 21:10:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 16:10:42 2019
Received: from localhost ([127.0.0.1]:33521 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1im2JG-0000gE-0b
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 16:10:42 -0500
Received: from sender4-of-o51.zoho.com ([136.143.188.51]:21128)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1im2JD-0000g6-Qi
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 16:10:40 -0500
ARC-Seal: i=1; a=rsa-sha256; t=1577740233; cv=none; 
 d=zohomail.com; s=zohoarc; 
 b=WfPsF/Vc0Y7McE0MRONFUTof7IzIvcI78mfB3l0URsAUB36hKMt918pFNxa8CTAPSsPsMJ00b7AFFnuqr9Hdhx3hQs7Sg2ElisbAfN9HV4qmv+9d7FxhpIsOlC9mwDEPcHmPJe8eq/xqg6ghnpDkdGD0rkxBW8+aymoMMChwN5E=
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=zohomail.com;
 s=zohoarc; t=1577740233;
 h=Content-Type:Content-Transfer-Encoding:Cc:Date:From:In-Reply-To:MIME-Version:Message-ID:References:Subject:To;
 bh=9H22+tsWU6npXGpwnTGycEnIPg5piIe2kc57gv5GVjw=; 
 b=gwEjMuoqHGONhY8EbuIFkUkbt4SNYYayy1eSur7g4OfsXK5Awm2YJpTcW52gNUQuvkDF5NDNF3Qs7ReXUqAhvcPZN8UuYGVAJ5MNDsu+t0OXUWvjGtZOknRaUg6ZNl7Y7O8r+1sVBNcTfvY5fqWU6Mrqz7ST2NaSMhIeDFJ7HF0=
ARC-Authentication-Results: i=1; mx.zohomail.com;
 dkim=pass  header.i=elephly.net;
 spf=pass  smtp.mailfrom=rekado@HIDDEN;
 dmarc=pass header.from=<rekado@HIDDEN> header.from=<rekado@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1577740233; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:Message-ID:MIME-Version:Content-Type:Content-Transfer-Encoding;
 bh=9H22+tsWU6npXGpwnTGycEnIPg5piIe2kc57gv5GVjw=;
 b=eEN/CqewBQ26ZRP98iLNr70AhSYZszFbzPb37P91QLjKNzMni9moNynjH3fXXq+6
 DHPzV59vDcpBsNk+Sda0CuwiJFTgJsukO+TyR2D5xfKTNMbtDh10opN728RpwVYZPid
 +V34xOKzbmIvGux8Y9POG9cPKDbCN8RxRq0wKtfA=
Received: from localhost (p54AD4FE0.dip0.t-ipconnect.de [84.173.79.224]) by
 mx.zohomail.com with SMTPS id 1577740227154662.0833964693969;
 Mon, 30 Dec 2019 13:10:27 -0800 (PST)
References: <87eexeu8mo.fsf@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
 <87blrqp2pp.fsf@HIDDEN> <878smu85kw.fsf@HIDDEN>
 <CAJ3okZ3jjB8kRRN3xqv7VWn0ba_Qwm8jDWUUiodXi+NtQwWsLA@HIDDEN>
 <87tv5h7t0j.fsf@HIDDEN>
 <CAJ3okZ2WVmPprrGw4xnzpRYzBeMXMPVnaTgG00=DicTaRFRMmw@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Ricardo Wurmus <rekado@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ2WVmPprrGw4xnzpRYzBeMXMPVnaTgG00=DicTaRFRMmw@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Mon, 30 Dec 2019 22:10:22 +0100
Message-ID: <87eewlo6yp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>,
 GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


zimoun <zimon.toutoune@HIDDEN> writes:

>> > Why do you say that "guix shell" does not reflect what the command is =
about?
>> > Because the command spawns a new shell with options (expanding it,
>> > isolating it, etc.)
>>
>> The command does not necessarily spawn a new shell; it spawns a command
>> in a well-defined environment, and that command might be a shell.
>
> What about "guix spawn"?

=E2=80=9Cspawn=E2=80=9D is a very generic verb, much like =E2=80=9Center=E2=
=80=9D (enter what?) or
=E2=80=9Cmake=E2=80=9D.  =E2=80=9Cshell=E2=80=9D has the awkward property o=
f meaning different things
dependent on how you interpret it: =E2=80=9Cto shell=E2=80=9D means to *rem=
ove* an outer
shell (like that of a nut) whereas =E2=80=9Cguix shell=E2=80=9D as a noun w=
ould imply
*wrapping=E2=80=9C something in a shell.  It sends mixed signals.  We=E2=80=
=99d probably
want people to understand it as =E2=80=98spawn a command line shell=E2=80=
=99, but that=E2=80=99s
really not the primary purpose of =E2=80=98guix environment=E2=80=99.

Thinking about words some more I started to wonder: do we want verbs or
nouns?  We have some sub-commands that could be interpreted either way:

   archive
   gc
   hash

Others that are primarily understood as nouns:

   container
   environment
   graph
   package
   processes
   repl
   size
   system
   time-machine
   weather

And a majority that are primarily understood as verbs:

   build
   challenge
   copy
   deploy
   describe
   download
   edit
   import
   install
   lint
   pack
   publish
   pull
   refresh
   remove
   search
   show
   upgrade

If we were looking for verbs that express the idea of creating an
environment or to place a thing inside of an environment we could use
one of these:

   to envelop (envelop what though?  This seems to require two objects.)
   to arrange (kinda misses the point)
   to stage (in the theatric sense)
   to frame (not in the criminal sense)
   to contain (=E2=80=A6the resulting process in a possibly leaky environme=
nt)
   to join (=E2=80=A6all these packages to form a new whole)
   to group (=E2=80=A6all these packages)

(As a bonus: =E2=80=98to environ=E2=80=99 exists, but it suffers from the s=
ame problem
as =E2=80=98to envelop=E2=80=99.)

Here are some nouns that might work:

   scene
   frame
   context
   union

All of them are shorter than =E2=80=9Cenvironment=E2=80=9D!  :)
What do you think?

--
Ricardo





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 17:55:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 12:55:24 2019
Received: from localhost ([127.0.0.1]:33342 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ilzGF-0006rr-P1
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 12:55:24 -0500
Received: from mail-qv1-f44.google.com ([209.85.219.44]:37796)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ilzGE-0006rf-Mr
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 12:55:23 -0500
Received: by mail-qv1-f44.google.com with SMTP id f16so12619683qvi.4
 for <38529 <at> debbugs.gnu.org>; Mon, 30 Dec 2019 09:55:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=cFVlu4OuZ+pc/sb6z/oHxe7tigX9iHpe3SVC5EBn4nU=;
 b=dr/hzoGa+nsUOwO5Vq3WwgRtT9nu6ddLGWypHCDYjIgI+LleBcAi8tGqJyUBVmZEzN
 036DhxKezoIbTWG7spsmFZhgj/uNjWbOJhM/t7r9BAfSHAihZ6o+RNZcMxoTGUEk/Ntq
 s8UfJG11UKtRxeEa+4FhJ1VrVOIEe/h6Bn82FPvgxIbSg6zmZc36Uj7p5EGlQ07iK6QX
 yec86YGDR8qtnvjzPRz0HtMO74eo27mZmfA0WLdrLi2VBzbYo3Y6urjZcjNVfcyHPhRU
 G1tKXX+da1KzoWLr/bNKk20jEXmFd+7AUcz4NWCN2CCVgxQt7JiRLfofvFWQtNYvnq7K
 o+DA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=cFVlu4OuZ+pc/sb6z/oHxe7tigX9iHpe3SVC5EBn4nU=;
 b=bowZiNkTSduTe6UTbNJGew4uC5Bn/0i2RSYPhJ2ja7WhwfRFC6Cu0ZOb/vROf6Jfpt
 Gre2ecOMuX2jWB++Y+xA3XCWJKett0/rfn16/IAQ7PwSKxhOZeUYys74qGVf3hk1skE7
 +p2PrBancN8oyf4PTfc6FdB8U2rYDHXm0prTJim9ooDQCwe+39f/7pE/PxX7dqRZwSSf
 OljBOAfAeeZxF83Af/UbuBCVqajQ99rdkZPg99dM3VRxTK+fMYIrLAnBkjfjD+P31qls
 Ev8pME8xTVIfTDPkfjoEsqE3cyVS+47+qr97CKs7hBMjeq4WhwnyLDbcTk5Wv2DZraxR
 pJYg==
X-Gm-Message-State: APjAAAULLZnOzN/e2e+2LK4suEHOzfBampLmbRi0R2t3gDj47Gy+ES68
 6Cuejhcus3cyPVfW8gfqWZwScOPvVNXSKbp7dwU=
X-Google-Smtp-Source: APXvYqxyY72FTDunij+t+kFSUDPv7tgsTtqpzdxHwo9OxZTHb0FRYgdZQivaJ4VNMAupatQW3HwE1H5qVEdXikwwOkw=
X-Received: by 2002:a05:6214:108a:: with SMTP id
 o10mr43227019qvr.246.1577728517178; 
 Mon, 30 Dec 2019 09:55:17 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
 <87blrqp2pp.fsf@HIDDEN> <878smu85kw.fsf@HIDDEN>
 <CAJ3okZ3jjB8kRRN3xqv7VWn0ba_Qwm8jDWUUiodXi+NtQwWsLA@HIDDEN>
 <87tv5h7t0j.fsf@HIDDEN>
In-Reply-To: <87tv5h7t0j.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Mon, 30 Dec 2019 18:55:04 +0100
Message-ID: <CAJ3okZ2WVmPprrGw4xnzpRYzBeMXMPVnaTgG00=DicTaRFRMmw@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hey!

On Mon, 30 Dec 2019 at 16:06, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:
> zimoun <zimon.toutoune@HIDDEN> skribis:
> > On Mon, 30 Dec 2019 at 11:35, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote=
:

> > Is this statement acted? Is it the consensus by all the maintainers?
>
> All I=E2=80=99m saying is that what EuAndreh wrote above is correct; I=E2=
=80=99m not
> stating anything as to what solution we should implement.  :-)

H=C3=A9h=C3=A9, it is an answer to the questions. ;-)


> > Why do you say that "guix shell" does not reflect what the command is a=
bout?
> > Because the command spawns a new shell with options (expanding it,
> > isolating it, etc.)
>
> The command does not necessarily spawn a new shell; it spawns a command
> in a well-defined environment, and that command might be a shell.

What about "guix spawn"?

All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 17:27:37 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 12:27:37 2019
Received: from localhost ([127.0.0.1]:33316 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ilypN-0006BS-5W
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 12:27:37 -0500
Received: from mx1.riseup.net ([198.252.153.129]:53378)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <raingloom@HIDDEN>) id 1ilypL-0006BK-36
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 12:27:35 -0500
Received: from bell.riseup.net (bell-pn.riseup.net [10.0.1.178])
 (using TLSv1 with cipher ECDHE-RSA-AES256-SHA (256/256 bits))
 (Client CN "*.riseup.net",
 Issuer "Sectigo RSA Domain Validation Secure Server CA" (not verified))
 by mx1.riseup.net (Postfix) with ESMTPS id 47mks228dLzDs7J;
 Mon, 30 Dec 2019 09:27:34 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=riseup.net; s=squak;
 t=1577726854; bh=9mPSHOzgRUnFTCS+zmImFvD2eqVujggYwgL1mQUHOMM=;
 h=Subject:From:To:Cc:Date:In-Reply-To:References:From;
 b=qQuHRPqs9zyT+d9mBv06G886cB+RMcBAhEDfhSo+EqPM5JlxjTq/VIcQC39tmsrJJ
 +gbM4aMA6IFk7ZpFyLH5jW8FeF5rJOYKbfE/EJqIF2Y1hj6vaNkQEGGuCwJVEZySiY
 bwuelwlF81uIiN8OluVqRDY2O0tEM7uPUEIn19Ds=
X-Riseup-User-ID: 10BF4D5527408382E137A1FF81D324FB3AD892B00FC08D5A62A59710F7BC6A41
Received: from [127.0.0.1] (localhost [127.0.0.1])
 by bell.riseup.net (Postfix) with ESMTPSA id 47mks06DkZzJqrk;
 Mon, 30 Dec 2019 09:27:32 -0800 (PST)
Message-ID: <0eda3cfa6b08d9e58249eac6d41df0c0af33f681.camel@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
From: raingloom <raingloom@HIDDEN>
To: Ludovic =?ISO-8859-1?Q?Court=E8s?= <ludo@HIDDEN>, "Thompson, David"
 <dthompson2@HIDDEN>
Date: Mon, 30 Dec 2019 18:27:17 +0100
In-Reply-To: <87o8wgksnp.fsf@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAJ=RwfabiMuyx_JXP+KU76kCCRAX0zofN14YJ5wEi-YMwNW_YQ@HIDDEN>
 <87o8wgksnp.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
MIME-Version: 1.0
Content-Transfer-Encoding: 8bit
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Pierre Neidhardt <mail@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Tue, 2019-12-10 at 18:16 +0100, Ludovic Courtès wrote:
> As for ‘--ad-hoc’: making it the default is technically easy.  The
> difficulty is to come up with a nice transition/deprecation mechanism
> so
> that we don’t break everyone’s script overnight.
> 
> Ideas on how to achieve it are welcome!
> 
> Thanks,
> Ludo’.
> 
> 

Why not make it fully explicit, without either being the default?
It would make script more readable too.

Then the deprecation is as easy as printing a warning when the
invocation relies on the default.

For example `guix environment hello` would become `guix environment --
inputs-of hello`. Not using `--inputs-of` would print something like
"warning: implicit --inputs-of is deprecated".





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 15:06:19 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 10:06:19 2019
Received: from localhost ([127.0.0.1]:33170 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ilwcd-0002Qu-3O
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 10:06:19 -0500
Received: from eggs.gnu.org ([209.51.188.92]:59131)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1ilwcY-0002Qd-M3
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 10:06:17 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:35306)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1ilwcR-0000Sm-RH; Mon, 30 Dec 2019 10:06:07 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=44164 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1ilwcR-00014Q-2x; Mon, 30 Dec 2019 10:06:07 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
References: <87eexeu8mo.fsf@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
 <87blrqp2pp.fsf@HIDDEN> <878smu85kw.fsf@HIDDEN>
 <CAJ3okZ3jjB8kRRN3xqv7VWn0ba_Qwm8jDWUUiodXi+NtQwWsLA@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 =?utf-8?Q?Niv=C3=B4se?= an 228 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Mon, 30 Dec 2019 16:06:04 +0100
In-Reply-To: <CAJ3okZ3jjB8kRRN3xqv7VWn0ba_Qwm8jDWUUiodXi+NtQwWsLA@HIDDEN>
 (zimoun's message of "Mon, 30 Dec 2019 13:03:19 +0100")
Message-ID: <87tv5h7t0j.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: EuAndreh <eu@HIDDEN>, GNU Guix maintainers <guix-maintainers@HIDDEN>,
 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hello!

zimoun <zimon.toutoune@HIDDEN> skribis:

> On Mon, 30 Dec 2019 at 11:35, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:
>
>> > Wouldn't having a new name for the new behaviour avoid breakage in this
>> > situation?
>>
>> Yes, that=E2=80=99s correct (that=E2=80=99s also one of the suggestions =
Konrad made).
>
> Is this statement acted? Is it the consensus by all the maintainers?

All I=E2=80=99m saying is that what EuAndreh wrote above is correct; I=E2=
=80=99m not
stating anything as to what solution we should implement.  :-)

> And I am not clear about what will happens for "guix environment"?
> Deprecate for sure.
> But after X time: removed or frozen?

I guess that=E2=80=99s the whole point of deprecation.

> As Arne described the process (bottom of [1]), "guix environment" will
> become a kind-of alias of "guix shell/<name-it>". Right?

Yes.

>> We could take that route.  What would we call it, though?  I don=E2=80=
=99t like
>> =E2=80=9Cguix shell=E2=80=9D because it doesn=E2=80=99t quite reflect wh=
at the command is
>> about.  No good idea, though.
>
> Argh! Naming is hard.
> Something that reflects what the command is about: "guix environment"?
> (joke!! ;-))

Yeah!

> Why do you say that "guix shell" does not reflect what the command is abo=
ut?
> Because the command spawns a new shell with options (expanding it,
> isolating it, etc.)

The command does not necessarily spawn a new shell; it spawns a command
in a well-defined environment, and that command might be a shell.

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 12:03:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 07:03:41 2019
Received: from localhost ([127.0.0.1]:60550 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iltlt-0002O3-Cy
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 07:03:41 -0500
Received: from mail-qk1-f196.google.com ([209.85.222.196]:41894)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iltlp-0002Np-JH
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 07:03:40 -0500
Received: by mail-qk1-f196.google.com with SMTP id x129so26082400qke.8
 for <38529 <at> debbugs.gnu.org>; Mon, 30 Dec 2019 04:03:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=u+tyL1pWgttGoM/VS80EVPx6pZl7u0Ql630EWGelgyU=;
 b=M80j5GtWBGh3K4qR4MQtl1+KR/CU7jzNcj6xVetQO6PGKF4W2vIibGzHtdpMU+Dwqk
 Dg+FhaGwQZv2aEdaV5t0xgW60pMGIlzRn/6uBMffozFvbFfjJf5uCroI+FU4dMNKFd1E
 RIsE4EIJN+HsC9jDKtKfWLsy2rAT8eD8GnkBxz7mJifpjK3K4x/e3cpeQ1SZ4di2Lmox
 GDKP6eKu9wsirS4nt/6jDfv6yRE8sbSXvOrG3Z1ff6mY1m0+YGKVuuy7d7ttimMkVdqy
 utj5zzR0TqtXlQAfFAqM4UNhd4tb65OY7HxX2kNOzewD12b4Tg8GCCluXSJN84G6/hFA
 CfIg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=u+tyL1pWgttGoM/VS80EVPx6pZl7u0Ql630EWGelgyU=;
 b=dK3HTjsxN+Siu0g1gCyqEQseVezLUiCbXAxxkAmLCH6d5ykP1zMJFIDFT5SUhHbFCi
 QAK1L3ruIwisJvl4/QxZjp1zDZ1329eU4RuwpiYlaenwkfiHDvbRfDQaFjIwVJizkrJu
 9NH+AkZTd7ePiZ7ob8oETDtVfNl44GQ0dKeuOn39LIcukGc64u/3BNCTPL7OXzCX5TMC
 O1BlKEJ1SWUC4NfPgaD4jV1nfkWYQhvx7NeOgf8DHzaIjYLSNFyYTJ0LPnPy0e9mhfml
 pW8yg2I/cD+q0gRP4P0bJITzpkrLuvetzbGSzJYPzsZVj9iWcz+2uXaaTzzMXIrgUf7q
 qCXA==
X-Gm-Message-State: APjAAAWmuVj0B+XYZ1G3+pX4IEfROIUnnnHSHMq2CeivwjMHDYEtcHgj
 Rt79Shsgyx2t+ax4wgeLACtE6hvWq9R5XF0j00k=
X-Google-Smtp-Source: APXvYqy4SFJSblwWUtdI97MQXTlmIYxZv6ZqPSZV1Hevxu/XmzpShGpLGKnkDEzaTEs3bipfyPp3pEN46ZvTqXn4cvU=
X-Received: by 2002:a05:620a:1592:: with SMTP id
 d18mr53878195qkk.80.1577707412084; 
 Mon, 30 Dec 2019 04:03:32 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
 <87blrqp2pp.fsf@HIDDEN> <878smu85kw.fsf@HIDDEN>
In-Reply-To: <878smu85kw.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Mon, 30 Dec 2019 13:03:19 +0100
Message-ID: <CAJ3okZ3jjB8kRRN3xqv7VWn0ba_Qwm8jDWUUiodXi+NtQwWsLA@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: EuAndreh <eu@HIDDEN>, GNU Guix maintainers <guix-maintainers@HIDDEN>,
 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Ludo,

On Mon, 30 Dec 2019 at 11:35, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:

> > Wouldn't having a new name for the new behaviour avoid breakage in this
> > situation?
>
> Yes, that=E2=80=99s correct (that=E2=80=99s also one of the suggestions K=
onrad made).

Is this statement acted? Is it the consensus by all the maintainers?

And I am not clear about what will happens for "guix environment"?
Deprecate for sure.
But after X time: removed or frozen?

Removing the command "guix environment" is against the backward
compatibility argument because all the current documentation/scripts
using it will not work anymore. Other said, if the
documentation/scripts cannot be updated as it was said -- in favor for
strong backward compatibility -- then the user will be surprised that
what worked does not anymore because the command does not exist
anymore.

Therefore, if Guix goes the backward compatibility route, then the
"guix environment" should be frozen until the version 2.0 and so only
removed when the 2.0 will be released. Or I misunderstand the
arguments in favor of the backward compatibility.

As Arne described the process (bottom of [1]), "guix environment" will
become a kind-of alias of "guix shell/<name-it>". Right?



> We could take that route.  What would we call it, though?  I don=E2=80=99=
t like
> =E2=80=9Cguix shell=E2=80=9D because it doesn=E2=80=99t quite reflect wha=
t the command is
> about.  No good idea, though.

Argh! Naming is hard.
Something that reflects what the command is about: "guix environment"?
(joke!! ;-))

Why do you say that "guix shell" does not reflect what the command is about=
?
Because the command spawns a new shell with options (expanding it,
isolating it, etc.)

Well, because we do not seem having good idea for a new name, maybe if
we argument why we collectively find that name or this name is bad or
good, one of us will find the good name. Currently, "guix shell" seems
the better option.


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 10:34:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 05:34:49 2019
Received: from localhost ([127.0.0.1]:60516 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ilsNt-0000BI-5o
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 05:34:49 -0500
Received: from eggs.gnu.org ([209.51.188.92]:50035)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1ilsNr-0000B1-Ms
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 05:34:48 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:33040)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1ilsNl-0002yu-Tk; Mon, 30 Dec 2019 05:34:41 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=43824 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1ilsNl-0007vL-Bp; Mon, 30 Dec 2019 05:34:41 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: EuAndreh <eu@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
 <87blrqp2pp.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 10 =?utf-8?Q?Niv=C3=B4se?= an 228 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Mon, 30 Dec 2019 11:34:39 +0100
In-Reply-To: <87blrqp2pp.fsf@HIDDEN> (EuAndreh's message of "Mon, 30 Dec
 2019 06:44:34 -0300")
Message-ID: <878smu85kw.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: Ricardo Wurmus <rekado@HIDDEN>,
 GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi,

EuAndreh <eu@HIDDEN> skribis:

> Ludovic Court=C3=A8s <ludo@HIDDEN> writes:
>
>> Yes, I think it is clear that we=E2=80=99d have to do this using all the=
 tools
>> at our disposal, including time.
>>
>> Konrad=E2=80=99s objection remains though: existing documents (papers, b=
log
>> posts, MOOCs, etc.) that mention =E2=80=98guix environment=E2=80=99 woul=
d all of a
>> sudden become wrong if we were to change the defaults of =E2=80=98guix
>> environment=E2=80=99.  Even if we introduce a variable to restore the old
>> behavior.
>>
>> Perhaps that=E2=80=99s unavoidable in the long run, but perhaps this is =
not the
>> right time for this.
>
> Wouldn't having a new name for the new behaviour avoid breakage in this
> situation?

Yes, that=E2=80=99s correct (that=E2=80=99s also one of the suggestions Kon=
rad made).

We could take that route.  What would we call it, though?  I don=E2=80=99t =
like
=E2=80=9Cguix shell=E2=80=9D because it doesn=E2=80=99t quite reflect what =
the command is
about.  No good idea, though.

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 30 Dec 2019 09:44:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 30 04:44:46 2019
Received: from localhost ([127.0.0.1]:60502 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ilrbR-0007Ry-Ey
	for submit <at> debbugs.gnu.org; Mon, 30 Dec 2019 04:44:46 -0500
Received: from box.euandre.org ([162.243.185.39]:60933)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <eu@HIDDEN>) id 1ilrbQ-0007Rn-OC
 for 38529 <at> debbugs.gnu.org; Mon, 30 Dec 2019 04:44:45 -0500
Received: from authenticated-user (box.euandre.org [162.243.185.39])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by box.euandre.org (Postfix) with ESMTPSA id 2AD8F9FB9D;
 Mon, 30 Dec 2019 07:44:37 -0200 (-02)
DKIM-Signature: v=1; a=rsa-sha256; c=simple/simple; d=euandre.org; s=mail;
 t=1577699079; bh=3LCNSl1wNT80zrxkrYkr4fPQu1jkTDUMyXpeqtHF1OA=;
 h=From:To:Cc:Cc:Subject:In-Reply-To:References:Date:From;
 b=byUKv5iP51/j4FPZBCk19gyOPlrXCKD9tcRyAcfxLuD0PTO0Jzkm3CZ8cL7VxfWYH
 s81K9RhT7T90967D856FHvSOypX4wZtk5dwT5FD2olYcv+EU4ObE6xL2J0sm/ZLYUG
 CmR7UHlQ6G4sdlPnfTzmBc5cEvou5/ipXVDlUTjO6sxU3WKgzZ920MPA6bzoLA09C4
 oup7QWasBjKf90jDBp3oHVk7BlIGPDBr4SS0TcNhlAP7e8SU9m4/Y6WQr8BoD1Ml+S
 4GuvIyI1aNNBqG1oc4akHtuwstc0F9yrrAN4feDHq/5QHVFQnd2WculhH5qJO/S/ZN
 Iu5Ai7I/03HUQ==
From: EuAndreh <eu@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>, Ricardo Wurmus
 <rekado@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-Reply-To: <87o8w1mxjt.fsf@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN> <87o8w1mxjt.fsf@HIDDEN>
Date: Mon, 30 Dec 2019 06:44:34 -0300
Message-ID: <87blrqp2pp.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 1.8 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  Hello :) Jumping in the discussion xD Ludovic Courtès <ludo@HIDDEN>
    writes: 
 
 Content analysis details:   (1.8 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
  0.0 URIBL_BLOCKED          ADMINISTRATOR NOTICE: The query to URIBL was
                             blocked.  See
                             http://wiki.apache.org/spamassassin/DnsBlocklists#dnsbl-block
                              for more information.
                             [URIs: euandre.org]
  1.8 DOS_RCVD_IP_TWICE_B    Received from the same IP twice in a row
                             (only one external relay)
 -0.0 SPF_HELO_PASS          SPF: HELO matches SPF record
 -0.0 SPF_PASS               SPF: sender matches SPF record
X-Debbugs-Envelope-To: 38529
Cc: , GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: 0.8 (/)

Hello :)

Jumping in the discussion xD

Ludovic Court=C3=A8s <ludo@HIDDEN> writes:

> Yes, I think it is clear that we=E2=80=99d have to do this using all the =
tools
> at our disposal, including time.
>
> Konrad=E2=80=99s objection remains though: existing documents (papers, bl=
og
> posts, MOOCs, etc.) that mention =E2=80=98guix environment=E2=80=99 would=
 all of a
> sudden become wrong if we were to change the defaults of =E2=80=98guix
> environment=E2=80=99.  Even if we introduce a variable to restore the old
> behavior.
>
> Perhaps that=E2=80=99s unavoidable in the long run, but perhaps this is n=
ot the
> right time for this.

Wouldn't having a new name for the new behaviour avoid breakage in this
situation?

Suppose the path of adding new subcommand is chosen, and it is "guix
shell". Couldn't it adopt the new desired behaviour?

  guix shell foo --inputs-of bar     # new command
  guix environment bar --ad-hoc foo  # untouched old command

After the introduction of "guix shell", "guix environment" could become
deprecated, but no current usage of it would stop working, and no public
references to it in the internet would become misleading. "guix
environment" could say that is has been deprecated, and point to "guix
shell", but keep working the same way.

If desired, "guix environment" could be removed after X time of
deprecation has passed, but that would be optional.

What are the downsides? Am I missing something?

Thanks,
euandreh.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 23 Dec 2019 09:28:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 23 04:28:08 2019
Received: from localhost ([127.0.0.1]:50565 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ijK0W-0006YW-IJ
	for submit <at> debbugs.gnu.org; Mon, 23 Dec 2019 04:28:08 -0500
Received: from dd26836.kasserver.com ([85.13.145.193]:58892)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dannym@HIDDEN>) id 1ijK0T-0006YN-JT
 for 38529 <at> debbugs.gnu.org; Mon, 23 Dec 2019 04:28:06 -0500
Received: from localhost (unknown [185.17.13.127])
 by dd26836.kasserver.com (Postfix) with ESMTPSA id EA5C63365203;
 Mon, 23 Dec 2019 10:28:02 +0100 (CET)
Date: Mon, 23 Dec 2019 10:28:00 +0100
From: Danny Milosavljevic <dannym@HIDDEN>
To: Ricardo Wurmus <rekado@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
Message-ID: <20191223102800.35e12fea@HIDDEN>
In-Reply-To: <87woaqpuvz.fsf@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
 <CAJ3okZ3zSS0Rbnu5eLhpYHPvSY1emaj=-estQcjRwiJ3=4RMMA@HIDDEN>
 <m1fthfz1db.fsf@HIDDEN>
 <CAJ3okZ32Ozgky=qUtj+QwjNRoX6aTzWKrMXy0M0wZpLAZRi8pg@HIDDEN>
 <87woaqpuvz.fsf@HIDDEN>
X-Mailer: Claws Mail 3.17.3 (GTK+ 2.24.32; x86_64-unknown-linux-gnu)
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="Sig_/jFdGygFgS9pdt3AOHieG5vz";
 protocol="application/pgp-signature"; micalg=pgp-sha256
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--Sig_/jFdGygFgS9pdt3AOHieG5vz
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi Ricardo,

On Fri, 20 Dec 2019 22:08:48 +0100
Ricardo Wurmus <rekado@HIDDEN> wrote:

> zimoun <zimon.toutoune@HIDDEN> writes:
>=20
> >  - I propose the name "guix shell" =20
>=20
> This is not a bad idea, especially considering that =E2=80=9Cguix environ=
ment=E2=80=9D
> was meant to get shebang support, so that you could use it as the
> interpreter in a script that handles the environment configuration.

Note that the Linux kernel shebang interpreter only supports ONE argument.
The good news is that whatever number of arguments you pass, it will all
be subsumed into the first argument.

#!foo bar baz

foo gets: $1=3D"bar baz", $#=3D2

--Sig_/jFdGygFgS9pdt3AOHieG5vz
Content-Type: application/pgp-signature
Content-Description: OpenPGP digital signature

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEds7GsXJ0tGXALbPZ5xo1VCwwuqUFAl4AiKAACgkQ5xo1VCww
uqV1gQf7Bn7WDu9gn8Y9GfN1sW1dNR3p0wQjGjGHvBeNpaZ+7iWroOz7ObRXGoT4
06YudNnN9kxulLzTc12G657YFMLq7q3BsAUX+sbYQkhYOOI5mau9NeaqaTuuI0yv
0xmorYN8NdTZ+kY5x17X8KZTGvVIw96cZMgxS+IbbxRxLC3xTxvlxMQ9y72K1A55
I4Mrz32lpmJ8GXZMPEMIm0eS14gEqNxktgL81lx2CWs8+oaftMJ6BTNSHHkBVq9i
xH49KeEORRVtyBUdQxaNGkH0YYdmPjNMskrsfusBv5KHFJIlSLSH/WaF0tZylgEM
WP55Oi+jxyjuLJ2lMFcIFrdSoQYRRA==
=mzlL
-----END PGP SIGNATURE-----

--Sig_/jFdGygFgS9pdt3AOHieG5vz--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 21 Dec 2019 16:52:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 21 11:52:03 2019
Received: from localhost ([127.0.0.1]:48715 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iihz1-00052S-6s
	for submit <at> debbugs.gnu.org; Sat, 21 Dec 2019 11:52:03 -0500
Received: from eggs.gnu.org ([209.51.188.92]:34914)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1iihyz-00051z-FV
 for 38529 <at> debbugs.gnu.org; Sat, 21 Dec 2019 11:52:01 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:59925)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1iihys-0000Y6-5w; Sat, 21 Dec 2019 11:51:54 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=60904 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1iihyr-0005VC-6A; Sat, 21 Dec 2019 11:51:53 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Ricardo Wurmus <rekado@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 1 =?utf-8?Q?Niv=C3=B4se?= an 228 de la =?utf-8?Q?R?=
 =?utf-8?Q?=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Sat, 21 Dec 2019 17:51:50 +0100
In-Reply-To: <87tv5upttv.fsf@HIDDEN> (Ricardo Wurmus's message of "Fri,
 20 Dec 2019 22:31:40 +0100")
Message-ID: <87o8w1mxjt.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: Arne Babenhauserheide <arne_bab@HIDDEN>,
 GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi!

Ricardo Wurmus <rekado@HIDDEN> skribis:

> I=E2=80=99m just chiming in here to say that feelings of frustration are =
very
> valid reasons to make or object to a change.  Guix is or can be a very
> important piece of software =E2=80=94 if it remains reliable in the toolb=
ox of
> those using it.
>
> It is difficult striking the right balance between exciting new features
> that make things possible that were previously unattainable and
> dependability through stable interfaces.
>
> The Guix command line is by far the most commonly used interface.  We
> can=E2=80=99t just claim that the Scheme API is stable (which it actually=
 isn=E2=80=99t)
> and change the user-facing CLI as we please.

Agreed.

> Personally, I think that it is fine to introduce breaking changes, but
> that for changes that are likely to have a high potential for annoyance
> and frustration there ought to be a documented way to work around them.
> Breaking changes must be communicated through version number bumps and
> accompanying announcements.

Yes, I think it is clear that we=E2=80=99d have to do this using all the to=
ols
at our disposal, including time.

Konrad=E2=80=99s objection remains though: existing documents (papers, blog
posts, MOOCs, etc.) that mention =E2=80=98guix environment=E2=80=99 would a=
ll of a
sudden become wrong if we were to change the defaults of =E2=80=98guix
environment=E2=80=99.  Even if we introduce a variable to restore the old
behavior.

Perhaps that=E2=80=99s unavoidable in the long run, but perhaps this is not=
 the
right time for this.

> While I don=E2=80=99t see how we can make it happen, I do find the idea o=
f a
> stable API whose version can be selected with an environment variable
> intriguing and worth thinking about.  If our Scheme API is as flexible
> as we claim it shouldn=E2=80=99t be too hard to interpose a configuration=
 layer
> between the core facilities and the =E2=80=9Cporcelain=E2=80=9D.

You mean a stable Scheme API, or a stable CLI?

To me, a stable CLI is definitely the goal.  As for the Scheme API, I
would distinguish core APIs, peripheral APIs (e.g., the importers), (gnu
system =E2=80=A6) APIs, and packages.  I=E2=80=99d aim for high stability f=
or core APIs,
be laxer for peripheral APIs, even laxer for the remaining.

I=E2=80=99m not sure what you mean about adding a configuration layer betwe=
en
the core facilities (the core Scheme APIs?) and the porcelain?

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 21 Dec 2019 15:18:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 21 10:18:39 2019
Received: from localhost ([127.0.0.1]:48684 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iigWd-0002pG-7Q
	for submit <at> debbugs.gnu.org; Sat, 21 Dec 2019 10:18:39 -0500
Received: from wout3-smtp.messagingengine.com ([64.147.123.19]:57941)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <konrad.hinsen@HIDDEN>) id 1iigWb-0002p3-Uw
 for 38529 <at> debbugs.gnu.org; Sat, 21 Dec 2019 10:18:38 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.west.internal (Postfix) with ESMTP id 0C414602;
 Sat, 21 Dec 2019 10:18:31 -0500 (EST)
Received: from mailfrontend1 ([10.202.2.162])
 by compute7.internal (MEProxy); Sat, 21 Dec 2019 10:18:32 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=fastmail.net; h=
 from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-type:content-transfer-encoding; s=fm2; bh=
 cqjqKgjRi6WcafmHocIdOh+JpSXIx+uWRrDVU3yQ4fA=; b=QIIea/K9xGs9lZAq
 AcvWox+DE02YQ4Y1yOptRCr/HyfMGc//uLkes+A4+f2ccdRky+JUsvh9yp9qEBLF
 E6oN/l4EYeMk3ewrkYRokApPVqWQG2gGBy0qo5h7UvupSTDuT107gfelnxPtaUSw
 oiclXKnealSZXzNctcfSrg6MFeEKu8Dt/62xWl+exlqVwbF9v2ZGM7k/rcsH/xwm
 3A3M5NEKBcNSDPJmPcf7kVxaCqGdyKha/HiZ2OFPOg4s1Dm9lX2JX6vC3qevZU55
 +QFHNxRCJhbzRqb4lXTo39rl++dIS7AUoPr6dLUk4QsRpWiF77fGaKogrl90KBXY
 lk2/fQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :date:from:in-reply-to:message-id:mime-version:references
 :subject:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm1; bh=cqjqKgjRi6WcafmHocIdOh+JpSXIx+uWRrDVU3yQ4
 fA=; b=IFCcHN6WQBpp7Jz1vmutXy95RoMOvrxF6/FrZZehI+3cw8IGm6bY3elTp
 idlmgI3qPBDpAJw7A/LGjiKmtwy/Cy0H8ivLDgCrD4ZcV/jL3/D0usHSpTqaSh8C
 eEi5YJpirjD+vgwC3FWRIAwTAOAFxQMPm45ExRMUHKccxQkACJ3dQI816zuGFRrO
 ii6hQmoHblCXchdgmmJuk40yayiXkb2//dYY+wgt6xOaD8+frNiExSOfgC8/iBun
 ZA3jIuLy2sFZYSwBdZIPukeu0Y8VbTnDi6ZOIRdkqCNJHqS4DKFDyyDg8941GFQN
 YR3T66zjPrZ2AI6mINFoS0jPyDaBg==
X-ME-Sender: <xms:xjf-XRdzDzqLrTwuUkssYtKfAfDrysvHSlPpYEFhCJNEw0PRaCwB_w>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedufedrvdduhedgjeegucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhephffvufgjfhffkfggtgfgsehtqhertddttdejnecuhfhrohhmpefmohhnrhgr
 ugcujfhinhhsvghnuceokhhonhhrrggurdhhihhnshgvnhesfhgrshhtmhgrihhlrdhnvg
 htqeenucfkphepkeeirddvgeejrdduieegrddvgeehnecurfgrrhgrmhepmhgrihhlfhhr
 ohhmpehkohhnrhgrugdrhhhinhhsvghnsehfrghsthhmrghilhdrnhgvthenucevlhhush
 htvghrufhiiigvpedt
X-ME-Proxy: <xmx:xjf-XWqiAFfgwHZ7tKdKWyM1YcIbs5mTCO87P5MWVJZhq1b94u1SYQ>
 <xmx:xjf-XX5rZnct0t61rtiAVTBAKM7DReEPyh9NO8BM38fqlpBtYPqJCw>
 <xmx:xjf-XUp8ISAfVClnG6LyNsKI5kFV14XWpEDcilIagngR17iMjKVLQw>
 <xmx:xzf-XWyObbUYsvOSW7J0lkWKv-zQwSShOs_9x1q_yI3A0hCNFqo5oA>
Received: from ordinateur-de-catherine--konrad.home
 (lfbn-idf2-1-714-245.w86-247.abo.wanadoo.fr [86.247.164.245])
 by mail.messagingengine.com (Postfix) with ESMTPA id 3054D80061;
 Sat, 21 Dec 2019 10:18:30 -0500 (EST)
From: Konrad Hinsen <konrad.hinsen@HIDDEN>
To: Ricardo Wurmus <rekado@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-Reply-To: <87v9qapuq6.fsf@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87v9qapuq6.fsf@HIDDEN>
Date: Sat, 21 Dec 2019 16:18:29 +0100
Message-ID: <m1sgldyaey.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi Ricardo,

> I wonder if we should simply bump the version number to indicate that
> this is a breaking change?

That's a possibility, but who ever looks at Guix version numbers?

> Another more difficult option would be to do what responsible API
> developers on the web do: to version their API and to make the API
> version selectable.  I don=E2=80=99t know *how* to do this elegantly, and

That's an interesting idea which would also take care of similar
situations in the future.

One way to implement this is to have executables "guix1", "guix2"
etc. Most users would then define an alias "guix" for interactive use,
but hopefully script authors would use the versioned executables.

Cheers,
  Konrad.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 21 Dec 2019 08:40:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Dec 21 03:40:27 2019
Received: from localhost ([127.0.0.1]:47599 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiaJH-00088i-GE
	for submit <at> debbugs.gnu.org; Sat, 21 Dec 2019 03:40:27 -0500
Received: from mail-ed1-f54.google.com ([209.85.208.54]:33552)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <boskovits@HIDDEN>) id 1iiaJF-00088V-QF
 for 38529 <at> debbugs.gnu.org; Sat, 21 Dec 2019 03:40:26 -0500
Received: by mail-ed1-f54.google.com with SMTP id r21so10830654edq.0
 for <38529 <at> debbugs.gnu.org>; Sat, 21 Dec 2019 00:40:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=5g2vDz/y7Zey9jewUhZYH6UL7ZHIb+4eP1hvxv491Rw=;
 b=IEpnEmqudIlBl58DERnvPBdUKKJuUltwLqEEQPyfbG5s9+PzIRyykfbveor0xg3HoH
 1f//rLSGV82oI6mWg8C1jDvaLigu70tKJIWSKMvTgDIFsL1mwCpAsyfXQGHZx8UBTgUR
 gQ/YZ0ug8NyMa+vRMMeeq0V1wq5O/kf19l5XHFHwD7nLCIXttfybKoXsil7kIyS9K2EY
 L0PGttid6RSUvfgJZmI4XF3gjtpOlhiO9nWbQSnba9Sj+TaKX6eJ31cZeztfiQwoZ858
 x3G9PMdckzrTHqv5xR4fzTamCZLzgE6Z/99WmomsFK0WMOzUchp9UM8NBZH3KDqRpfKN
 LArg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=5g2vDz/y7Zey9jewUhZYH6UL7ZHIb+4eP1hvxv491Rw=;
 b=ZyGs5Ejn0BsptSA5u0gZ24OomQQNIlyFG88tqNA6ddS7YejKV1H5PxthmNTl09K4FM
 fGv9VsRSg5XF5xnkkbBBgRN7qqGSSZvs7nmU06JnyQG3s5mZeycBhb4xqNTy2OJkqOR7
 4/KPg7ZXJNwfREyFlIyNrtjbuIsgglUi+oxsA6iiFRZ1ycAm54ZyGFCIeuA+F1TIQiVk
 5grbdXtP5B93XAmmxoDliPejvGbuJdaqrNs8n06rjQ+9A0r3UVDTDHi+OznSvO+NOPjn
 mltMWM4fO1ywk5BddEpVZNLfkVfMJw+fSNK6Hxq7hab2g9OR6xrLwPP461VWi+2Qviad
 8dAg==
X-Gm-Message-State: APjAAAUswaJo73Px6TPKjTT4zPxQscMHrNEOS4XLU8d1VIJBodUkejjI
 sonBucl1vVsmfrrW/IWC0/TGPwGa8T5edclMvQ==
X-Google-Smtp-Source: APXvYqy6Aq7G5moQntrk+c6Ihnf7gYr9ZkQSn7+/umdzESG+uXyeLNM+BEU13DpChXzhCmTjb1YG8ntKvZU/Ql7xaXY=
X-Received: by 2002:a17:906:a3d3:: with SMTP id
 ca19mr21126674ejb.136.1576917619612; 
 Sat, 21 Dec 2019 00:40:19 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87tv5upttv.fsf@HIDDEN>
In-Reply-To: <87tv5upttv.fsf@HIDDEN>
From: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Date: Sat, 21 Dec 2019 09:40:06 +0100
Message-ID: <CAE4v=pjJMc3YPft5SOeSZQAeAUsf2mnFKWiGvcSG3o_i9NV3yQ@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Ricardo Wurmus <rekado@HIDDEN>
Content-Type: multipart/alternative; boundary="0000000000008ea096059a32be93"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000008ea096059a32be93
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Ricardo Wurmus <rekado@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2019. dec.=
 20., P=C3=A9n
22:32):

>
> zimoun <zimon.toutoune@HIDDEN> writes:
>
> > Then you ask one question: "Should Guix be volatile software?" with
> > the subtitle "Software developers should avoid traumatic changes".
> > Nothing more.
> > Well, I answer you by trying to fill the gap. Note that "volatile
> > software" is the same argument than the Ludo's concern and the
> > Konrad's example. So, nothing new on the table; except you are
> > starting to throw "feelings" with the "traumatic change" words.
>
> I=E2=80=99m just chiming in here to say that feelings of frustration are =
very
> valid reasons to make or object to a change.  Guix is or can be a very
> important piece of software =E2=80=94 if it remains reliable in the toolb=
ox of
> those using it.
>
> It is difficult striking the right balance between exciting new features
> that make things possible that were previously unattainable and
> dependability through stable interfaces.
>
> The Guix command line is by far the most commonly used interface.  We
> can=E2=80=99t just claim that the Scheme API is stable (which it actually=
 isn=E2=80=99t)
> and change the user-facing CLI as we please.
>
> Personally, I think that it is fine to introduce breaking changes, but
> that for changes that are likely to have a high potential for annoyance
> and frustration there ought to be a documented way to work around them.
> Breaking changes must be communicated through version number bumps and
> accompanying announcements.
>
> While I don=E2=80=99t see how we can make it happen, I do find the idea o=
f a
> stable API whose version can be selected with an environment variable
> intriguing and worth thinking about.  If our Scheme API is as flexible
> as we claim it shouldn=E2=80=99t be too hard to interpose a configuration=
 layer
> between the core facilities and the =E2=80=9Cporcelain=E2=80=9D.
>
This is something that needs consideration. I believe that the original
ideas presented here, and what you say about having a stable api can be
easily synchronized by naming the environment variable to something like
GUIX_CLI_API_VERSION. I would propose it to be of the form 1.0.1.0, so that
the first three numbers could be the current guix  version. Havin it this
way would allow inter releas updates bumping the last number, and the
ability to easily set a new default when the major version is bumped, which
implies a breaking change anyways. From there on the question would be what
should be the default? I would say, that is should be
<current-mayor>.0.0.0. Does that make sense?  Maybe we could come up with
something simpler, like dropping the second and third number.

>
> I wonder what the other maintainers think about this.
>
> --
> Ricardo
>
>
>
>
>

--0000000000008ea096059a32be93
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"auto"><div><br><br><div class=3D"gmail_quote"><div dir=3D"ltr" =
class=3D"gmail_attr">Ricardo Wurmus &lt;<a href=3D"mailto:rekado@HIDDEN=
t">rekado@HIDDEN</a>&gt; ezt =C3=ADrta (id=C5=91pont: 2019. dec. 20., =
P=C3=A9n 22:32):<br></div><blockquote class=3D"gmail_quote" style=3D"margin=
:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:1ex"><br>
zimoun &lt;<a href=3D"mailto:zimon.toutoune@HIDDEN" target=3D"_blank" re=
l=3D"noreferrer">zimon.toutoune@HIDDEN</a>&gt; writes:<br>
<br>
&gt; Then you ask one question: &quot;Should Guix be volatile software?&quo=
t; with<br>
&gt; the subtitle &quot;Software developers should avoid traumatic changes&=
quot;.<br>
&gt; Nothing more.<br>
&gt; Well, I answer you by trying to fill the gap. Note that &quot;volatile=
<br>
&gt; software&quot; is the same argument than the Ludo&#39;s concern and th=
e<br>
&gt; Konrad&#39;s example. So, nothing new on the table; except you are<br>
&gt; starting to throw &quot;feelings&quot; with the &quot;traumatic change=
&quot; words.<br>
<br>
I=E2=80=99m just chiming in here to say that feelings of frustration are ve=
ry<br>
valid reasons to make or object to a change.=C2=A0 Guix is or can be a very=
<br>
important piece of software =E2=80=94 if it remains reliable in the toolbox=
 of<br>
those using it.<br>
<br>
It is difficult striking the right balance between exciting new features<br=
>
that make things possible that were previously unattainable and<br>
dependability through stable interfaces.<br>
<br>
The Guix command line is by far the most commonly used interface.=C2=A0 We<=
br>
can=E2=80=99t just claim that the Scheme API is stable (which it actually i=
sn=E2=80=99t)<br>
and change the user-facing CLI as we please.<br>
<br>
Personally, I think that it is fine to introduce breaking changes, but<br>
that for changes that are likely to have a high potential for annoyance<br>
and frustration there ought to be a documented way to work around them.<br>
Breaking changes must be communicated through version number bumps and<br>
accompanying announcements.<br>
<br>
While I don=E2=80=99t see how we can make it happen, I do find the idea of =
a<br>
stable API whose version can be selected with an environment variable<br>
intriguing and worth thinking about.=C2=A0 If our Scheme API is as flexible=
<br>
as we claim it shouldn=E2=80=99t be too hard to interpose a configuration l=
ayer<br>
between the core facilities and the =E2=80=9Cporcelain=E2=80=9D.<br></block=
quote></div></div><div dir=3D"auto">This is something that needs considerat=
ion. I believe that the original ideas presented here, and what you say abo=
ut having a stable api can be easily synchronized by naming the environment=
 variable to something like GUIX_CLI_API_VERSION. I would propose it to be =
of the form 1.0.1.0, so that the first three numbers could be the current g=
uix=C2=A0 version. Havin it this way would allow inter releas updates bumpi=
ng the last number, and the ability to easily set a new default when the ma=
jor version is bumped, which implies a breaking change anyways. From there =
on the question would be what should be the default? I would say, that is s=
hould be &lt;current-mayor&gt;.0.0.0. Does that make sense?=C2=A0 Maybe we =
could come up with something simpler, like dropping the second and third nu=
mber.</div><div dir=3D"auto"><div class=3D"gmail_quote"><blockquote class=
=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padd=
ing-left:1ex">
<br>
I wonder what the other maintainers think about this.<br>
<br>
--<br>
Ricardo<br>
<br>
<br>
<br>
<br>
</blockquote></div></div></div>

--0000000000008ea096059a32be93--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 21 Dec 2019 00:04:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 19:04:28 2019
Received: from localhost ([127.0.0.1]:47391 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiSFw-0004Nr-2l
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 19:04:28 -0500
Received: from mail-qv1-f46.google.com ([209.85.219.46]:40153)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiSFt-0004NS-EM
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 19:04:25 -0500
Received: by mail-qv1-f46.google.com with SMTP id dp13so4300111qvb.7
 for <38529 <at> debbugs.gnu.org>; Fri, 20 Dec 2019 16:04:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=mOJei5sqyWjn2RA1IAd8W670d/HUHNLbjux6tMRFHtY=;
 b=UPj1hgpsLwLk+j/eQ802P6lxLR4cOIb5CuVJGDy0VjkSqJ8pBehdI/fhmAAHaOi42O
 Wuv2G9ioX64UiJhglEW1ny41cIj0gok6YhZTbk7qYTwN2X8bA2x0MMCJCeA87AjPLbmQ
 9oJb9U2AjTnDlYZhvbWz5YAkCpP2DEzwEduQr/CRUg7mPHssRiq6HKaDhWZAtgEJA/RI
 XmsQBdjgTDur1r5Ch5o7992boT0Ors6VnrZ021revkrOTabeKU/SEy3xZT83I/47N+ZS
 FJTfKuXbAPXR1m22y/WhyTpWpqsZ1gZganRBGbNnO6AyOaeYQ+3WYHuVNDyDF0q/Hghf
 tdJw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=mOJei5sqyWjn2RA1IAd8W670d/HUHNLbjux6tMRFHtY=;
 b=LWdM0GUQDmaG1xwABfm/IHdpFoQxEloSkPZ41zXShJ2r5Hd1BdOT4+QmyjWKpN96wY
 smL0rTUO+pNIopG3vACwVJDBVzNWVLhjnO6ANnoQwVxynVbp0dIeaTHdaGrV7HvSr7Kf
 kq9XmSWF5Z0g4h7ilQ+UWfYhhOyw1I2uFqQbio0RnZdNyx8I1e6YOwyQSeQH0qnCWF3V
 7DPvrvDEKNQZM2iC6S9V5zXdme2mgTMYwhMpJi/aNE6Z3TPKE6YOLBNTnBc+m1kbOKYr
 fM4IahC160WbFVyO9+b1aBxzxsHz+dgySsmlyNRBCCj4rX8FJy5xxCtQfEqjmTM0Bu73
 dOOw==
X-Gm-Message-State: APjAAAXVjh793cB2XQuaZ5etWWhEsc91FhFWJkxhqW+k7CyEdBusUHlm
 edM7UL4qRrjNenqeNx2aAkgseuGo8mywTgOSXwI=
X-Google-Smtp-Source: APXvYqwquSsN4yEWdShvXOx1rDqYnsSImw2/LcWVRSYlXj14CvdNeKICAcZgAeJiu5RJy8HQc77h3jr5foBYHdgyaNQ=
X-Received: by 2002:a05:6214:108a:: with SMTP id
 o10mr6961264qvr.246.1576886659829; 
 Fri, 20 Dec 2019 16:04:19 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87o8w2iorn.fsf@HIDDEN>
In-Reply-To: <87o8w2iorn.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Sat, 21 Dec 2019 01:04:08 +0100
Message-ID: <CAJ3okZ071vtMPF_xsdg6wPkP7KUqE9szrDDc8_s0EVg_BDPJzA@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Arne,

First, do not take me wrong, I am not "fighting" or not going to an
"heated debate".
I am fine and I hope you are also fine.
As I said my opinion in other emails, I am not repeating here. Well, I
am not convinced it is the good one, but as I trust collective power,
I am sure Guix will find the best consensus. I am even calling since
the very beginning of this discussion to collect opinions from the
other fellow hackers.


Expressing the feelings is better than bitterness. Therefore I express
mines. :-)
I could send that privately because I am not sure it deserves to be
public. But let wash the laundry in family (translation from French
expression ;-))


On Sat, 21 Dec 2019 at 00:02, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> > Konrad's example. So, nothing new on the table; except you are
> > starting to throw "feelings" with the "traumatic change" words.
>
> I do not see this as feelings, but as strategy. That=E2=80=99s what the a=
rticle
> is about: Many small breakages add up, and repeated changes to
> best-practices also add up.

Just to be on the same wavelength, traumatic means in the Collins
Dictionnary: "A 'traumatic' experience is very shocking and upsetting,
and may cause psychological damage."

https://www.collinsdictionary.com/dictionary/english/traumatic

Well, to me it could make sense in the context of the mentioned blog.
Even if I feel this very opinionated. Not to say it could hurt me; bah
I am a big boy, that's ok.

Again, to be on the same wavelength, the blog says: "The result has
been hugely divisive and intimately familiar to anyone who works with
Python, creating massive rifts in the community and wasting millions
of hours of engineer time addressing. This kind of =E2=80=9Cstrong=E2=80=9D=
 trauma is
fairly easy to spot in advance."

Well, I understand when speaking about Python. Are we comparing the
number of Guix users with the number of Python users? Are we comparing
the number of changes between Python 2 and 3 with the change of the
default "guix environment foo"? And not all the "guix environment"
behaviour, only a specific case.

Ok, maybe we are talking about the other trauma. The blog explains:
"Since nothing has actually broken with this change, the effects are
more subtle than with strong traumatic changes." and then "The
opportunity to solve this problem by rewriting with asyncio in mind,
however, also presents me a chance to rewrite in anything else, and
reevaluate my choice of Python for the project entirely."

I am sorry, I do not understand. I am probably too dumb. On one hand,
the issue of "guix environment" is the very backward compatibility so
are we really talking about this second "trauma"? On the other hand,
because "guix environment" will be better and users probably need to
rethink how they use Guix, then they will fully drop Guix.


Maybe "feelings" (quoting, in citation quoted too) is not the right
word. My point is all is vague. Example: I have the feeling that my
students(*) do not like Scheme; do I need to switch next year to
another language? Then do I make my decision based on my feelings?
based on the feelings of the students who are retaking the year (could
be shocked)? Me, I will make my decision based on: how many students
failed? what do they understand? what could be better for all the
students? what could be a better language? what is the ratio between
the new student vs the retaking ones? how many length the Scheme
textbook is? etc. Well, analogy is just analogy.


Well, that's it. I expressed what it appears to me a trail going
nowhere. Let move forward and put energy in "backward compatibility"
discussion: does Guix want? what does it imply? which level? etc. for
example, your interesting input "GUIX_ENVIRONMENT_STABLE=3D1".

All the best,
simon

(*) hypothetical, I do not have real students, even if I teach a bit.
And we use Python as introduction to implemented algorithms after 1
year fighting to switch from C. Whatever! :-)




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 21 Dec 2019 00:04:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 19:04:25 2019
Received: from localhost ([127.0.0.1]:47388 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiSFs-0004Nc-Nl
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 19:04:25 -0500
Received: from lists.gnu.org ([209.51.188.17]:39602)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiSFr-0004NV-Sj
 for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 19:04:24 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:44885)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiSFq-00082i-95
 for bug-guix@HIDDEN; Fri, 20 Dec 2019 19:04:23 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiSFo-0006XS-RT
 for bug-guix@HIDDEN; Fri, 20 Dec 2019 19:04:22 -0500
Received: from mail-qv1-xf29.google.com ([2607:f8b0:4864:20::f29]:36351)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <zimon.toutoune@HIDDEN>)
 id 1iiSFo-0006UY-LH; Fri, 20 Dec 2019 19:04:20 -0500
Received: by mail-qv1-xf29.google.com with SMTP id m14so4302899qvl.3;
 Fri, 20 Dec 2019 16:04:20 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=mOJei5sqyWjn2RA1IAd8W670d/HUHNLbjux6tMRFHtY=;
 b=UPj1hgpsLwLk+j/eQ802P6lxLR4cOIb5CuVJGDy0VjkSqJ8pBehdI/fhmAAHaOi42O
 Wuv2G9ioX64UiJhglEW1ny41cIj0gok6YhZTbk7qYTwN2X8bA2x0MMCJCeA87AjPLbmQ
 9oJb9U2AjTnDlYZhvbWz5YAkCpP2DEzwEduQr/CRUg7mPHssRiq6HKaDhWZAtgEJA/RI
 XmsQBdjgTDur1r5Ch5o7992boT0Ors6VnrZ021revkrOTabeKU/SEy3xZT83I/47N+ZS
 FJTfKuXbAPXR1m22y/WhyTpWpqsZ1gZganRBGbNnO6AyOaeYQ+3WYHuVNDyDF0q/Hghf
 tdJw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=mOJei5sqyWjn2RA1IAd8W670d/HUHNLbjux6tMRFHtY=;
 b=Zpg/WcaOESNFQbQ7vONnlGRdlaOo/XI8OAwQxy7XNaJGk1ruLZbzM9wqDkVjuqE4UP
 WgZLUdyEJTVGDC/0StIqYz6q/0RzSE1gkwJKY8/nkwlbVo51B3AwEIf6CBausACnN7ZP
 xIBxWn/A8nnUf+bvf7A8xRmfOvs2ZhMKUvZ4Dgd4J4j4tk6oz+4SkUUNRUQLqqTydZPR
 kxytwCUd7shwpCRasMpR6v3t5q+BC1gvZxAnvy5h21yqpKIuWIojAAezHaMEZik4HTrA
 wkajZXzannfq6rNgLzr2TJG9BmUavr9xT3slLdUynTRiOLPXWORN82kDtV0bHbdzA2hy
 b+8w==
X-Gm-Message-State: APjAAAV7Q44tiJbVLihLLYKUWVXoAAzD0OnaeYiyFBs5FHjIo//LRJTg
 krqYD1bSj+jFRNmvkOmTfKKA9+M2pv5ZAhcMVds=
X-Google-Smtp-Source: APXvYqwquSsN4yEWdShvXOx1rDqYnsSImw2/LcWVRSYlXj14CvdNeKICAcZgAeJiu5RJy8HQc77h3jr5foBYHdgyaNQ=
X-Received: by 2002:a05:6214:108a:: with SMTP id
 o10mr6961264qvr.246.1576886659829; 
 Fri, 20 Dec 2019 16:04:19 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
 <87o8w2iorn.fsf@HIDDEN>
In-Reply-To: <87o8w2iorn.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Sat, 21 Dec 2019 01:04:08 +0100
Message-ID: <CAJ3okZ071vtMPF_xsdg6wPkP7KUqE9szrDDc8_s0EVg_BDPJzA@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2607:f8b0:4864:20::f29
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi Arne,

First, do not take me wrong, I am not "fighting" or not going to an
"heated debate".
I am fine and I hope you are also fine.
As I said my opinion in other emails, I am not repeating here. Well, I
am not convinced it is the good one, but as I trust collective power,
I am sure Guix will find the best consensus. I am even calling since
the very beginning of this discussion to collect opinions from the
other fellow hackers.


Expressing the feelings is better than bitterness. Therefore I express
mines. :-)
I could send that privately because I am not sure it deserves to be
public. But let wash the laundry in family (translation from French
expression ;-))


On Sat, 21 Dec 2019 at 00:02, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> > Konrad's example. So, nothing new on the table; except you are
> > starting to throw "feelings" with the "traumatic change" words.
>
> I do not see this as feelings, but as strategy. That=E2=80=99s what the a=
rticle
> is about: Many small breakages add up, and repeated changes to
> best-practices also add up.

Just to be on the same wavelength, traumatic means in the Collins
Dictionnary: "A 'traumatic' experience is very shocking and upsetting,
and may cause psychological damage."

https://www.collinsdictionary.com/dictionary/english/traumatic

Well, to me it could make sense in the context of the mentioned blog.
Even if I feel this very opinionated. Not to say it could hurt me; bah
I am a big boy, that's ok.

Again, to be on the same wavelength, the blog says: "The result has
been hugely divisive and intimately familiar to anyone who works with
Python, creating massive rifts in the community and wasting millions
of hours of engineer time addressing. This kind of =E2=80=9Cstrong=E2=80=9D=
 trauma is
fairly easy to spot in advance."

Well, I understand when speaking about Python. Are we comparing the
number of Guix users with the number of Python users? Are we comparing
the number of changes between Python 2 and 3 with the change of the
default "guix environment foo"? And not all the "guix environment"
behaviour, only a specific case.

Ok, maybe we are talking about the other trauma. The blog explains:
"Since nothing has actually broken with this change, the effects are
more subtle than with strong traumatic changes." and then "The
opportunity to solve this problem by rewriting with asyncio in mind,
however, also presents me a chance to rewrite in anything else, and
reevaluate my choice of Python for the project entirely."

I am sorry, I do not understand. I am probably too dumb. On one hand,
the issue of "guix environment" is the very backward compatibility so
are we really talking about this second "trauma"? On the other hand,
because "guix environment" will be better and users probably need to
rethink how they use Guix, then they will fully drop Guix.


Maybe "feelings" (quoting, in citation quoted too) is not the right
word. My point is all is vague. Example: I have the feeling that my
students(*) do not like Scheme; do I need to switch next year to
another language? Then do I make my decision based on my feelings?
based on the feelings of the students who are retaking the year (could
be shocked)? Me, I will make my decision based on: how many students
failed? what do they understand? what could be better for all the
students? what could be a better language? what is the ratio between
the new student vs the retaking ones? how many length the Scheme
textbook is? etc. Well, analogy is just analogy.


Well, that's it. I expressed what it appears to me a trail going
nowhere. Let move forward and put energy in "backward compatibility"
discussion: does Guix want? what does it imply? which level? etc. for
example, your interesting input "GUIX_ENVIRONMENT_STABLE=3D1".

All the best,
simon

(*) hypothetical, I do not have real students, even if I teach a bit.
And we use Python as introduction to implemented algorithms after 1
year fighting to switch from C. Whatever! :-)




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 23:03:07 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 18:03:07 2019
Received: from localhost ([127.0.0.1]:47378 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiRIY-0002zL-Qc
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 18:03:06 -0500
Received: from mout.web.de ([212.227.15.3]:58447)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1iiRIW-0002yr-UR
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 18:03:05 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576882977;
 bh=++AqDfMCae+Kta705GY7rrjVhp3ppl+0STYRVdwh4ds=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=iY2Q7NmDXebpd3HtmxGKIQNxjjGeF/E/F+23VO2iDkZJqL0oHIvSF3sAQPyJnEOp+
 SF6IKxDzDwzaIP6I9xMLLF1gE5ATkZCZnYbFxrCUJdxx2h8WMlG3BXdTPOVWrrJAxM
 9IqbYiJvhW2dSzzyMzlaurEl+Z2WMHnXLc5LSM24=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb002
 [213.165.67.108]) with ESMTPSA (Nemesis) id 0MaJgG-1iOa411Tr6-00Js7a; Sat, 21
 Dec 2019 00:02:57 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
Date: Sat, 21 Dec 2019 00:02:52 +0100
Message-ID: <87o8w2iorn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:iHIdTrfVYk7LacFuYcrAHQMwpTHYy+OxhtFnv5H4bKwMWUdB1MV
 Ff7zoVk87Sqn4LLjKwNCnqlbZf5dsg8IQd/KB024L6oZtACasegqK4OHgg5m8FT5MYTbQIP
 J4p0uMyN2QvG+kfCp88vVoGWN6HtSZFgz51msSuXCVrMVH2dAaUVv03gj7aOzLKtCqFmbIy
 CtLlF5gDEV/CqGDyILxuw==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:jFuwJhzV8Eo=:rEzzOwohA3ITydmtH3zk6s
 TVtuoKSMiPLQK5lOuCt4tbcv8E3KpcOHignUx1Do5i1Hn9nusrYFjkSFULHnXIsMM5WTwcoe8
 SSeHCxroJhIkRcwl+LW1rJHTSTl+4c/Al6ErCR0M2G0mEOQuBegRqOITSDZmfroxhimCkcmnC
 Ru2rF1z85Ol8P+aeCIRlCivNPg6Qq7jdCtZbTIEu/1U/bM1mgqF6BjD43h4nHzk9kC7u0ARrg
 IfDoKTGRQ7t7XEL0ut+ktcb6x+9TzklUK1iuRX/M+DocjIFRDf3HAWTSejkvXxgoiG6CLJBBy
 zZxeB0nJEps4oVTJqDuhlPiKbh+vz7LoiWi7y4P1/DSssxrRzgQyG/HWjUd28pCkKO9DlX0lZ
 ZsQ3f3x4jrIKUEw/gPdO9gN4UUiUhDvitXLYNNzTqyF77ZRFgo/Sv+Lc5pvP8l6jejk73sJFi
 l1vqd8b1/A2nVs2xLx96JRh2PPF41QqiRovCmJtTx0g3q9Y6xiI4mONBLX9o5HOhuq7XjEDVW
 7RLhjqnvnBLyEiYmc9+WhR0gyyY9kJrA/YLskCxwR11bABVLEKm1rUYvu39z4PZmJhaQamBfz
 hZPU3Kxn3rJfm1lUoWNm9NBBug37umMVwBt6t9Rf3R2nZvfEvTzlKVH9GihBPJo+X0bsT88Us
 ZL/XPouczXvVt42OgTJ6lV6Ze94COzvURuWUb9wsHg5EJx8VC31AFWufkuf+1IElBmEmAT0CF
 mFdjsYdo6QLMlH9wHXf9ViPhRvpVEdhz9597xYXP81j8XxTWPHJsxSQ4lIz2M2JGRKkYSOrnH
 vS9NsDB1C4j8N/LrrxeV6PJwseovhFpfLT1QHpFrdH/+5oNt2zyb4xkIXbeslDbyfs5T4gBc9
 hZFpXD72aBmecmuGwTViqmcOqqqEe59qJsC2w+boScPzDxGLBUNetl3s0Lxj9tKTo7iRvm+07
 CTc0zETjG4lykIFHdZuFtk4m1LW3jx6wnEWOlWCS6M8rrKfwOxUZ26yWIbXpKrfKbNoXSuS1p
 gDxe/0XMEc+sDQ6TPYs8A5GTc2xOFnmAERJ2htprn53Om9ttPnKnwZF1bTDAXy7Ku5ApcvbL7
 vEcGFCYWTyviYhQD8jWFuYbmGFhEp4xfj1S2PnV1DB20LoiTqhkG7ZDcXOW71buzSyXxQWuuI
 S4OkqPqYkgPFwpeiRoLSN+9VJWm86UUVsa7jiet6bs7A9zn4baRHfXIeRhlqNrT3D5Gyualjc
 oxI6gE2qgJxHTyA8MZDpC6R56M7l8/Z9l2RGeVA==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi zimoun,

zimoun <zimon.toutoune@HIDDEN> writes:
> Konrad's example. So, nothing new on the table; except you are
> starting to throw "feelings" with the "traumatic change" words.

I do not see this as feelings, but as strategy. That=E2=80=99s what the art=
icle
is about: Many small breakages add up, and repeated changes to
best-practices also add up.

The volatile software article describes that software differs in how
much work it is to keep using it. The traumatic change article discusses
one aspect why people stop using projects.

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl39Ux8ACgkQE++NRSQD
w+vYUhAAklXBpD4PXyigANFXMLGMqdMC3eQYrD5QO5hKDTvhlEDefIrSCsRbq/ti
5boMWnIcUli5Gks4QdQ2DMrePmRKbyK8z/uL7BNOz6BlVIIKgwcwypfbzXZCV7Mj
O5dZPqPA5hM0hwRABhEkQsz5/hjX5UoW4Uy2jLh7+EfGg0ITCv+5mUaWFbPQwyWh
vbRm3NWMTt/FIbeOwaHMLmBiCrB4vzRTb6GsZ+tPbAKoEq7csqMOZ0leMzjWclPm
gnFZtX9kQeeDOevKVAQ7jJHzkypygE9wycJ7ZIK9rRVr90/biekwGRzDWlvjwxrY
3VxzF8a9RDGRM0t3hRVe4GF9Ngf9TmX5LDoEY/EmIj1V+ZTZYhYi1fRDD5AGNz8L
PapgE6SDQVYaVnoxX1HROt2I0VLEjbZqHzhj2iVC0gU5cCpfHanVDFKtkARiYiej
U6B1S/JHOzPhA7d9rzxghAC+5zACNYmHLYASCY+5TfIC5Xcin+2wGXXmTiJHZgMg
r6ZSsc8sBaQ3FrnIX00MLVa2JxeWPznK7RyuyBzwKEn6zYK7VjnKBS61tLYnj5tb
jo+Np/SbT/4f30LC9P9rUzLXQzmqwFsviFWOiDcAOHf+75k2LjO3/h3nz25RuILn
i0Ub7Nd5dKIPp+eoBxtJch6AMIFYa8vgThHxy2zIbAt7a2DGaWKIswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd/VMfAAoJENzPDbMLwQVIM64EAIFu1nUh
vkoVT7CR6fMYGl76dwqrNi5TkhO9kX6mXZfhkgcnW+O6+2lWCjGCuSIICSFE5/uZ
UjzZv8J2RyhwgP6s3mQ/fckTvS03vt94ESnnmBuhnT2huTXlKu6nyJX1lUN/fAQn
5K1Fc9ZkWzyWbCspwJZWkRGTMQFBtkhJ+pCc
=CGQ6
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Dec 2019 23:03:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 18:03:15 2019
Received: from localhost ([127.0.0.1]:47381 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiRIh-0002zg-0z
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 18:03:15 -0500
Received: from lists.gnu.org ([209.51.188.17]:55228)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1iiRIe-0002zY-NC
 for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 18:03:12 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:33973)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <arne_bab@HIDDEN>) id 1iiRId-0002cV-LF
 for bug-guix@HIDDEN; Fri, 20 Dec 2019 18:03:12 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RCVD_IN_DNSWL_NONE autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <arne_bab@HIDDEN>) id 1iiRIc-0003Zx-O2
 for bug-guix@HIDDEN; Fri, 20 Dec 2019 18:03:11 -0500
Received: from mout.web.de ([212.227.15.3]:55601)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <arne_bab@HIDDEN>)
 id 1iiRIa-0003Dh-26; Fri, 20 Dec 2019 18:03:08 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576882977;
 bh=++AqDfMCae+Kta705GY7rrjVhp3ppl+0STYRVdwh4ds=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=iY2Q7NmDXebpd3HtmxGKIQNxjjGeF/E/F+23VO2iDkZJqL0oHIvSF3sAQPyJnEOp+
 SF6IKxDzDwzaIP6I9xMLLF1gE5ATkZCZnYbFxrCUJdxx2h8WMlG3BXdTPOVWrrJAxM
 9IqbYiJvhW2dSzzyMzlaurEl+Z2WMHnXLc5LSM24=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb002
 [213.165.67.108]) with ESMTPSA (Nemesis) id 0MaJgG-1iOa411Tr6-00Js7a; Sat, 21
 Dec 2019 00:02:57 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
Date: Sat, 21 Dec 2019 00:02:52 +0100
Message-ID: <87o8w2iorn.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:iHIdTrfVYk7LacFuYcrAHQMwpTHYy+OxhtFnv5H4bKwMWUdB1MV
 Ff7zoVk87Sqn4LLjKwNCnqlbZf5dsg8IQd/KB024L6oZtACasegqK4OHgg5m8FT5MYTbQIP
 J4p0uMyN2QvG+kfCp88vVoGWN6HtSZFgz51msSuXCVrMVH2dAaUVv03gj7aOzLKtCqFmbIy
 CtLlF5gDEV/CqGDyILxuw==
X-UI-Out-Filterresults: notjunk:1;V03:K0:jFuwJhzV8Eo=:rEzzOwohA3ITydmtH3zk6s
 TVtuoKSMiPLQK5lOuCt4tbcv8E3KpcOHignUx1Do5i1Hn9nusrYFjkSFULHnXIsMM5WTwcoe8
 SSeHCxroJhIkRcwl+LW1rJHTSTl+4c/Al6ErCR0M2G0mEOQuBegRqOITSDZmfroxhimCkcmnC
 Ru2rF1z85Ol8P+aeCIRlCivNPg6Qq7jdCtZbTIEu/1U/bM1mgqF6BjD43h4nHzk9kC7u0ARrg
 IfDoKTGRQ7t7XEL0ut+ktcb6x+9TzklUK1iuRX/M+DocjIFRDf3HAWTSejkvXxgoiG6CLJBBy
 zZxeB0nJEps4oVTJqDuhlPiKbh+vz7LoiWi7y4P1/DSssxrRzgQyG/HWjUd28pCkKO9DlX0lZ
 ZsQ3f3x4jrIKUEw/gPdO9gN4UUiUhDvitXLYNNzTqyF77ZRFgo/Sv+Lc5pvP8l6jejk73sJFi
 l1vqd8b1/A2nVs2xLx96JRh2PPF41QqiRovCmJtTx0g3q9Y6xiI4mONBLX9o5HOhuq7XjEDVW
 7RLhjqnvnBLyEiYmc9+WhR0gyyY9kJrA/YLskCxwR11bABVLEKm1rUYvu39z4PZmJhaQamBfz
 hZPU3Kxn3rJfm1lUoWNm9NBBug37umMVwBt6t9Rf3R2nZvfEvTzlKVH9GihBPJo+X0bsT88Us
 ZL/XPouczXvVt42OgTJ6lV6Ze94COzvURuWUb9wsHg5EJx8VC31AFWufkuf+1IElBmEmAT0CF
 mFdjsYdo6QLMlH9wHXf9ViPhRvpVEdhz9597xYXP81j8XxTWPHJsxSQ4lIz2M2JGRKkYSOrnH
 vS9NsDB1C4j8N/LrrxeV6PJwseovhFpfLT1QHpFrdH/+5oNt2zyb4xkIXbeslDbyfs5T4gBc9
 hZFpXD72aBmecmuGwTViqmcOqqqEe59qJsC2w+boScPzDxGLBUNetl3s0Lxj9tKTo7iRvm+07
 CTc0zETjG4lykIFHdZuFtk4m1LW3jx6wnEWOlWCS6M8rrKfwOxUZ26yWIbXpKrfKbNoXSuS1p
 gDxe/0XMEc+sDQ6TPYs8A5GTc2xOFnmAERJ2htprn53Om9ttPnKnwZF1bTDAXy7Ku5ApcvbL7
 vEcGFCYWTyviYhQD8jWFuYbmGFhEp4xfj1S2PnV1DB20LoiTqhkG7ZDcXOW71buzSyXxQWuuI
 S4OkqPqYkgPFwpeiRoLSN+9VJWm86UUVsa7jiet6bs7A9zn4baRHfXIeRhlqNrT3D5Gyualjc
 oxI6gE2qgJxHTyA8MZDpC6R56M7l8/Z9l2RGeVA==
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 212.227.15.3
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi zimoun,

zimoun <zimon.toutoune@HIDDEN> writes:
> Konrad's example. So, nothing new on the table; except you are
> starting to throw "feelings" with the "traumatic change" words.

I do not see this as feelings, but as strategy. That=E2=80=99s what the art=
icle
is about: Many small breakages add up, and repeated changes to
best-practices also add up.

The volatile software article describes that software differs in how
much work it is to keep using it. The traumatic change article discusses
one aspect why people stop using projects.

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl39Ux8ACgkQE++NRSQD
w+vYUhAAklXBpD4PXyigANFXMLGMqdMC3eQYrD5QO5hKDTvhlEDefIrSCsRbq/ti
5boMWnIcUli5Gks4QdQ2DMrePmRKbyK8z/uL7BNOz6BlVIIKgwcwypfbzXZCV7Mj
O5dZPqPA5hM0hwRABhEkQsz5/hjX5UoW4Uy2jLh7+EfGg0ITCv+5mUaWFbPQwyWh
vbRm3NWMTt/FIbeOwaHMLmBiCrB4vzRTb6GsZ+tPbAKoEq7csqMOZ0leMzjWclPm
gnFZtX9kQeeDOevKVAQ7jJHzkypygE9wycJ7ZIK9rRVr90/biekwGRzDWlvjwxrY
3VxzF8a9RDGRM0t3hRVe4GF9Ngf9TmX5LDoEY/EmIj1V+ZTZYhYi1fRDD5AGNz8L
PapgE6SDQVYaVnoxX1HROt2I0VLEjbZqHzhj2iVC0gU5cCpfHanVDFKtkARiYiej
U6B1S/JHOzPhA7d9rzxghAC+5zACNYmHLYASCY+5TfIC5Xcin+2wGXXmTiJHZgMg
r6ZSsc8sBaQ3FrnIX00MLVa2JxeWPznK7RyuyBzwKEn6zYK7VjnKBS61tLYnj5tb
jo+Np/SbT/4f30LC9P9rUzLXQzmqwFsviFWOiDcAOHf+75k2LjO3/h3nz25RuILn
i0Ub7Nd5dKIPp+eoBxtJch6AMIFYa8vgThHxy2zIbAt7a2DGaWKIswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd/VMfAAoJENzPDbMLwQVIM64EAIFu1nUh
vkoVT7CR6fMYGl76dwqrNi5TkhO9kX6mXZfhkgcnW+O6+2lWCjGCuSIICSFE5/uZ
UjzZv8J2RyhwgP6s3mQ/fckTvS03vt94ESnnmBuhnT2huTXlKu6nyJX1lUN/fAQn
5K1Fc9ZkWzyWbCspwJZWkRGTMQFBtkhJ+pCc
=CGQ6
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 21:31:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 16:31:52 2019
Received: from localhost ([127.0.0.1]:47317 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiPsF-0000es-S1
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 16:31:52 -0500
Received: from sender4-of-o51.zoho.com ([136.143.188.51]:21127)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1iiPsE-0000ek-47
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 16:31:50 -0500
ARC-Seal: i=1; a=rsa-sha256; t=1576877506; cv=none; 
 d=zohomail.com; s=zohoarc; 
 b=cQQ9JZDO+D1yQX7007qdPHNoGtjkvxb5YAa+exUs8RBhnYzMih8EcWtGOwusuc1PhoBloVoAWnysCVz1lONZ0vaDbq19Ptr6AcbnYzXsHB8d+3TZOohDPGD4r1hzhiDLJEHf04nDUfL4gPKBy3KcVFsppzSXZAz8Hq0JFtG9zC0=
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=zohomail.com;
 s=zohoarc; t=1576877506;
 h=Content-Type:Content-Transfer-Encoding:Cc:Date:From:In-Reply-To:MIME-Version:Message-ID:References:Subject:To;
 bh=z+GfV3W7oMEWSxKk3uWfH2yMs+t/byTdWoVgSU/X1qc=; 
 b=OLFCHUNNVsBjSX2oTRccnH0teXFCOA6dsOFNxlUPvXjrIA7naQnT09PLVoNT4qkS20ifp1KTjOAWfa1Nb/4yjYToWBNRGV4eWSFGqi2z3eIdgXzfLxZplhJQr61/iS52npY2znzGi1I3RWSZiHFK0VByTsZc/RM9SqO1rLTHAfM=
ARC-Authentication-Results: i=1; mx.zohomail.com;
 dkim=pass  header.i=elephly.net;
 spf=pass  smtp.mailfrom=rekado@HIDDEN;
 dmarc=pass header.from=<rekado@HIDDEN> header.from=<rekado@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1576877506; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:Message-ID:MIME-Version:Content-Type:Content-Transfer-Encoding;
 bh=z+GfV3W7oMEWSxKk3uWfH2yMs+t/byTdWoVgSU/X1qc=;
 b=TP32gBcpq4DDSJDyY3wwvgxHlJCQh0ihXaWK+Y/fwLX7RdIhBCEFWp4LqCFBLYnf
 8gG1zNgg64+4dl+lfp5qFgwf7gKVtfeAdOb5VGB+Fae0BauVOX6VKqHnpqLzdNpUcq/
 QVKAsx7c8zsXhz2R0iRx2OxpNoeFB0cREg2bWws8=
Received: from localhost (p54AD4BF0.dip0.t-ipconnect.de [84.173.75.240]) by
 mx.zohomail.com with SMTPS id 1576877503864111.15727719804363;
 Fri, 20 Dec 2019 13:31:43 -0800 (PST)
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
 <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Ricardo Wurmus <rekado@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Fri, 20 Dec 2019 22:31:40 +0100
Message-ID: <87tv5upttv.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Arne Babenhauserheide <arne_bab@HIDDEN>,
 GNU Guix maintainers <guix-maintainers@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


zimoun <zimon.toutoune@HIDDEN> writes:

> Then you ask one question: "Should Guix be volatile software?" with
> the subtitle "Software developers should avoid traumatic changes".
> Nothing more.
> Well, I answer you by trying to fill the gap. Note that "volatile
> software" is the same argument than the Ludo's concern and the
> Konrad's example. So, nothing new on the table; except you are
> starting to throw "feelings" with the "traumatic change" words.

I=E2=80=99m just chiming in here to say that feelings of frustration are ve=
ry
valid reasons to make or object to a change.  Guix is or can be a very
important piece of software =E2=80=94 if it remains reliable in the toolbox=
 of
those using it.

It is difficult striking the right balance between exciting new features
that make things possible that were previously unattainable and
dependability through stable interfaces.

The Guix command line is by far the most commonly used interface.  We
can=E2=80=99t just claim that the Scheme API is stable (which it actually i=
sn=E2=80=99t)
and change the user-facing CLI as we please.

Personally, I think that it is fine to introduce breaking changes, but
that for changes that are likely to have a high potential for annoyance
and frustration there ought to be a documented way to work around them.
Breaking changes must be communicated through version number bumps and
accompanying announcements.

While I don=E2=80=99t see how we can make it happen, I do find the idea of a
stable API whose version can be selected with an environment variable
intriguing and worth thinking about.  If our Scheme API is as flexible
as we claim it shouldn=E2=80=99t be too hard to interpose a configuration l=
ayer
between the core facilities and the =E2=80=9Cporcelain=E2=80=9D.

I wonder what the other maintainers think about this.

--
Ricardo





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 21:12:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 16:12:26 2019
Received: from localhost ([127.0.0.1]:47308 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiPZR-0000C7-V8
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 16:12:26 -0500
Received: from sender4-of-o51.zoho.com ([136.143.188.51]:21124)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1iiPZQ-0000C0-Ey
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 16:12:24 -0500
ARC-Seal: i=1; a=rsa-sha256; t=1576876341; cv=none; 
 d=zohomail.com; s=zohoarc; 
 b=KC8qOSk1lgJIPcLWQ3jc39WMfc9xlYlJ/4RvHXfdYYuPIhyp1j131mWGZiY3SVgL/dZhn6W/4Sgj5y+/f78AizMLJa4zCbRS3N6JxrEX1xMSvDLbYxuLR6KQc6EXvVevb04TkbhcRYONUI7ep1k4L8yB6TebYSLW/z1IvGUVN8E=
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=zohomail.com;
 s=zohoarc; t=1576876341;
 h=Content-Type:Content-Transfer-Encoding:Cc:Date:From:In-Reply-To:MIME-Version:Message-ID:References:Subject:To;
 bh=N13jcy6MQYVWG+S+p/THeH9XERiymTOcnuMOiQucG74=; 
 b=LtXwlFgGI8YV4VfkirQ3U+MVbkBTQScDJv2UkYADYWBDdthlEBy3j9ERroiKKceTYnJwykm50nkHTeWboR/VsWWIbI+Kn5RqPh8HZk2RyfPTZsFxBXbm2T3oq4wZPqZEn0Z1CePnr8kmCNvpLCx7K0QDNXaAg0HIuZQOgwCuhXU=
ARC-Authentication-Results: i=1; mx.zohomail.com;
 dkim=pass  header.i=elephly.net;
 spf=pass  smtp.mailfrom=rekado@HIDDEN;
 dmarc=pass header.from=<rekado@HIDDEN> header.from=<rekado@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1576876341; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:Message-ID:MIME-Version:Content-Type:Content-Transfer-Encoding;
 bh=N13jcy6MQYVWG+S+p/THeH9XERiymTOcnuMOiQucG74=;
 b=FeiZoli+dvZs9ocdLBfyE9W89kba8eDoemKBxWl1L2VUSzhjuUIbu/1kcbb6aJzl
 G0NTJHRcRkfbuj3isr6ck09U4od9UILFnw69JK9aQJnHTyD20h8a+dXwURsFtLVNAzw
 g/AHOMMpt1PT6CG2cWTs+ObWfu/pMO3eHknemUQc=
Received: from localhost (p54AD4BF0.dip0.t-ipconnect.de [84.173.75.240]) by
 mx.zohomail.com with SMTPS id 1576876340375788.1906509358064;
 Fri, 20 Dec 2019 13:12:20 -0800 (PST)
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Ricardo Wurmus <rekado@HIDDEN>
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <m1pngmrmst.fsf@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Fri, 20 Dec 2019 22:12:17 +0100
Message-ID: <87v9qapuq6.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


Konrad Hinsen <konrad.hinsen@HIDDEN> writes:

>> Maybe I miss a point. It is not: "watch out, this will do something
>> else in the future" but "watch out, this was doing something else in
>> the past and the change happened the <date> in <commit>".
>
> Concrete example: I am writing a tutorial about using Guix for
> reproducible research. It shows several uses of "guix environment", some
> of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my exa=
mples will
> cease to work in a few months. What am I supposed to do about this?

I wonder if we should simply bump the version number to indicate that
this is a breaking change?

Another more difficult option would be to do what responsible API
developers on the web do: to version their API and to make the API
version selectable.  I don=E2=80=99t know *how* to do this elegantly, and
there=E2=80=99s a real maintenance cost (it seems small in this case), but
configuration files can be used for changing new defaults.

--
Ricardo





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 21:09:00 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 16:09:00 2019
Received: from localhost ([127.0.0.1]:47297 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiPW8-00006q-0Z
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 16:09:00 -0500
Received: from sender4-of-o51.zoho.com ([136.143.188.51]:21144)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <rekado@HIDDEN>) id 1iiPW6-00006h-AP
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 16:08:59 -0500
ARC-Seal: i=1; a=rsa-sha256; t=1576876134; cv=none; 
 d=zohomail.com; s=zohoarc; 
 b=c3aLmGgYog44mB9x/S8FKQMWkJexr1JQjktqtSFavyVaVnY7bhVK4JwtDuH2ri+0mg6IxbzrlrRGqYVxmKhftvMYujKTN9+itMQYhUSODoABvs9PYBvMJkXGbAp8LlAuu50SuXPGH7sxf2BuYDj9DQJOSjrgVz76Gk62M6Ja7/Y=
ARC-Message-Signature: i=1; a=rsa-sha256; c=relaxed/relaxed; d=zohomail.com;
 s=zohoarc; t=1576876134;
 h=Content-Type:Content-Transfer-Encoding:Cc:Date:From:In-Reply-To:MIME-Version:Message-ID:References:Subject:To;
 bh=y7/Z/zzt0J6lWZbIpls1m408ZpIOP5/L8auzqQXSZok=; 
 b=gmNS42QvnRaSb6WQw7TCvYIoUv7lio4YqaeLfW0pCYaodBfNmv7HX2bE1nXFbH1OQkddCqHl+5GAgzKUyQpuxCYRaJz3C4FaN+qbMqW05hucnpr1I3v+fnP9bE1C2A8woQFoGuMv8kbi0N1Gvysj5sLJtgdrSowr2byhLMkXEUI=
ARC-Authentication-Results: i=1; mx.zohomail.com;
 dkim=pass  header.i=elephly.net;
 spf=pass  smtp.mailfrom=rekado@HIDDEN;
 dmarc=pass header.from=<rekado@HIDDEN> header.from=<rekado@HIDDEN>
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; t=1576876134; 
 s=zoho; d=elephly.net; i=rekado@HIDDEN;
 h=References:From:To:Cc:Subject:In-reply-to:Date:Message-ID:MIME-Version:Content-Type:Content-Transfer-Encoding;
 bh=y7/Z/zzt0J6lWZbIpls1m408ZpIOP5/L8auzqQXSZok=;
 b=TyvNTeB6js996cfctR7Ghu+R/D+dA89BgT/saxhDx/SZrjdPhA0R2HNf2suhHFqi
 XE7mAjMhe0Ghasw9m7LmhlIW0RbqTsf23M433PxU9ENtV9lfKuBNNHAA3wlkQjLsWuT
 Bva9WbqZK6g3nvpytjvhkR7lcYMx25V6V1t1dmEU=
Received: from localhost (p54AD4BF0.dip0.t-ipconnect.de [84.173.75.240]) by
 mx.zohomail.com with SMTPS id 1576876132124196.49071745282401;
 Fri, 20 Dec 2019 13:08:52 -0800 (PST)
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
 <CAJ3okZ3zSS0Rbnu5eLhpYHPvSY1emaj=-estQcjRwiJ3=4RMMA@HIDDEN>
 <m1fthfz1db.fsf@HIDDEN>
 <CAJ3okZ32Ozgky=qUtj+QwjNRoX6aTzWKrMXy0M0wZpLAZRi8pg@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.3
From: Ricardo Wurmus <rekado@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ32Ozgky=qUtj+QwjNRoX6aTzWKrMXy0M0wZpLAZRi8pg@HIDDEN>
X-URL: https://elephly.net
X-PGP-Key: https://elephly.net/rekado.pubkey
X-PGP-Fingerprint: BCA6 89B6 3655 3801 C3C6  2150 197A 5888 235F ACAC
Date: Fri, 20 Dec 2019 22:08:48 +0100
Message-ID: <87woaqpuvz.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-ZohoMailClient: External
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, Konrad Hinsen <konrad.hinsen@HIDDEN>,
 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)


zimoun <zimon.toutoune@HIDDEN> writes:

>  - I propose the name "guix shell"

This is not a bad idea, especially considering that =E2=80=9Cguix environme=
nt=E2=80=9D
was meant to get shebang support, so that you could use it as the
interpreter in a script that handles the environment configuration.

It is also shorter.

--
Ricardo





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 13:21:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 08:21:52 2019
Received: from localhost ([127.0.0.1]:46012 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiIE4-00050i-3f
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 08:21:52 -0500
Received: from mail-qk1-f175.google.com ([209.85.222.175]:38825)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiIE2-00050R-VH
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 08:21:51 -0500
Received: by mail-qk1-f175.google.com with SMTP id k6so7587582qki.5
 for <38529 <at> debbugs.gnu.org>; Fri, 20 Dec 2019 05:21:50 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=0zJNsdmXfz/uwjSQsWi0WYblqnf2mIc82olyPAhHzDQ=;
 b=A1EsuPqQsAVErYE7sEskK43EfWKEq6FY8b9dXUN51Z2+KxMghZD39IW6DIUX1AZi8T
 8mAK3X36EF5ScSnUolxBkBND4uZI/54sI8rWLNdg6L2iBeDInWraenBHbTyWYNHqkQ3Z
 /gJu/4W+6U5PAmDPZHVNHdcaNtvyGKvqE4eXXV8BLgXDk29CNn6tpPyPgTzcFJhla3nb
 8sUZJ6Hm6qQ+ZoYRC/Mna8F4reBvZouCncOEq/rLSKIz+xhUrs7ODk6C1sgrKApNOV1k
 DR/YMFVseaXdZMQAy+faEiQuxLYCnTXGb5XY58qnmBe1hoO/VI7M1qbhRk4fqjnwju0L
 ApJw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=0zJNsdmXfz/uwjSQsWi0WYblqnf2mIc82olyPAhHzDQ=;
 b=E0ejqOdoXO8q9GMVhwb7YRwRBhBgYvsy6JSq1HMcDkgsAOev4fwovGkXdIBV0L8oNw
 mbxVTNl316rGOQZMBvbLOWsMrGfePX/EpmAU0cRhaVs7tL8to116fA/X6rkO0kmoraJ4
 hY0CCUENPjY/zgIUgOT+knESgCDhHLcjTOrv8vqAKfdGNCFrgGrbkKQwnckShcpPArAG
 5FIhiJV4HAfWspETAfpETXkIQmlDO9TQvyLsslUTQ8FbAfImGVmjgHYUpFHkUXJzvozN
 SoSGw9rtP4SKl8O3npRWEWUdYQZ3DBCGGdTdJjV3FxNo0gQSQzrLyt5j6eV3le9+MrbP
 wspg==
X-Gm-Message-State: APjAAAX0xk0l9uI7f4JJF2ThawzP9Nudt9KkoLBROfWwNoV793sMV92c
 W4dSzVx5a5nwACzwtiU6oEPxcenmDE+H+Sjexrc=
X-Google-Smtp-Source: APXvYqwrj5/zj9P5muYeUI8p6PE+piyMok4SRswo2CWpvjSdavi8EeXo9N5zpdcf4USv8D2VtmlC9d65ZNukIQmM9cY=
X-Received: by 2002:a37:63c7:: with SMTP id
 x190mr13217203qkb.232.1576848105490; 
 Fri, 20 Dec 2019 05:21:45 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <87k16snuoz.fsf_-_@HIDDEN>
 <m1immbz1ny.fsf@HIDDEN>
In-Reply-To: <m1immbz1ny.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 20 Dec 2019 14:21:34 +0100
Message-ID: <CAJ3okZ1paGtBzEGQZOn2U5Y4chTtR+MxK7PkAT1i_4orSHdOMA@HIDDEN>
Subject: =?UTF-8?B?UmU6IERlcHJlY2F0aW5nIOKAmGd1aXggZW52aXJvbm1lbnTigJk/?=
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>,
 =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Konrad,


On Fri, 20 Dec 2019 at 12:18, Konrad Hinsen <konrad.hinsen@HIDDEN> wrote:

> My point of view (long form:
> https://hal.archives-ouvertes.fr/hal-02117588)
> is that software projects should adopt a backwards compatibility policy
> early on, state it clearly in their documentation, and stick to it. That
> prevents misunderstandings, bad surprises, and heated debates.

Thank you for the pointer. I have not read yet.
I agree with the compatibility policy and this argument has been
raises in the "heated" debate with Arne. :-)


> As for what that policy should be for Guix, that's a more difficult
> story. For projects with versioned releases, I like the principles

The first idea which comes in mind is to introduce a pledge. Maybe in
the introduction.

"The Guix project pledges to keep backward compatibility... blabla".

However, the real question is at which level.
At the CLI level? At the exported scheme functions? All modules or
specific ones?


> of semantic versioning, but Guix is more of a rolling-release
> project. (Test question: does anyone know what the current Guix version
> number is? Does anyone care?) I am not aware of any good precedents
> in terms of policy for such projects.

I agree.

I proposed [1] to add "tags" in the meaning of "git tag". Initially,
to ease the navigation through the history when searching for
packages.
Re-hashing this "guix tag" or "guix pull --tag" proposal, one idea
could be to introduce tags, say v1.1, v1.2, v1.3 etc bumping the
version every X months, or after each core-update merge, or after
<you-name-it>, then by default "guix pull" would update to the tags.
This adds "stability" because we could tag commits that we know are
stable (no "guix pull" break, etc.)

[1] https://lists.gnu.org/archive/html/guix-devel/2019-11/msg00513.html


> > The hard question then becomes: what do we call it?  I vote against
> > abbreviations.  :-)
> >
> > Also, what other goals would we set for that command?  How would we
> > frame it in the set of commands?
>
> I vote for discussing the second point before the first one. Names
> should reflect the functionality behind them.

The starting point seems:
 - https://lists.gnu.org/archive/html/guix-devel/2017-08/msg00300.html
 - what do you feel missing about "guix environment"?

Considering my use-case, I am mostly aligned with "The future of 'guix
environment'".



All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 12:03:24 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 07:03:24 2019
Received: from localhost ([127.0.0.1]:45984 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiH08-00010o-Gy
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 07:03:24 -0500
Received: from mail-qv1-f52.google.com ([209.85.219.52]:35573)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiH06-00010Y-BP
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 07:03:23 -0500
Received: by mail-qv1-f52.google.com with SMTP id u10so3440016qvi.2
 for <38529 <at> debbugs.gnu.org>; Fri, 20 Dec 2019 04:03:22 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=PPLjqMpWwNNKkVhhpw19ZPMkGWHN2Dlt3sLJWX2Tz7g=;
 b=NPUFP/QlPvz/ETfjDitJngIlDNG9NMtzjcSMbDpBk8T4qnWZFu/HejPmIFSquOj9G8
 rhJHzoOZNPOxf0A+AbQxLRiz3Kw94ycQWhHIouYVtUsgYq1wQYQlVBqUElKzzSJuxXCt
 FnuRkqtJb1ijrb5/IoiUosRap7gEJawanBxfTcCGr8Nc0y4EiL+7VuEr92uMXkVG4js6
 PrRa3J+/XIi2iOr8+tbRpLMzmy+Tz05cMB33et4AGnXbJKw3Ol6tffeG9wyM4w6VRrkm
 Iu5ZZLnAO/h5JRuOyuKRuImHKZQ55NhA0C08j14x3oLKFY/1S/qGhT9k+e8pVzRAbhpX
 GJrA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=PPLjqMpWwNNKkVhhpw19ZPMkGWHN2Dlt3sLJWX2Tz7g=;
 b=g/sfqK1PrbdTcKeq1R5TcoyVBtU1OT87hI1quEl/Q5JZ91n3B9g2FUBoq7rXohZdMC
 LjgrdcnAgqakjHIZ8n7ZKtjdByfLT4B2q855xBTP9BD4q6CaiR5cfbLQna/w4a7fhWD8
 UhcNHszLcuiAbnQsDeDFEW7zlWz+0LyEdCYycSBmI1s0LGi3MIHQrQlI7eMT48PrMBir
 u0r1iu4rFHSZV9wfbsk3xfzSbSXZYLmMpA7Slnw8JIT9Hj2bFC/7urnBv7W/1gPHoTJ5
 yjeQW53prMJxbZPRXF/AAkRkH6l0Wt9Yypd07oj1JvW2vZ9+0iOGFxPvWjie+3PeSKjS
 rgmg==
X-Gm-Message-State: APjAAAVOTJT2XYyWdn/iTSLxI9X60LsoWgmWfnDmVovhvwyHnACPfPoF
 d00HZb6h2ebgkKyAhgNR5oFxhtUDhG7RYE6tCRs=
X-Google-Smtp-Source: APXvYqxrvLV8a3e33UjqhxQ0Ons3b3a5M8i3Zhia5r7xuDkdTkQNouy78Ff5T0ct8WKIb+E+chVPI8sz+UWAAX+A7ag=
X-Received: by 2002:a05:6214:108a:: with SMTP id
 o10mr4348994qvr.246.1576843396816; 
 Fri, 20 Dec 2019 04:03:16 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
 <CAJ3okZ3zSS0Rbnu5eLhpYHPvSY1emaj=-estQcjRwiJ3=4RMMA@HIDDEN>
 <m1fthfz1db.fsf@HIDDEN>
In-Reply-To: <m1fthfz1db.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 20 Dec 2019 13:03:05 +0100
Message-ID: <CAJ3okZ32Ozgky=qUtj+QwjNRoX6aTzWKrMXy0M0wZpLAZRi8pg@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Konrad,

On Fri, 20 Dec 2019 at 12:24, Konrad Hinsen <konrad.hinsen@HIDDEN> wrote:

> The problem is scripts circulating in public repositories, tutorials,
> etc. New users will find them and use them for inspiration. It's very
> discouraging to see examples from tutorials fail or do something weird.

As I said, I am not convinced because it lacks concrete examples.
Personally, I do not know Guix ressource outside the Guix ecosystem.


> The main precedent is the Python 2->3 transition. There are tons of
> GitHub repositories with Python code but no indication if it's 2, 3, or
> both. I even had to use one that executed with either 2 or 3, but gave
> different results. It takes a lot of motivation to persist.

Except that "guix environment" will raise warnings.
Whatever.


> For guix, there's the additional issue that we use the reproducibility
> of builds as an argument. Non-reproducible examples are then a bit of a
> credibility problem.

I agree.
I do not want to fight about "backward compatibility".


As I said, talking about "guix environment", my opinion is that the
cost of the change is low.
However, we cannot know this cost, only probe and estimate: using my
probings, I estimate the cost is low.

IMHO, in this case, there is 2 ways to make a decision:
 - more probings to estimate more precisely;
or
 - say: "no backward compatibility breakage"

I am fine with both. :-)
 - I report my use-case: no cost at all
 - I propose the name "guix shell"


However, I feel I have spent enough time and energy on this topic and
I feel a blocking situation so I will move forward to another topic.
:-)

All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 11:40:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 06:40:52 2019
Received: from localhost ([127.0.0.1]:45975 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiGeK-0000PU-AU
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:40:52 -0500
Received: from mail-qv1-f51.google.com ([209.85.219.51]:39205)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiGeF-0000Oj-KK
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:40:47 -0500
Received: by mail-qv1-f51.google.com with SMTP id y8so3489673qvk.6
 for <38529 <at> debbugs.gnu.org>; Fri, 20 Dec 2019 03:40:47 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=4xsJOiUMY5CVuanpC56KcR1NN+h1LL+deKjbyLMxws4=;
 b=C6o00HbKmicrLu+CzFrm+pgUYKv3OGRbCGpC7kepRVoZe53aIPQa3Q8E7v1gwuMGPG
 3QT9IA5dVjILfdbuxvqSnx47gEZQtY1LB2wLuQYIjdWCUlz0e4XdgHHRlqJ5JdeXIMGI
 MJYzH/tSLiVXPN9M+hzAJzLtvAh+sPln9/ZQceE+rhIfnJDselC+iXym28nAhfJuXRBo
 dVZPVemWreaocXwXWUIIltvcSTgDbj4tDtCp2dT3kv1FFExEhlNLsLU0Z9AhUhr72lST
 D3Y2B+dlM/peSAMF/DYqM7HfIYPu5YJdzKi/b5qCnK1ZOoge/A8SClX/qTy9Vz2mtyt+
 8XRg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=4xsJOiUMY5CVuanpC56KcR1NN+h1LL+deKjbyLMxws4=;
 b=iuMmk7heIOl7Edpnsq0D30+ie5VZ/+TaiD1yO4FbHt5RNYEH795wQm37VlSV+xqZyH
 Yu2QFjyqlKf6QnF1YDrgOSqMtGJ+rodSQb5rjTQN2x7HAN/Js8mAQ97see77nYvvvJ6c
 uQqKaa703FhToeoXXZL6UGDOWv6U1S9dQhqVMYl9zySXaVOXTmoZShdtIlprnhgz6ahr
 8LxRoy1fwuZvcIGobN8ZkDSQ421pFgoBlbymzgNSzK8xcd/ecb7IEq/Z2oQn/3VOn9cn
 zrPw78+JGkENSqAVbRG2rI9IkzMo0WAGGJRkqR0IVrF5kBukBwnbwWyvZCPyoaBRAr/s
 J1VA==
X-Gm-Message-State: APjAAAU1LWyjRhh9ZpRke5gLpJVNTnJehd3ovIEGwQ9KZ8Yszy6Nylu1
 ZZvssctKuAg9qZZFMDKsmy6PuvVgcbSkOxSYK8M=
X-Google-Smtp-Source: APXvYqxOCFe3xJHYaLOw6/heDnVsOfDeq5n1CfgUjSKX1i1wMcb2SxzTaWLBqpnbsO+z/2Ap0slInoTdlpIXcfmXhvE=
X-Received: by 2002:a0c:ca06:: with SMTP id c6mr11792884qvk.74.1576842042016; 
 Fri, 20 Dec 2019 03:40:42 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
In-Reply-To: <87zhfn3hgj.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 20 Dec 2019 12:40:30 +0100
Message-ID: <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Arne,


On Fri, 20 Dec 2019 at 02:37, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> > Or are you (maybe a bit) "overreacting" about the backward compatibilit=
y?
>
> I don=E2=80=99t think so. I am definitely reacting strongly, but that=E2=
=80=99s because
> breakages in Guix have already cost me the evenings of several weeks
> this year.
>
> But before I write anything more, I=E2=80=99d like to ask you to take a s=
tep
> back to breathe.
>
> We=E2=80=99re discussing a change in software. We disagree on the way for=
ward,
> but I=E2=80=99m not attacking you as a person, and I hope it does not fee=
l that
> way to you.
>
> If it does: This is not my intention. Please take a moment to sigh
> deeply, shake your head, relax, and smile =E2=80=94 because that actually=
 helps.
> It=E2=80=99s what I try to do when discussions get vexing.
>
> I am grateful that you=E2=80=99re taking up improvements in Guix, and the=
re are
> situations where viewpoints are different. That is OK.


I am fine. :-)
Life is about managing disagreements.
And I am probably a typical grouchy French. ;-)

Well, if we go back in time, the story is:
 - the original author of "guix environment" is not happy with the
current behaviour and proposes a change (see "The future of 'guix
environment'").
 - life happens (v1.0) but not this change.
 - I am not happy with the current behaviour and other on IRC neither.
 - a plan to change is opened for discussions.

The first concern by Ludo is about the compatibility.
Then Konrad raises concrete examples.

At this point, my personal opinion is: the cost is low so the change can ha=
ppen.
However, I agree with the "backward compatibility" issue and even I
propose a name for this "new" command: "guix shell".

Then you ask one question: "Should Guix be volatile software?" with
the subtitle "Software developers should avoid traumatic changes".
Nothing more.
Well, I answer you by trying to fill the gap. Note that "volatile
software" is the same argument than the Ludo's concern and the
Konrad's example. So, nothing new on the table; except you are
starting to throw "feelings" with the "traumatic change" words.

Then, your following answer is more about your feelings than concrete
examples. It is hard to know in advance how many scripts or use-cases
would be broken -- i.e., estimate the cost -- and a way is to probe;
say: "it will break X of my scripts" or "in my institute, X people use
"guix environment blabla" daily, so it is not an option", etc.
Otherwise, it is unproductive.

Well, instead of arguing about feelings because it is going nowhere or
at better a flame war about "backward compatibility", I prefer going
to spend my time elsewhere (still about Guix :-)).
I mean, I proposed, I said my opinion and I called to collect more
opinions. I feel I did my best on this front and other fronts deserve
proposals and fixes.


Kind regards,
simon

ps:
Note that I did a proposal which could be a path to reduce the burden
of "guix pull" breakage: adding tags. Feel free to comment.

https://lists.gnu.org/archive/html/guix-devel/2019-11/msg00513.html




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Dec 2019 11:40:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 06:40:49 2019
Received: from localhost ([127.0.0.1]:45973 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiGeG-0000PC-R2
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:40:49 -0500
Received: from lists.gnu.org ([209.51.188.17]:37073)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiGeF-0000Ov-1A
 for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:40:47 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:38180)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiGeD-0005fA-Dd
 for bug-guix@HIDDEN; Fri, 20 Dec 2019 06:40:46 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1iiGeB-0005Cu-9E
 for bug-guix@HIDDEN; Fri, 20 Dec 2019 06:40:45 -0500
Received: from mail-qv1-xf35.google.com ([2607:f8b0:4864:20::f35]:32983)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <zimon.toutoune@HIDDEN>)
 id 1iiGeB-0005BI-2q; Fri, 20 Dec 2019 06:40:43 -0500
Received: by mail-qv1-xf35.google.com with SMTP id z3so3503625qvn.0;
 Fri, 20 Dec 2019 03:40:42 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=4xsJOiUMY5CVuanpC56KcR1NN+h1LL+deKjbyLMxws4=;
 b=C6o00HbKmicrLu+CzFrm+pgUYKv3OGRbCGpC7kepRVoZe53aIPQa3Q8E7v1gwuMGPG
 3QT9IA5dVjILfdbuxvqSnx47gEZQtY1LB2wLuQYIjdWCUlz0e4XdgHHRlqJ5JdeXIMGI
 MJYzH/tSLiVXPN9M+hzAJzLtvAh+sPln9/ZQceE+rhIfnJDselC+iXym28nAhfJuXRBo
 dVZPVemWreaocXwXWUIIltvcSTgDbj4tDtCp2dT3kv1FFExEhlNLsLU0Z9AhUhr72lST
 D3Y2B+dlM/peSAMF/DYqM7HfIYPu5YJdzKi/b5qCnK1ZOoge/A8SClX/qTy9Vz2mtyt+
 8XRg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=4xsJOiUMY5CVuanpC56KcR1NN+h1LL+deKjbyLMxws4=;
 b=HkbqU7iQ3lUOpo4Nh7vTs6hLD/cFFGXJ0K6DLppZNWhniKjssOCkqScKKfVt0083Xf
 ljzUHLrG7x72XsR8wmtjfZIU+u64z0PbSw9h25cgN+aAFUKGV26XSiyok8ZfQ+drkdu4
 mssD7V51awrmEdgMlcHj7arCRSDIdHLQT8gw7FgO1TfJR6jeIo8X9S7DVoDqEUTLt8vK
 95UAH/SzVceuhrLKd+/rNf/CK0VroWULJRVfA2GAqq9RoqocwAcmkozc5rTVbyJelMIx
 nAO0p23RhFnB2yQ1CPTJcMymABKQSgY2m18BE/So4W/q4umLCyzsAD2TLkLPb+DV8rMY
 3XtA==
X-Gm-Message-State: APjAAAUYVKtgPgbNkN+PcXYlRX7sqFZPgD7R9bVl+Cb2OiSmgAQ4jPQG
 bviaO7qhtEUK6APAviB3NEzpDCw+bR5XaiBNs14=
X-Google-Smtp-Source: APXvYqxOCFe3xJHYaLOw6/heDnVsOfDeq5n1CfgUjSKX1i1wMcb2SxzTaWLBqpnbsO+z/2Ap0slInoTdlpIXcfmXhvE=
X-Received: by 2002:a0c:ca06:: with SMTP id c6mr11792884qvk.74.1576842042016; 
 Fri, 20 Dec 2019 03:40:42 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
 <87zhfn3hgj.fsf@HIDDEN>
In-Reply-To: <87zhfn3hgj.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 20 Dec 2019 12:40:30 +0100
Message-ID: <CAJ3okZ2XTAbPp0m7TQqCEi_oz223HyBd0BZefRO4Q90xmni2mw@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2607:f8b0:4864:20::f35
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi Arne,


On Fri, 20 Dec 2019 at 02:37, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> > Or are you (maybe a bit) "overreacting" about the backward compatibilit=
y?
>
> I don=E2=80=99t think so. I am definitely reacting strongly, but that=E2=
=80=99s because
> breakages in Guix have already cost me the evenings of several weeks
> this year.
>
> But before I write anything more, I=E2=80=99d like to ask you to take a s=
tep
> back to breathe.
>
> We=E2=80=99re discussing a change in software. We disagree on the way for=
ward,
> but I=E2=80=99m not attacking you as a person, and I hope it does not fee=
l that
> way to you.
>
> If it does: This is not my intention. Please take a moment to sigh
> deeply, shake your head, relax, and smile =E2=80=94 because that actually=
 helps.
> It=E2=80=99s what I try to do when discussions get vexing.
>
> I am grateful that you=E2=80=99re taking up improvements in Guix, and the=
re are
> situations where viewpoints are different. That is OK.


I am fine. :-)
Life is about managing disagreements.
And I am probably a typical grouchy French. ;-)

Well, if we go back in time, the story is:
 - the original author of "guix environment" is not happy with the
current behaviour and proposes a change (see "The future of 'guix
environment'").
 - life happens (v1.0) but not this change.
 - I am not happy with the current behaviour and other on IRC neither.
 - a plan to change is opened for discussions.

The first concern by Ludo is about the compatibility.
Then Konrad raises concrete examples.

At this point, my personal opinion is: the cost is low so the change can ha=
ppen.
However, I agree with the "backward compatibility" issue and even I
propose a name for this "new" command: "guix shell".

Then you ask one question: "Should Guix be volatile software?" with
the subtitle "Software developers should avoid traumatic changes".
Nothing more.
Well, I answer you by trying to fill the gap. Note that "volatile
software" is the same argument than the Ludo's concern and the
Konrad's example. So, nothing new on the table; except you are
starting to throw "feelings" with the "traumatic change" words.

Then, your following answer is more about your feelings than concrete
examples. It is hard to know in advance how many scripts or use-cases
would be broken -- i.e., estimate the cost -- and a way is to probe;
say: "it will break X of my scripts" or "in my institute, X people use
"guix environment blabla" daily, so it is not an option", etc.
Otherwise, it is unproductive.

Well, instead of arguing about feelings because it is going nowhere or
at better a flame war about "backward compatibility", I prefer going
to spend my time elsewhere (still about Guix :-)).
I mean, I proposed, I said my opinion and I called to collect more
opinions. I feel I did my best on this front and other fronts deserve
proposals and fixes.


Kind regards,
simon

ps:
Note that I did a proposal which could be a path to reduce the burden
of "guix pull" breakage: adding tags. Feel free to comment.

https://lists.gnu.org/archive/html/guix-devel/2019-11/msg00513.html




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 11:24:09 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 06:24:09 2019
Received: from localhost ([127.0.0.1]:45959 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiGO9-0008Ge-L3
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:24:09 -0500
Received: from out2-smtp.messagingengine.com ([66.111.4.26]:40153)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <konrad.hinsen@HIDDEN>) id 1iiGO8-0008GP-4K
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:24:08 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.nyi.internal (Postfix) with ESMTP id 069C822396;
 Fri, 20 Dec 2019 06:24:03 -0500 (EST)
Received: from mailfrontend2 ([10.202.2.163])
 by compute7.internal (MEProxy); Fri, 20 Dec 2019 06:24:03 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=fastmail.net; h=
 from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-type; s=fm2; bh=j0i31SZz0X8vTaJP3Y4T5gYn0I
 WBqDtLFETZAROl87k=; b=IDtyW2rfb/RS1iIIMvHu1y28vOj+rOgaIkJ+oUcdfv
 S8zi9/M+zN2Ba1exBVx6RI9KkRDSC2kti8NLOGhF1w2e7xv3W79z7cSVc/t8jJTV
 oBIxYKpM7UDi04ftGkE7BqpnYiq3IrT90uHIhM+jy8LzvjemqVsjksQ9Vjfd5GcP
 Im++SIKbX924s9r/dU2s5UgTRW1PBJwqA0/17jJ3hcTk0U0Ifqg5+uButOdssRxX
 5opzwwA9vNfbDZuB5gfSPt9E1arXZU49RQIuu+J/8V3uY3NpzirLDbcbXbHoyUta
 /C0/QaMAWN+X8GITBPJ2FirItOit1QF6JNtZ9a2QMLgQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:references:subject:to:x-me-proxy
 :x-me-proxy:x-me-sender:x-me-sender:x-sasl-enc; s=fm1; bh=j0i31S
 Zz0X8vTaJP3Y4T5gYn0IWBqDtLFETZAROl87k=; b=CNkdiqVpR5LkVKVlxy0iVH
 MK7g291zEx02MoxFskW8/6H0LwjcZOSj01Rn49t8yyGWh9ap87mksO8zP0MnyDCJ
 iQWiAIzrd+dlrV1v/HIauXSh2vB95/QOjDx4nkLnQfRZKUUKBHI5IWOycihJEiVQ
 MsWql4dVwSnKgZUZUVmoMzOddnQkGssfM3AlHbkdYflMtOmrrH5py5jV/TA2mSpn
 dospusQaIF8BFDEQYYoy92XllQeS+DeR+CV/NNDqMBXhyMEBvAPxNyxmMvWJghfF
 GZp1suyLiMXflibmDra/u/+4vpKakOca7Q7qmmDsEvgP7xHiI3GGxjoHj/7eqsyQ
 ==
X-ME-Sender: <xms:Uq_8XWc8oi971MFdn6-gscqcbaCgUyI-y3xHADB88P1OYR7meJuB8g>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedufedrvddufedgvdeiucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhephffvufgjfhffkfggtgesthdtredttddttdenucfhrhhomhepmfhonhhrrggu
 ucfjihhnshgvnhcuoehkohhnrhgrugdrhhhinhhsvghnsehfrghsthhmrghilhdrnhgvth
 eqnecukfhppeekiedrvdegjedrudeigedrvdegheenucfrrghrrghmpehmrghilhhfrhho
 mhepkhhonhhrrggurdhhihhnshgvnhesfhgrshhtmhgrihhlrdhnvghtnecuvehluhhsth
 gvrhfuihiivgeptd
X-ME-Proxy: <xmx:Uq_8XcM_BOxcHHC8VlNbSiBV8GvlQE-UVPMJ87KK3LHaY8xe9HU1Kg>
 <xmx:Uq_8XZuon7MIo8Fjax8xMs3nKSkLJ4fRzrNRA4GW9pwqaRFIx3Iq5w>
 <xmx:Uq_8XVDsDfh9EDNrEHbVoiINEglzm93c1qzpqx25mk_JCIHJbiEAPQ>
 <xmx:Uq_8XYciDM-adq6M07BmMFZ84my55lbsBnMWgXXi6J1lDGkV1hXEvw>
Received: from ordinateur-de-catherine--konrad.home
 (lfbn-idf2-1-714-245.w86-247.abo.wanadoo.fr [86.247.164.245])
 by mail.messagingengine.com (Postfix) with ESMTPA id 08E6D306030B;
 Fri, 20 Dec 2019 06:24:01 -0500 (EST)
From: Konrad Hinsen <konrad.hinsen@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-Reply-To: <CAJ3okZ3zSS0Rbnu5eLhpYHPvSY1emaj=-estQcjRwiJ3=4RMMA@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
 <CAJ3okZ3zSS0Rbnu5eLhpYHPvSY1emaj=-estQcjRwiJ3=4RMMA@HIDDEN>
Date: Fri, 20 Dec 2019 12:24:00 +0100
Message-ID: <m1fthfz1db.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi Simon,

> Assuming "guix environment" would stay and following the proposed
> plan, you would need to add GUIX_ENVIRONMENT_DEPRECATED=1 on the top
> of your script. In this would not be a problem for travelling back in
> time.

The problem is not how I update my scripts - I can manage that, no
matter what it takes.

The problem is scripts circulating in public repositories, tutorials,
etc. New users will find them and use them for inspiration. It's very
discouraging to see examples from tutorials fail or do something weird.

The main precedent is the Python 2->3 transition. There are tons of
GitHub repositories with Python code but no indication if it's 2, 3, or
both. I even had to use one that executed with either 2 or 3, but gave
different results. It takes a lot of motivation to persist.

For guix, there's the additional issue that we use the reproducibility
of builds as an argument. Non-reproducible examples are then a bit of a
credibility problem.

Cheers,
  Konrad.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 11:17:47 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 20 06:17:47 2019
Received: from localhost ([127.0.0.1]:45949 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iiGHz-00084x-4J
	for submit <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:17:47 -0500
Received: from out2-smtp.messagingengine.com ([66.111.4.26]:59545)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <konrad.hinsen@HIDDEN>) id 1iiGHw-00084b-B9
 for 38529 <at> debbugs.gnu.org; Fri, 20 Dec 2019 06:17:45 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.nyi.internal (Postfix) with ESMTP id 34AD0223DC;
 Fri, 20 Dec 2019 06:17:39 -0500 (EST)
Received: from mailfrontend1 ([10.202.2.162])
 by compute7.internal (MEProxy); Fri, 20 Dec 2019 06:17:39 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=fastmail.net; h=
 from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-type:content-transfer-encoding; s=fm2; bh=
 quK5caNGFafrM/2sJNQxSRJEUFhsxysaBaN2cUHD6YU=; b=aHsyWlm9hQZis0Qu
 T04b2GYbacpfkryDnpNVqi67Nxd/yygx3nRy7a6yBdlkec8g7u+k0p66eJgRGGd5
 MLqz9dKPxN0RD5XcJRO1cWLmM2v/eP36ohHb2W6zH48w7k3bidGkNJsL1i1rYDVk
 Vf1DBC673mBBS7cx5V5q0Tn8VVxC08nH31ifkHJODfQiasVSBfZ7CXqIVY6fReus
 hLE/T4d7q7KpIrBdtEP9eGzSzX+9t1oJ7URYSQE1IRngLo5c5gzK1lNWUPBlG1dh
 l2RQRqd1szbDdv9kVRdJDIGTgQhJ3anWlP0KNKKk0jMisOQlPph8GotnUVwM4see
 cmRniQ==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :date:from:in-reply-to:message-id:mime-version:references
 :subject:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm1; bh=quK5caNGFafrM/2sJNQxSRJEUFhsxysaBaN2cUHD6
 YU=; b=bwvWcJzwNeAcedYCH2U2YD/n7MUNZbJ5zM6N45At+UwcGkSzb7BOqjRkQ
 4nnN0CVCrfTqI6uVo4mpQFsM9S5LwVoIxJOwS2tIQszuECumTPzqa76PJ8zMbJwA
 FWMVIpGMR3Bjdu7LxYB+KNQ9KjVgPe9FyOW6dn+3B8d489fuWQHFnfRtBF/Basii
 ddoFrVeruW7CSP83eYxrGJbaHbm/6q6DQYsj7gaQL3363xOmyJiohVwho4mQzPW+
 S64T4fomMzo21GmQj4o8kGj/cihx2HOSce6VohUkcoj/7kKN23c+wHEqCbPdhtzA
 otHnBJBMJs/E3euVFWqGd4rBFBOfQ==
X-ME-Sender: <xms:0q38XQX1IDRANDdWyVLgnn1rpe6bIJWvcaDvK9JFptg2qAe5zD-ToA>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedufedrvddufedgvdehucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhephffvufgjfhffkfggtgfgsehtqhertddttdejnecuhfhrohhmpefmohhnrhgr
 ugcujfhinhhsvghnuceokhhonhhrrggurdhhihhnshgvnhesfhgrshhtmhgrihhlrdhnvg
 htqeenucffohhmrghinheprghrtghhihhvvghsqdhouhhvvghrthgvshdrfhhrnecukfhp
 peekiedrvdegjedrudeigedrvdegheenucfrrghrrghmpehmrghilhhfrhhomhepkhhonh
 hrrggurdhhihhnshgvnhesfhgrshhtmhgrihhlrdhnvghtnecuvehluhhsthgvrhfuihii
 vgeptd
X-ME-Proxy: <xmx:0q38XY3G66XoHkKF1qX2qG-2CKBsfLgjNZg0cwvLJePvHWL9DHCSeA>
 <xmx:0q38XfYkbYsxBTYJ8RJckRoqGxdTGwgv6Aia6gJJXZcIWnFsDuZRVw>
 <xmx:0q38XTrKdOI8naLGbn7Rs2aNm1_m8HVwWBp5YFmFZBavxSkxiC1CTg>
 <xmx:0638XXG_PGxJNKnTVr0OUxLWL9gGNcXc9EtZIxb-RwfldardgJRb8g>
Received: from ordinateur-de-catherine--konrad.home
 (lfbn-idf2-1-714-245.w86-247.abo.wanadoo.fr [86.247.164.245])
 by mail.messagingengine.com (Postfix) with ESMTPA id 225CD80061;
 Fri, 20 Dec 2019 06:17:38 -0500 (EST)
From: Konrad Hinsen <konrad.hinsen@HIDDEN>
To: Ludovic =?utf-8?Q?Court=C3=A8s?= <ludo@HIDDEN>
Subject: Re: Deprecating =?utf-8?Q?=E2=80=98guix_environment=E2=80=99=3F?=
In-Reply-To: <87k16snuoz.fsf_-_@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <87k16snuoz.fsf_-_@HIDDEN>
Date: Fri, 20 Dec 2019 12:17:37 +0100
Message-ID: <m1immbz1ny.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: guix-devel@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi Ludo,

> Clearly there=E2=80=99s a tension between that and keeping Guix open to c=
hanges.

That's indeed the main problem and here as elsewhere, it is often a
topic of heated arguments.

My point of view (long form:
https://hal.archives-ouvertes.fr/hal-02117588)
is that software projects should adopt a backwards compatibility policy
early on, state it clearly in their documentation, and stick to it. That
prevents misunderstandings, bad surprises, and heated debates.

As for what that policy should be for Guix, that's a more difficult
story. For projects with versioned releases, I like the principles
of semantic versioning, but Guix is more of a rolling-release
project. (Test question: does anyone know what the current Guix version
number is? Does anyone care?) I am not aware of any good precedents
in terms of policy for such projects.

> The hard question then becomes: what do we call it?  I vote against
> abbreviations.  :-)
>
> Also, what other goals would we set for that command?  How would we
> frame it in the set of commands?

I vote for discussing the second point before the first one. Names
should reflect the functionality behind them.

How about a unified command for constructing environments and profiles
declaratively? In other words, combine "guix environment" and the
declarative parts of "guix package". We could probably get rid of
the somewhat obscure "guix environment -r" in the process.

Cheers,
  Konrad.





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 20 Dec 2019 01:37:49 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 20:37:49 2019
Received: from localhost ([127.0.0.1]:45747 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii7Ei-00027a-9t
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 20:37:49 -0500
Received: from mout.web.de ([217.72.192.78]:42693)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1ii7Ee-00027L-MZ
 for 38529 <at> debbugs.gnu.org; Thu, 19 Dec 2019 20:37:45 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576805857;
 bh=7w/eR58ORNgTUn2UKFZHIdpOyqvKMi8eOlkXPcxLmJg=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=NBLVOlwp5hX/pC+py9K2nhZLNg50uowFtFX7by33teh1tBXxWMIAcUtTOo87Mhyg0
 LcFyMhwtS2vvkfMoswwAVBZLaVA5weI0zkw9QDOOpAo0FhPEMD5a7Tjw+M7vVDYhMT
 1VRWuA9XVBxiT0nSPY4gbdk5zz3jjOLYBbUjIqU0=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb102
 [213.165.67.124]) with ESMTPSA (Nemesis) id 0M0Qkb-1hoVFF2l4f-00uWx6; Fri, 20
 Dec 2019 02:37:36 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
Date: Fri, 20 Dec 2019 02:37:32 +0100
Message-ID: <87zhfn3hgj.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:EEV/ncBLKLDkEMpXo50zYYBcDHZnniIWm4RtS5RXqJ3lc9exlMO
 E5LNG7t8iV/Omt7rzvsvIeNPSL/EEyKCnaaKRAzjnjLS+fnWr49EwS3OV+AO9CHS/UHXL2T
 CU7Ir8ruv0ErsVIIaS0ivN1NaCjEaQkSlnanQUEQEgTocXPmj+M+GnyTpK+jL9Kz72R2FxJ
 5vm3IgD6qV6PJMCkAOFXg==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:JlQzMKPMkAE=:MTioK7hNa+0yyyvCQw6BaH
 ikWjaMpa0gsLENMif35BXje1gxqRNwfGoCp8iuESpH7Cz4tl5tBgHSjoXrdOIfhijCuNsKKW3
 3/r/c4U5p+LzyCVmqMy7wqNkXFV6e0IboZJHWk+WjXvenMbqIqv2LIPzhN00/vK0cew8gaHf7
 9RMxTU4YpGEkmWxsu58HDrmesVAEPRZbf23/ZDp1kckgsX/KCzjPXSc2vsb55ke2SckeWZXsM
 cQ9IcKyKZp8FIn+nan8ZbJfJ++GHAY+1LoXZgLEEazRUac/rWkmld/+Q6mUw1C90NqAzje1Ck
 TKAEjQTpbESb1xh1okHOp/d7+uQ3WtCPVRuf9IwYfGIylV02mJ8rdrSZsvthv4ZovvpGk6DxT
 tHPIXHlL+e3yz+hxzHD3MHMTuCO+l3LV4Sj4VEnZFCbQDeobxJRCvjlfn0YkGs2sUDU19V7Gp
 oaRgfyEdgBlklbpRyZUJKUBtAPzs6FKrb+SEecem7ycfQBDmLKKebUAnfN0u9v7t9/uER64Wk
 v7/OlVIc0kYX+2Jz88z809Ce81CtgBZHqy9lTZ4zd97XiWVuuAulJFPRA4Ltz0ZmvnYOEpWDB
 2DOKW3wWNoABxv8hENNX94Htzc3E1fawBh0q4RfHu3kXivhzPhOOAV0vs0JNQU5xkuMhqFtHo
 +wh5wLBhvbxgTz4b/QKGDye7+Yg9ZqGQnazIEhqYqxeFjqTVpU9PtnFZAd0Ttjx5fbAqx2bjh
 5A7KxPZaMxZhBij2EfwdA0EkjK2Qw3vo8m8SxtYAnqRNMnodtwtYjcE5/zuXF07MQK+x6WnhX
 AT9wHz+pyBaeMQeRRYYOLHuHS5TO9iFKVP1j48fji2gnnB3tIE/R7so9ENzen7sbfw6zDUEOt
 y5jLDqequg5h13JDcCLQPjopXm+mxVqhgEm8Xui8vDG99lWMqSou2rl0htMW5j51V3/CNa/D0
 WTKKzT0xOdCL6x9nXIdsuQiRDNWpegZUaAKM+6uAwaef8b4xWTRwwBYl13zWoSY+WZ6dXVRcp
 XaWNaHVLepg9IhShBEtzr7Z8MaLiBtY2C/XmmkIgrh7wZJIi8NAR3aauOtPiE+e1TSWepClXh
 sjS756Tm8QuZmVPgScNP/QlyZ+vsjiMuzkqlDziUSP5C1B3pPDyzVnD5In/dpP4e718DSV/U2
 fIwbKQk0vijm9WoPUqn2IO67JAXNRvtYjwzTmQxTjeKcNmGNbJ7TRIVz6HE/tPVhBGXP7ZQeq
 P7aDx7f1kcW7rReHQhPQbKWmgVJyotkhR0m/4KA==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


zimoun <zimon.toutoune@HIDDEN> writes:
> First, have you read the proposal?

Yes.

> Or are you (maybe a bit) "overreacting" about the backward compatibility?

I don=E2=80=99t think so. I am definitely reacting strongly, but that=E2=80=
=99s because
breakages in Guix have already cost me the evenings of several weeks
this year.

But before I write anything more, I=E2=80=99d like to ask you to take a step
back to breathe.

We=E2=80=99re discussing a change in software. We disagree on the way forwa=
rd,
but I=E2=80=99m not attacking you as a person, and I hope it does not feel =
that
way to you.

If it does: This is not my intention. Please take a moment to sigh
deeply, shake your head, relax, and smile =E2=80=94 because that actually h=
elps.
It=E2=80=99s what I try to do when discussions get vexing.

I am grateful that you=E2=80=99re taking up improvements in Guix, and there=
 are
situations where viewpoints are different. That is OK.

>> This is taking this a bit too easy. If I can no longer pull, because
>> that breaks my Emacs or Gnome, then Guix is broken for me: I can no
>> longer update my system without first adjusting my config.
>
> So you expect that we would push a patch changing "guix environment"
> and in the same time break "guix pull, isn't it?

No, this is an example which shows that being able to roll back does not
mean that there is no problem with breaking the way forward. Using only
old versions is often not an option. Just imagine running audio software
from 5 years ago on a system that only provides pulseaudio (or whatever
will come after it). Imagine using an old KDE DCOP-based automation
workflow on a dbus-system. You need to update the libraries you use to
get it working at all.

>> > Hum? I am not convinced that the cost would be high... Because 1. the
>> > number of people using Guix is not so high (yet!), so 2. I am almost
>> > sure we can name the people using "guix environment" in scripts ;-).
>>
>> I=E2=80=99m not so sure. Guix is already used in scientific workflows, a=
nd there
>> is existing third-party documentation about using `guix environment`.
>
> Please point me where.
> It will save me time instead of reinventing the wheel.

It was mentioned on this list.

For the scientific workflows, see https://hpc.guix.info/

>> And can you name the people using `guix environment` by searching
>> backwards in their bash history?
>
> So what would break?
> Your workflow: spending 5 minutes to read the warning message and then pr=
essing:
> C-a GUIX_ENVIRONMENT_DEPRACATED=3D1 guix environment <your-complicated-in=
vokation>
>
> (unfair and bitter; sorry!)

I=E2=80=99m sorry that this makes you bitter. This is not my intention.

I=E2=80=99ll answer without bitterness: The original environment does not s=
pawn
instantly. It takes many minutes until it is ready. If I then have to go
back, find the warning (it=E2=80=99s likely that I=E2=80=99d miss it, becau=
se these are
things that work, and suddenly they break, which I=E2=80=99m likely to only
figure out when the followup steps don=E2=80=99t work) and run it again, th=
at
often means that I=E2=80=99m out of time to do what I actually wanted to do.

Despite that: Yes, this is a viable way. It is one of the less painful
ones. Maybe avoid calling it "DEPRECATED" and instead give it a more
descriptive name that does not imply that it will go away.

Mercurial uses HGPLAIN=3D1 to say "I want the version which will never
change established API". Best practice is to always use that in scripts
=E2=80=94 and that is a stable best practice. But this is also slow to rece=
ive
new features.

If the old way to use guix environment is intended to actually be legacy
only, then it could be a way forward to also provide
GUIX_ENVIRONMENT_STABLE=3D1 which gives an API that is guaranteed to never
change the meaning of options again *after the change that=E2=80=99s been
started to brew in 2017*.

That would be a purely append-only API then, and while it would break
once, it would prevent such changes for the future.

For PR it might be possible to state that with this change, guix
environment as a tool reaches version 0.99 (to be updated to 1.0 after
sufficient testing).

>> > And 3. the time to figure out what changed is really low -- especially
>> > with warnings and hints -- and "guix environment foo -- make" would
>> > return an error because of dependencies missing.
>>
>> It took me days to figure out the exact guix environment invocation that
>> allows me to build the tools for a paper I=E2=80=99m still working on. I=
f that
>> breaks, that causes massive anxiety, because I then don=E2=80=99t know w=
hether
>> I=E2=80=99ll find the time to fix it before I run into deadlines.
>
> Do you mean add GUIX_ENVIRONMENT_DEPRECATED=3D1 at the top of your script?

Yes, at every script. And remember to add it to every command I still
have in history.

>> > Other said, I do not see myself use-cases where the scripts using
>> > "guix environment" need to be robust for time-travelling -- the same
>> > script used with current, past and future Guix versions -- because as
>> > it was said elsewhere: "environment" can be seen like "temporary
>> > profile". And temporary means... well temporary. ;-)
>>
>> The same script must always work with future versions. Otherwise the
>> software is volatile.
>
> Here is the real argument.
>
> It is a point of view. I would like to ear the one of others.
> If I understand well, Konrad agrees with you.
>
> I am fine with: the same script must always work with future versions.
>
> It is a strong statement and if the Guix project agrees then it must
> be documented. For example in this section [1].
>
> What do you think?

Only if this is actually the stance of the whole Guix project.

Currently this is the argument given by one person in an email
discussion. I think that it is a strong and important argument
(otherwise I would not have made it), but I=E2=80=99ve been wrong before.

Maybe the change to Guix environment now is for the best of the project.
I cannot actually see so clearly into the future that I could say
whether the churn due to the breaking change or the annoyance due to
suboptimal default behavior will be worse.

> [1] http://guix.gnu.org/manual/devel/en/html_node/Managing-Software-the-G=
uix-Way.html#Managing-Software-the-Guix-Way
>
>
>> You don=E2=80=99t need to be able to go back in time, but the path forwa=
rd must
>> be without breakage.
>
> Talking about Reproducible Science, going back in time is the core
> issue. If one is able to go back in time and to run again the (almost)
> exact same version, then the future is not the issue.

The future is an issue, because you often have to use up-to-date
libraries. Just imagine using a rust-tool but being stuck in a 12 months
old environment that you cannot update without breakage.

> Correct me if I misunderstand your point.
> Today, I write a script using X tools at time T. In the future, I want
> to re-run this script so all the X tools must have a path forward
> without any breakage. It is your point, right? But this never happens,
> there is always a breakage somewhere; and generally for good reasons.

No, and that=E2=80=99s the point. That=E2=80=99s also the point of the arti=
cle: There
are tools which almost never break. And there are tools that almost
always break.

If you use a tool out of the latter group, you=E2=80=99re in for a world of
pain. It=E2=80=99s why it took years and years for somewhat stable git-wrap=
pers
to appear: The early wrappers that made git easier to use always broke
when git changed operation. Guix environment might actually help you
delay the update until you have time to deal with the breakage.

> Instead in this future, if I am able to restore the exact same X tools
> as they were at time T, my script still works.
>
> Well, this is another story.

This helps surviving volatility in other tools, but only if tool for
doing so isn=E2=80=99t volatile itself.

>> > Last, "volatile" vs "stable" is mitigated by "The future of 'guix
>> > environment'" [1] which really predates the 1.0. ;-)
>>
>> Yepp, but we=E2=80=99re after 1.0 now. This might have been a blocker fo=
r 1.0,
>> but it wasn=E2=80=99t.
>
> So if the version bump, it is not an issue then, isn't it?

It would still be an issue, but see the part about seeing into the
future above :-)

>> >> Also: Software developers should avoid traumatic changes
>> >>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html
>> >
>> > "Traumatic changes"? Maybe a bit extreme for the change we are talking=
 about...
>>
>> I don=E2=80=99t think so. There=E2=80=99s the strong version where it=E2=
=80=99s obvious: It
>> leads people to leave a project instantly.
>
> Yes, me!

Have a look at your reaction here. This is just the kind of reaction
people feel when something into which they invested time suddenly stops
working as expected.

>> There=E2=80=99s the weaker version which is less obvious: That=E2=80=99s=
 where people
>> who invested efford to follow best practices suddenly find their project
>> to be written in legacy style, because the best practices changed.
>
> Best practise depends on a lot of parameters. I did not know it was froze=
n.

If you manage to freeze the best practices without blocking ways into
the future, then you found part of the holy grail of software
development: You managed to find one fragment that=E2=80=99s so good that it
never needs to change again and everything new you do fits to it.

Typically reality isn=E2=80=99t quite as beautiful and change can break your
model. They say about Lisp that it=E2=80=99s a snowball: You can keep adding
stuff to it and it always stays a snowball. That=E2=80=99s close to this be=
auty.
But Lisp is also full of car/cdr-namings and legacy you cannot shed,
even though you might want to.

You cannot reach-and-keep perfection in a changing world, you can only
try to limit the pain for users and stay close to something which feels
right.

Volatile projects do not work to limit the pain.

Stale projects do not try to stay close to ways that feel right in a
changing reality.

A good project needs to get as close as possible to a consensus (I=E2=80=99=
m not
saying compromise here, because that=E2=80=99s not what I mean =E2=80=94 th=
e goal is
something which unites both) between not being volatile and not becoming
stale.

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl38Jd8ACgkQE++NRSQD
w+vC8g/8CTt/lgrSap1zl00qvgCOBd3OIiabwzGWWP47FW/pQhQbhQ9Pq6+qs9Rv
2e5SOcPsA208rOz5acQrrEdzlj3XjM/1WFTmDtyu8mA7ROypQktV5Djy3oTGPPiN
WEScyzIAOsLI07rhineOr950JXlStuS2aN6gBUshbGThPBG4Qz+zLgBZ6F3/QPEb
2XKFMkeGS2dDBmWk/F9u4/liC6WWP7RPl1jZLUC5pxVRZvqUNnjM2TXeBmlv3ItG
LzQ5LriOUrZrUVE/xLE1NjjTbLlzzn3yL5yVh8NCt6KoAc9BkOg6yjk671YHaxj2
GHFTJHXWvY+sYGAp1+YIj6c1zYPfadMmbPx3SwftLcetv7zUxk4HPVZB9FwToLsk
Gw8ow1M2n5XBurufkpa2UzJ7leJSP+PH++EU0u8+hbTbpKwTNtkrlPmdPdk17lWp
uzumBs33Fzbzo7nBdkM7keTsqepNusq0KlLUmLQNJCYqYtELxsPSvYguFkr6XBzd
mp95vYi37V0rWLsrUW6xx8wYTz9WAYUgki2DKvD5ZuTdSO9AHCup5zTjIDdE+KV+
mgfSuKegHLa3yTUE1Z/C25GFicSyHLIU9seYs6cac8Hvv9MziD00osd8meCU+w0Q
fDV1xhQ9NRrkcKGtDTnAuosBkoA7EfMDRIbJ0245tGBUr3fVK82IswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd/CXfAAoJENzPDbMLwQVIVb4D/3ZHXk97
aeV6d0bwuvAic/Rbjg08RAx2gP4IOopHI+/TWL0O7dCv1OW6jDAW5k36iAGaJhD0
6lIrUPH+LvCbpI2buacb1O0PO13BLUAVLkFoteLRMJiaiM8Juvoz/W87mNkDEsVB
Ggtf5r3qKTGur+I8jnY5bavuGCEjTDKfk1Xh
=VZF0
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 20 Dec 2019 01:37:56 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 20:37:56 2019
Received: from localhost ([127.0.0.1]:45750 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii7Eq-00027u-2D
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 20:37:56 -0500
Received: from lists.gnu.org ([209.51.188.17]:50325)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1ii7Eo-00027m-8G
 for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 20:37:54 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:52072)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <arne_bab@HIDDEN>) id 1ii7Em-0001f3-1F
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 20:37:54 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.1 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RCVD_IN_DNSWL_LOW,URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <arne_bab@HIDDEN>) id 1ii7Ej-0004vk-Gq
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 20:37:51 -0500
Received: from mout.web.de ([217.72.192.78]:55899)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <arne_bab@HIDDEN>)
 id 1ii7Eh-0004qp-7W; Thu, 19 Dec 2019 20:37:47 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576805857;
 bh=7w/eR58ORNgTUn2UKFZHIdpOyqvKMi8eOlkXPcxLmJg=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=NBLVOlwp5hX/pC+py9K2nhZLNg50uowFtFX7by33teh1tBXxWMIAcUtTOo87Mhyg0
 LcFyMhwtS2vvkfMoswwAVBZLaVA5weI0zkw9QDOOpAo0FhPEMD5a7Tjw+M7vVDYhMT
 1VRWuA9XVBxiT0nSPY4gbdk5zz3jjOLYBbUjIqU0=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb102
 [213.165.67.124]) with ESMTPSA (Nemesis) id 0M0Qkb-1hoVFF2l4f-00uWx6; Fri, 20
 Dec 2019 02:37:36 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
 <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
Date: Fri, 20 Dec 2019 02:37:32 +0100
Message-ID: <87zhfn3hgj.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:EEV/ncBLKLDkEMpXo50zYYBcDHZnniIWm4RtS5RXqJ3lc9exlMO
 E5LNG7t8iV/Omt7rzvsvIeNPSL/EEyKCnaaKRAzjnjLS+fnWr49EwS3OV+AO9CHS/UHXL2T
 CU7Ir8ruv0ErsVIIaS0ivN1NaCjEaQkSlnanQUEQEgTocXPmj+M+GnyTpK+jL9Kz72R2FxJ
 5vm3IgD6qV6PJMCkAOFXg==
X-UI-Out-Filterresults: notjunk:1;V03:K0:JlQzMKPMkAE=:MTioK7hNa+0yyyvCQw6BaH
 ikWjaMpa0gsLENMif35BXje1gxqRNwfGoCp8iuESpH7Cz4tl5tBgHSjoXrdOIfhijCuNsKKW3
 3/r/c4U5p+LzyCVmqMy7wqNkXFV6e0IboZJHWk+WjXvenMbqIqv2LIPzhN00/vK0cew8gaHf7
 9RMxTU4YpGEkmWxsu58HDrmesVAEPRZbf23/ZDp1kckgsX/KCzjPXSc2vsb55ke2SckeWZXsM
 cQ9IcKyKZp8FIn+nan8ZbJfJ++GHAY+1LoXZgLEEazRUac/rWkmld/+Q6mUw1C90NqAzje1Ck
 TKAEjQTpbESb1xh1okHOp/d7+uQ3WtCPVRuf9IwYfGIylV02mJ8rdrSZsvthv4ZovvpGk6DxT
 tHPIXHlL+e3yz+hxzHD3MHMTuCO+l3LV4Sj4VEnZFCbQDeobxJRCvjlfn0YkGs2sUDU19V7Gp
 oaRgfyEdgBlklbpRyZUJKUBtAPzs6FKrb+SEecem7ycfQBDmLKKebUAnfN0u9v7t9/uER64Wk
 v7/OlVIc0kYX+2Jz88z809Ce81CtgBZHqy9lTZ4zd97XiWVuuAulJFPRA4Ltz0ZmvnYOEpWDB
 2DOKW3wWNoABxv8hENNX94Htzc3E1fawBh0q4RfHu3kXivhzPhOOAV0vs0JNQU5xkuMhqFtHo
 +wh5wLBhvbxgTz4b/QKGDye7+Yg9ZqGQnazIEhqYqxeFjqTVpU9PtnFZAd0Ttjx5fbAqx2bjh
 5A7KxPZaMxZhBij2EfwdA0EkjK2Qw3vo8m8SxtYAnqRNMnodtwtYjcE5/zuXF07MQK+x6WnhX
 AT9wHz+pyBaeMQeRRYYOLHuHS5TO9iFKVP1j48fji2gnnB3tIE/R7so9ENzen7sbfw6zDUEOt
 y5jLDqequg5h13JDcCLQPjopXm+mxVqhgEm8Xui8vDG99lWMqSou2rl0htMW5j51V3/CNa/D0
 WTKKzT0xOdCL6x9nXIdsuQiRDNWpegZUaAKM+6uAwaef8b4xWTRwwBYl13zWoSY+WZ6dXVRcp
 XaWNaHVLepg9IhShBEtzr7Z8MaLiBtY2C/XmmkIgrh7wZJIi8NAR3aauOtPiE+e1TSWepClXh
 sjS756Tm8QuZmVPgScNP/QlyZ+vsjiMuzkqlDziUSP5C1B3pPDyzVnD5In/dpP4e718DSV/U2
 fIwbKQk0vijm9WoPUqn2IO67JAXNRvtYjwzTmQxTjeKcNmGNbJ7TRIVz6HE/tPVhBGXP7ZQeq
 P7aDx7f1kcW7rReHQhPQbKWmgVJyotkhR0m/4KA==
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 217.72.192.78
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


zimoun <zimon.toutoune@HIDDEN> writes:
> First, have you read the proposal?

Yes.

> Or are you (maybe a bit) "overreacting" about the backward compatibility?

I don=E2=80=99t think so. I am definitely reacting strongly, but that=E2=80=
=99s because
breakages in Guix have already cost me the evenings of several weeks
this year.

But before I write anything more, I=E2=80=99d like to ask you to take a step
back to breathe.

We=E2=80=99re discussing a change in software. We disagree on the way forwa=
rd,
but I=E2=80=99m not attacking you as a person, and I hope it does not feel =
that
way to you.

If it does: This is not my intention. Please take a moment to sigh
deeply, shake your head, relax, and smile =E2=80=94 because that actually h=
elps.
It=E2=80=99s what I try to do when discussions get vexing.

I am grateful that you=E2=80=99re taking up improvements in Guix, and there=
 are
situations where viewpoints are different. That is OK.

>> This is taking this a bit too easy. If I can no longer pull, because
>> that breaks my Emacs or Gnome, then Guix is broken for me: I can no
>> longer update my system without first adjusting my config.
>
> So you expect that we would push a patch changing "guix environment"
> and in the same time break "guix pull, isn't it?

No, this is an example which shows that being able to roll back does not
mean that there is no problem with breaking the way forward. Using only
old versions is often not an option. Just imagine running audio software
from 5 years ago on a system that only provides pulseaudio (or whatever
will come after it). Imagine using an old KDE DCOP-based automation
workflow on a dbus-system. You need to update the libraries you use to
get it working at all.

>> > Hum? I am not convinced that the cost would be high... Because 1. the
>> > number of people using Guix is not so high (yet!), so 2. I am almost
>> > sure we can name the people using "guix environment" in scripts ;-).
>>
>> I=E2=80=99m not so sure. Guix is already used in scientific workflows, a=
nd there
>> is existing third-party documentation about using `guix environment`.
>
> Please point me where.
> It will save me time instead of reinventing the wheel.

It was mentioned on this list.

For the scientific workflows, see https://hpc.guix.info/

>> And can you name the people using `guix environment` by searching
>> backwards in their bash history?
>
> So what would break?
> Your workflow: spending 5 minutes to read the warning message and then pr=
essing:
> C-a GUIX_ENVIRONMENT_DEPRACATED=3D1 guix environment <your-complicated-in=
vokation>
>
> (unfair and bitter; sorry!)

I=E2=80=99m sorry that this makes you bitter. This is not my intention.

I=E2=80=99ll answer without bitterness: The original environment does not s=
pawn
instantly. It takes many minutes until it is ready. If I then have to go
back, find the warning (it=E2=80=99s likely that I=E2=80=99d miss it, becau=
se these are
things that work, and suddenly they break, which I=E2=80=99m likely to only
figure out when the followup steps don=E2=80=99t work) and run it again, th=
at
often means that I=E2=80=99m out of time to do what I actually wanted to do.

Despite that: Yes, this is a viable way. It is one of the less painful
ones. Maybe avoid calling it "DEPRECATED" and instead give it a more
descriptive name that does not imply that it will go away.

Mercurial uses HGPLAIN=3D1 to say "I want the version which will never
change established API". Best practice is to always use that in scripts
=E2=80=94 and that is a stable best practice. But this is also slow to rece=
ive
new features.

If the old way to use guix environment is intended to actually be legacy
only, then it could be a way forward to also provide
GUIX_ENVIRONMENT_STABLE=3D1 which gives an API that is guaranteed to never
change the meaning of options again *after the change that=E2=80=99s been
started to brew in 2017*.

That would be a purely append-only API then, and while it would break
once, it would prevent such changes for the future.

For PR it might be possible to state that with this change, guix
environment as a tool reaches version 0.99 (to be updated to 1.0 after
sufficient testing).

>> > And 3. the time to figure out what changed is really low -- especially
>> > with warnings and hints -- and "guix environment foo -- make" would
>> > return an error because of dependencies missing.
>>
>> It took me days to figure out the exact guix environment invocation that
>> allows me to build the tools for a paper I=E2=80=99m still working on. I=
f that
>> breaks, that causes massive anxiety, because I then don=E2=80=99t know w=
hether
>> I=E2=80=99ll find the time to fix it before I run into deadlines.
>
> Do you mean add GUIX_ENVIRONMENT_DEPRECATED=3D1 at the top of your script?

Yes, at every script. And remember to add it to every command I still
have in history.

>> > Other said, I do not see myself use-cases where the scripts using
>> > "guix environment" need to be robust for time-travelling -- the same
>> > script used with current, past and future Guix versions -- because as
>> > it was said elsewhere: "environment" can be seen like "temporary
>> > profile". And temporary means... well temporary. ;-)
>>
>> The same script must always work with future versions. Otherwise the
>> software is volatile.
>
> Here is the real argument.
>
> It is a point of view. I would like to ear the one of others.
> If I understand well, Konrad agrees with you.
>
> I am fine with: the same script must always work with future versions.
>
> It is a strong statement and if the Guix project agrees then it must
> be documented. For example in this section [1].
>
> What do you think?

Only if this is actually the stance of the whole Guix project.

Currently this is the argument given by one person in an email
discussion. I think that it is a strong and important argument
(otherwise I would not have made it), but I=E2=80=99ve been wrong before.

Maybe the change to Guix environment now is for the best of the project.
I cannot actually see so clearly into the future that I could say
whether the churn due to the breaking change or the annoyance due to
suboptimal default behavior will be worse.

> [1] http://guix.gnu.org/manual/devel/en/html_node/Managing-Software-the-G=
uix-Way.html#Managing-Software-the-Guix-Way
>
>
>> You don=E2=80=99t need to be able to go back in time, but the path forwa=
rd must
>> be without breakage.
>
> Talking about Reproducible Science, going back in time is the core
> issue. If one is able to go back in time and to run again the (almost)
> exact same version, then the future is not the issue.

The future is an issue, because you often have to use up-to-date
libraries. Just imagine using a rust-tool but being stuck in a 12 months
old environment that you cannot update without breakage.

> Correct me if I misunderstand your point.
> Today, I write a script using X tools at time T. In the future, I want
> to re-run this script so all the X tools must have a path forward
> without any breakage. It is your point, right? But this never happens,
> there is always a breakage somewhere; and generally for good reasons.

No, and that=E2=80=99s the point. That=E2=80=99s also the point of the arti=
cle: There
are tools which almost never break. And there are tools that almost
always break.

If you use a tool out of the latter group, you=E2=80=99re in for a world of
pain. It=E2=80=99s why it took years and years for somewhat stable git-wrap=
pers
to appear: The early wrappers that made git easier to use always broke
when git changed operation. Guix environment might actually help you
delay the update until you have time to deal with the breakage.

> Instead in this future, if I am able to restore the exact same X tools
> as they were at time T, my script still works.
>
> Well, this is another story.

This helps surviving volatility in other tools, but only if tool for
doing so isn=E2=80=99t volatile itself.

>> > Last, "volatile" vs "stable" is mitigated by "The future of 'guix
>> > environment'" [1] which really predates the 1.0. ;-)
>>
>> Yepp, but we=E2=80=99re after 1.0 now. This might have been a blocker fo=
r 1.0,
>> but it wasn=E2=80=99t.
>
> So if the version bump, it is not an issue then, isn't it?

It would still be an issue, but see the part about seeing into the
future above :-)

>> >> Also: Software developers should avoid traumatic changes
>> >>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html
>> >
>> > "Traumatic changes"? Maybe a bit extreme for the change we are talking=
 about...
>>
>> I don=E2=80=99t think so. There=E2=80=99s the strong version where it=E2=
=80=99s obvious: It
>> leads people to leave a project instantly.
>
> Yes, me!

Have a look at your reaction here. This is just the kind of reaction
people feel when something into which they invested time suddenly stops
working as expected.

>> There=E2=80=99s the weaker version which is less obvious: That=E2=80=99s=
 where people
>> who invested efford to follow best practices suddenly find their project
>> to be written in legacy style, because the best practices changed.
>
> Best practise depends on a lot of parameters. I did not know it was froze=
n.

If you manage to freeze the best practices without blocking ways into
the future, then you found part of the holy grail of software
development: You managed to find one fragment that=E2=80=99s so good that it
never needs to change again and everything new you do fits to it.

Typically reality isn=E2=80=99t quite as beautiful and change can break your
model. They say about Lisp that it=E2=80=99s a snowball: You can keep adding
stuff to it and it always stays a snowball. That=E2=80=99s close to this be=
auty.
But Lisp is also full of car/cdr-namings and legacy you cannot shed,
even though you might want to.

You cannot reach-and-keep perfection in a changing world, you can only
try to limit the pain for users and stay close to something which feels
right.

Volatile projects do not work to limit the pain.

Stale projects do not try to stay close to ways that feel right in a
changing reality.

A good project needs to get as close as possible to a consensus (I=E2=80=99=
m not
saying compromise here, because that=E2=80=99s not what I mean =E2=80=94 th=
e goal is
something which unites both) between not being volatile and not becoming
stale.

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl38Jd8ACgkQE++NRSQD
w+vC8g/8CTt/lgrSap1zl00qvgCOBd3OIiabwzGWWP47FW/pQhQbhQ9Pq6+qs9Rv
2e5SOcPsA208rOz5acQrrEdzlj3XjM/1WFTmDtyu8mA7ROypQktV5Djy3oTGPPiN
WEScyzIAOsLI07rhineOr950JXlStuS2aN6gBUshbGThPBG4Qz+zLgBZ6F3/QPEb
2XKFMkeGS2dDBmWk/F9u4/liC6WWP7RPl1jZLUC5pxVRZvqUNnjM2TXeBmlv3ItG
LzQ5LriOUrZrUVE/xLE1NjjTbLlzzn3yL5yVh8NCt6KoAc9BkOg6yjk671YHaxj2
GHFTJHXWvY+sYGAp1+YIj6c1zYPfadMmbPx3SwftLcetv7zUxk4HPVZB9FwToLsk
Gw8ow1M2n5XBurufkpa2UzJ7leJSP+PH++EU0u8+hbTbpKwTNtkrlPmdPdk17lWp
uzumBs33Fzbzo7nBdkM7keTsqepNusq0KlLUmLQNJCYqYtELxsPSvYguFkr6XBzd
mp95vYi37V0rWLsrUW6xx8wYTz9WAYUgki2DKvD5ZuTdSO9AHCup5zTjIDdE+KV+
mgfSuKegHLa3yTUE1Z/C25GFicSyHLIU9seYs6cac8Hvv9MziD00osd8meCU+w0Q
fDV1xhQ9NRrkcKGtDTnAuosBkoA7EfMDRIbJ0245tGBUr3fVK82IswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd/CXfAAoJENzPDbMLwQVIVb4D/3ZHXk97
aeV6d0bwuvAic/Rbjg08RAx2gP4IOopHI+/TWL0O7dCv1OW6jDAW5k36iAGaJhD0
6lIrUPH+LvCbpI2buacb1O0PO13BLUAVLkFoteLRMJiaiM8Juvoz/W87mNkDEsVB
Ggtf5r3qKTGur+I8jnY5bavuGCEjTDKfk1Xh
=VZF0
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 19 Dec 2019 22:49:16 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 17:49:16 2019
Received: from localhost ([127.0.0.1]:45701 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii4bc-0006TX-Kv
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:49:16 -0500
Received: from mail-qv1-f43.google.com ([209.85.219.43]:42750)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ii4bb-0006TJ-0C
 for 38529 <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:49:15 -0500
Received: by mail-qv1-f43.google.com with SMTP id dc14so2891630qvb.9
 for <38529 <at> debbugs.gnu.org>; Thu, 19 Dec 2019 14:49:14 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=jxzx6DzXLPth7bcITEmPguFPht9khJ5/CM7JookkBjE=;
 b=O3wNTVbw4zcnGKtv9qGqeptqhVtiQzt928PNR8gLb3DzRISBrTP5hoRtPn5uAlS9Q8
 kxw0KvTidDpDrVbWqUt48QJkID4nxmaI+xWhOFUdPlhlRGZgpsbI6s7PAlno18QsbbcM
 QC9/dfOgc2XkHuLehP6zia6tDepN+Jn7KAo7K5qzD+q1ySqksHZO+uXya6ERZ32C25EF
 P05+HXMbqMQ74cY5/K3ewp/PAgAnFVxvx11YSKde2XJBHQUCXeIgCIkKlu0aaRKhmzQb
 4NtF4orF7p7v21rJlkeATRLSgvUxBxQyOzhQMdyrHQpDFCIXu/vVuGL8J+7LVOweqni7
 ISUQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=jxzx6DzXLPth7bcITEmPguFPht9khJ5/CM7JookkBjE=;
 b=T6Em8lSGAN+GU/hXnLld726W/3l4nN7/wJyILYWGNbHRAKtj0uGaue3V5UKvk++B4w
 X0f5S73xxzvRkNQUSJJoboO9sZhdFt+6qdRrwWvk66SJEXTHuu+YxbK/3eZ6jfLP7Q3u
 NYy/kdix5+pdhfXfPAVtI6vDVF9DMfampMJrP/ELnqfJf3EqEGB2ff9X+uckVG5qJZHT
 rRANaYVZ22gJ0t//cfcmwsiDKeNyLTisvp6Lx3AlHC7vNwZyIgw6McbGtOZgcJXFhnW5
 VAebgrfrxWj+GSQR1niVNaBVrbX4rcPPWjLRvdkByHH232LAtXzJGhO1BezzQMKHFJD6
 S72g==
X-Gm-Message-State: APjAAAVsJxXJgI3AqnFHxF80N4/QbROPqbUPEy1KjFX8N1mbCAMzf//K
 vxE1ku+hozgRZNynPbc0RrP2Vo0RkIhZy4LCEVQ=
X-Google-Smtp-Source: APXvYqxSP8cUASZUG1+98js7iHLxqbT/pzpanZWgAvJ4Ix1I4PSd1+ilQLxlWakrYLeG4Gx/GjL10LBTxYInDBgNDJI=
X-Received: by 2002:a0c:ca06:: with SMTP id c6mr9805411qvk.74.1576795749539;
 Thu, 19 Dec 2019 14:49:09 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <87k16snuoz.fsf_-_@HIDDEN>
In-Reply-To: <87k16snuoz.fsf_-_@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 19 Dec 2019 23:48:58 +0100
Message-ID: <CAJ3okZ0chDu8M4VNn_Xuq55gZYO+oZdLoNT0_Ly-AimKJvrCrg@HIDDEN>
Subject: =?UTF-8?B?UmU6IERlcHJlY2F0aW5nIOKAmGd1aXggZW52aXJvbm1lbnTigJk/?=
To: =?UTF-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, Konrad Hinsen <konrad.hinsen@HIDDEN>,
 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

On Thu, 19 Dec 2019 at 17:31, Ludovic Court=C3=A8s <ludo@HIDDEN> wrote:

> The hard question then becomes: what do we call it?  I vote against
> abbreviations.  :-)

"guix shell"?



Cheers,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 19 Dec 2019 22:40:50 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 17:40:50 2019
Received: from localhost ([127.0.0.1]:45689 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii4TR-0006GP-PY
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:40:50 -0500
Received: from mail-qt1-f169.google.com ([209.85.160.169]:37585)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ii4TQ-0006G6-M5
 for 38529 <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:40:49 -0500
Received: by mail-qt1-f169.google.com with SMTP id w47so6478435qtk.4
 for <38529 <at> debbugs.gnu.org>; Thu, 19 Dec 2019 14:40:48 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=+ehepk2484gFuhzNPQYQvKZFfi9+Nk8MzaWVxGLs3mI=;
 b=k2yRArazh9zTP34D+ikw5FFLkT+/1n+qBUrjqSEFmTN2lO7htoEVfJUws80q0prkVp
 JYRuIU7rOk30BB+rFrcDOpNBvn5wG0Pf2BS3EU5Yid4gG07KRR1kTI79lYI6K66yeW/e
 l1Y/ZohwCSbYRA0ID0jb1I1G8yr4Oi2LCA+KcYePeXQzmdxLo/fPqmnwttFmBCVNTHWP
 B9t76P4YLNiThi4BtQScJFZ49j316Gv58h2GSs3Qi/aqZVljRY4t9TGQyu0fD40dSdef
 44nwjBj57xFZpzpOEoKBl67O7qEALt408Ur/4n5ogna5SFV6aswLgOn6ywFzkAlFBVQ+
 heCQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=+ehepk2484gFuhzNPQYQvKZFfi9+Nk8MzaWVxGLs3mI=;
 b=EkfWEECKC34Z3WRx40oM70ia7SZmeqr53cQZiqgp1jwUNV++drUhbDAS+IEU/OphJe
 rU+MzHKleWu4vWZsi2MnBCOsFtmMstpNCVlju9mt45HkgiZ39OQnoCbTKf43tufhazoh
 +IGdp8K8bLBjqQAe3B3jke+IauwPwoMafXnW9weJloMSywQRsx0Kn5Noh8aMAFgQ/wqp
 PDDcNfGG7J3AQyaH8z5aSJGf3xZkOZi3jGFEdHZcNtPdsT8ZkYpAJUn1xRTd5lQNiJ+X
 UqXgawvcUfPIj+YvaYrv656K1zI9I+agkslYyqeK0hkzPkH+/I6KTu/FDV9sfm2ZkFlR
 ywKw==
X-Gm-Message-State: APjAAAXQpWcCKRNEMjnRZW2RTth7hO66eb2GIAgeTMDbMQrBTvP54e4/
 sNdaUzrsvU0zteFtqw0lbOCRlVPAloBQnTKEfFx7kee/
X-Google-Smtp-Source: APXvYqzqXdH4uVcPuDJ1vPxOYVJ1xhxJhxeF2KhqfrgwSWxM/te3yWjDeKldhV4SRwFB2bu4gQ4Km4TRytxy12cTJFA=
X-Received: by 2002:ac8:1016:: with SMTP id z22mr9279864qti.217.1576795243078; 
 Thu, 19 Dec 2019 14:40:43 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
In-Reply-To: <871rt03shq.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 19 Dec 2019 23:40:31 +0100
Message-ID: <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Arne,

First, have you read the proposal?
Or are you (maybe a bit) "overreacting" about the backward compatibility?


On Thu, 19 Dec 2019 at 22:39, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> zimoun <zimon.toutoune@HIDDEN> writes:

> > Guix is not a volatile software and will never be. Because it is
> > rooted in time-travelling.
> > The tools "guix pull --commit=3D", "guix <command> --manifest=3D", "gui=
x
> > time-machine" or the "--roll-back" avoid to break what is currently
> > working.
>
> This is taking this a bit too easy. If I can no longer pull, because
> that breaks my Emacs or Gnome, then Guix is broken for me: I can no
> longer update my system without first adjusting my config.

So you expect that we would push a patch changing "guix environment"
and in the same time break "guix pull, isn't it?
Otherwise I do not see your argument.


> > Hum? I am not convinced that the cost would be high... Because 1. the
> > number of people using Guix is not so high (yet!), so 2. I am almost
> > sure we can name the people using "guix environment" in scripts ;-).
>
> I=E2=80=99m not so sure. Guix is already used in scientific workflows, an=
d there
> is existing third-party documentation about using `guix environment`.

Please point me where.
It will save me time instead of reinventing the wheel.


> And can you name the people using `guix environment` by searching
> backwards in their bash history?

So what would break?
Your workflow: spending 5 minutes to read the warning message and then pres=
sing:
C-a GUIX_ENVIRONMENT_DEPRACATED=3D1 guix environment <your-complicated-invo=
kation>

(unfair and bitter; sorry!)


> > And 3. the time to figure out what changed is really low -- especially
> > with warnings and hints -- and "guix environment foo -- make" would
> > return an error because of dependencies missing.
>
> It took me days to figure out the exact guix environment invocation that
> allows me to build the tools for a paper I=E2=80=99m still working on. If=
 that
> breaks, that causes massive anxiety, because I then don=E2=80=99t know wh=
ether
> I=E2=80=99ll find the time to fix it before I run into deadlines.

Do you mean add GUIX_ENVIRONMENT_DEPRECATED=3D1 at the top of your script?


> > Other said, I do not see myself use-cases where the scripts using
> > "guix environment" need to be robust for time-travelling -- the same
> > script used with current, past and future Guix versions -- because as
> > it was said elsewhere: "environment" can be seen like "temporary
> > profile". And temporary means... well temporary. ;-)
>
> The same script must always work with future versions. Otherwise the
> software is volatile.

Here is the real argument.

It is a point of view. I would like to ear the one of others.
If I understand well, Konrad agrees with you.

I am fine with: the same script must always work with future versions.

It is a strong statement and if the Guix project agrees then it must
be documented. For example in this section [1].

What do you think?


[1] http://guix.gnu.org/manual/devel/en/html_node/Managing-Software-the-Gui=
x-Way.html#Managing-Software-the-Guix-Way


> You don=E2=80=99t need to be able to go back in time, but the path forwar=
d must
> be without breakage.

Talking about Reproducible Science, going back in time is the core
issue. If one is able to go back in time and to run again the (almost)
exact same version, then the future is not the issue.

Correct me if I misunderstand your point.
Today, I write a script using X tools at time T. In the future, I want
to re-run this script so all the X tools must have a path forward
without any breakage. It is your point, right? But this never happens,
there is always a breakage somewhere; and generally for good reasons.
Instead in this future, if I am able to restore the exact same X tools
as they were at time T, my script still works.

Well, this is another story.



> > Last, "volatile" vs "stable" is mitigated by "The future of 'guix
> > environment'" [1] which really predates the 1.0. ;-)
>
> Yepp, but we=E2=80=99re after 1.0 now. This might have been a blocker for=
 1.0,
> but it wasn=E2=80=99t.

So if the version bump, it is not an issue then, isn't it?


> >> Also: Software developers should avoid traumatic changes
> >>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html
> >
> > "Traumatic changes"? Maybe a bit extreme for the change we are talking =
about...
>
> I don=E2=80=99t think so. There=E2=80=99s the strong version where it=E2=
=80=99s obvious: It
> leads people to leave a project instantly.

Yes, me!


> There=E2=80=99s the weaker version which is less obvious: That=E2=80=99s =
where people
> who invested efford to follow best practices suddenly find their project
> to be written in legacy style, because the best practices changed.

Best practise depends on a lot of parameters. I did not know it was frozen.



Well, I withdraw my investment. I am not interested anymore to not
tell that I am traumatized.


Regards,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Dec 2019 22:40:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 17:40:52 2019
Received: from localhost ([127.0.0.1]:45691 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii4TU-0006Ga-9U
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:40:52 -0500
Received: from lists.gnu.org ([209.51.188.17]:52501)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ii4TR-0006GJ-8J
 for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 17:40:49 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:38188)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ii4TP-0006Pm-DQ
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 17:40:49 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ii4TN-0007FK-5E
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 17:40:47 -0500
Received: from mail-qt1-x835.google.com ([2607:f8b0:4864:20::835]:39275)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <zimon.toutoune@HIDDEN>)
 id 1ii4TM-0007CO-3Y; Thu, 19 Dec 2019 17:40:44 -0500
Received: by mail-qt1-x835.google.com with SMTP id e5so6480098qtm.6;
 Thu, 19 Dec 2019 14:40:43 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=+ehepk2484gFuhzNPQYQvKZFfi9+Nk8MzaWVxGLs3mI=;
 b=k2yRArazh9zTP34D+ikw5FFLkT+/1n+qBUrjqSEFmTN2lO7htoEVfJUws80q0prkVp
 JYRuIU7rOk30BB+rFrcDOpNBvn5wG0Pf2BS3EU5Yid4gG07KRR1kTI79lYI6K66yeW/e
 l1Y/ZohwCSbYRA0ID0jb1I1G8yr4Oi2LCA+KcYePeXQzmdxLo/fPqmnwttFmBCVNTHWP
 B9t76P4YLNiThi4BtQScJFZ49j316Gv58h2GSs3Qi/aqZVljRY4t9TGQyu0fD40dSdef
 44nwjBj57xFZpzpOEoKBl67O7qEALt408Ur/4n5ogna5SFV6aswLgOn6ywFzkAlFBVQ+
 heCQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=+ehepk2484gFuhzNPQYQvKZFfi9+Nk8MzaWVxGLs3mI=;
 b=jdGFCW/1EgucNNpIrX0sRfTg0HsPyDvZ1dxKPUY/SzaRsDlPCw1a4xaWBNlE/8KPWK
 0LGtGiMkCZgV3/5hwuDfrHH6TwILock4nZjL0O1cowPNBR4dx59wgooP+id69QUE+qD3
 X9bCNa6TrYqrEDIq258/MelKN4VQ1RxfT3aV6X88d1+rj4J/TwIQgLOn1et4ug/nCiwf
 2Hw/PZbsyJGO9nn+AnQf/BQDZStu/RjqypFG90brEp2oKZ4jBFANYZPKztPmfByktctd
 oUEqwT3tg9prtqoRKbUjWtL2Nx0oov7aOXh5Eo5W/YK0PuPTMjoBX8FgF0mPbqHsm4HG
 nkAg==
X-Gm-Message-State: APjAAAWb1msLEuQdlaJ2iZGfiZ1FgbjLWopZ4IfUfigy6qjnsdxpk3iU
 zQYbtjBEo4y7JqwhLKjtNb/W9sWbPrMpBYO/jRE=
X-Google-Smtp-Source: APXvYqzqXdH4uVcPuDJ1vPxOYVJ1xhxJhxeF2KhqfrgwSWxM/te3yWjDeKldhV4SRwFB2bu4gQ4Km4TRytxy12cTJFA=
X-Received: by 2002:ac8:1016:: with SMTP id z22mr9279864qti.217.1576795243078; 
 Thu, 19 Dec 2019 14:40:43 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
 <871rt03shq.fsf@HIDDEN>
In-Reply-To: <871rt03shq.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 19 Dec 2019 23:40:31 +0100
Message-ID: <CAJ3okZ3gwpjy2cgRj1iOtPX0cTSVBLoxSVaUBxnMEsMCVNUyFg@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2607:f8b0:4864:20::835
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi Arne,

First, have you read the proposal?
Or are you (maybe a bit) "overreacting" about the backward compatibility?


On Thu, 19 Dec 2019 at 22:39, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> zimoun <zimon.toutoune@HIDDEN> writes:

> > Guix is not a volatile software and will never be. Because it is
> > rooted in time-travelling.
> > The tools "guix pull --commit=3D", "guix <command> --manifest=3D", "gui=
x
> > time-machine" or the "--roll-back" avoid to break what is currently
> > working.
>
> This is taking this a bit too easy. If I can no longer pull, because
> that breaks my Emacs or Gnome, then Guix is broken for me: I can no
> longer update my system without first adjusting my config.

So you expect that we would push a patch changing "guix environment"
and in the same time break "guix pull, isn't it?
Otherwise I do not see your argument.


> > Hum? I am not convinced that the cost would be high... Because 1. the
> > number of people using Guix is not so high (yet!), so 2. I am almost
> > sure we can name the people using "guix environment" in scripts ;-).
>
> I=E2=80=99m not so sure. Guix is already used in scientific workflows, an=
d there
> is existing third-party documentation about using `guix environment`.

Please point me where.
It will save me time instead of reinventing the wheel.


> And can you name the people using `guix environment` by searching
> backwards in their bash history?

So what would break?
Your workflow: spending 5 minutes to read the warning message and then pres=
sing:
C-a GUIX_ENVIRONMENT_DEPRACATED=3D1 guix environment <your-complicated-invo=
kation>

(unfair and bitter; sorry!)


> > And 3. the time to figure out what changed is really low -- especially
> > with warnings and hints -- and "guix environment foo -- make" would
> > return an error because of dependencies missing.
>
> It took me days to figure out the exact guix environment invocation that
> allows me to build the tools for a paper I=E2=80=99m still working on. If=
 that
> breaks, that causes massive anxiety, because I then don=E2=80=99t know wh=
ether
> I=E2=80=99ll find the time to fix it before I run into deadlines.

Do you mean add GUIX_ENVIRONMENT_DEPRECATED=3D1 at the top of your script?


> > Other said, I do not see myself use-cases where the scripts using
> > "guix environment" need to be robust for time-travelling -- the same
> > script used with current, past and future Guix versions -- because as
> > it was said elsewhere: "environment" can be seen like "temporary
> > profile". And temporary means... well temporary. ;-)
>
> The same script must always work with future versions. Otherwise the
> software is volatile.

Here is the real argument.

It is a point of view. I would like to ear the one of others.
If I understand well, Konrad agrees with you.

I am fine with: the same script must always work with future versions.

It is a strong statement and if the Guix project agrees then it must
be documented. For example in this section [1].

What do you think?


[1] http://guix.gnu.org/manual/devel/en/html_node/Managing-Software-the-Gui=
x-Way.html#Managing-Software-the-Guix-Way


> You don=E2=80=99t need to be able to go back in time, but the path forwar=
d must
> be without breakage.

Talking about Reproducible Science, going back in time is the core
issue. If one is able to go back in time and to run again the (almost)
exact same version, then the future is not the issue.

Correct me if I misunderstand your point.
Today, I write a script using X tools at time T. In the future, I want
to re-run this script so all the X tools must have a path forward
without any breakage. It is your point, right? But this never happens,
there is always a breakage somewhere; and generally for good reasons.
Instead in this future, if I am able to restore the exact same X tools
as they were at time T, my script still works.

Well, this is another story.



> > Last, "volatile" vs "stable" is mitigated by "The future of 'guix
> > environment'" [1] which really predates the 1.0. ;-)
>
> Yepp, but we=E2=80=99re after 1.0 now. This might have been a blocker for=
 1.0,
> but it wasn=E2=80=99t.

So if the version bump, it is not an issue then, isn't it?


> >> Also: Software developers should avoid traumatic changes
> >>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html
> >
> > "Traumatic changes"? Maybe a bit extreme for the change we are talking =
about...
>
> I don=E2=80=99t think so. There=E2=80=99s the strong version where it=E2=
=80=99s obvious: It
> leads people to leave a project instantly.

Yes, me!


> There=E2=80=99s the weaker version which is less obvious: That=E2=80=99s =
where people
> who invested efford to follow best practices suddenly find their project
> to be written in legacy style, because the best practices changed.

Best practise depends on a lot of parameters. I did not know it was frozen.



Well, I withdraw my investment. I am not interested anymore to not
tell that I am traumatized.


Regards,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 19 Dec 2019 21:39:27 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 16:39:27 2019
Received: from localhost ([127.0.0.1]:45614 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii3W3-0004jH-0D
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 16:39:27 -0500
Received: from mout.web.de ([212.227.17.11]:51851)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1ii3W0-0004j4-Ff
 for 38529 <at> debbugs.gnu.org; Thu, 19 Dec 2019 16:39:25 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576791557;
 bh=N3U9uNOsNmyB0nXVK5/O8PmrMQoLcvt4g7XEpf3LjL4=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=DRt+SJacF+yk3XjMvx3oIerh3J6Td+X738IdXHgPo6pqbvdKEEcwrB4QnnrK0bNow
 6hrsuFeYcJcD+5grw9ojIyX5HIOSrxLaOxMDXH9E9HkXqjPEzPQ2y6nR2fsU7L+Pii
 LLuEumbAVx3jnpOGHpk+/CjZLz5WcSPsL78FCHyg=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb102
 [213.165.67.124]) with ESMTPSA (Nemesis) id 0MVcdn-1iBEWw0C5P-00Yxlz; Thu, 19
 Dec 2019 22:39:17 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
Date: Thu, 19 Dec 2019 22:39:13 +0100
Message-ID: <871rt03shq.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:JfifoonhvfdwLLBS00M57V+RXyAvKT7cNzpyhuonq6ADveu28LI
 grENkCU7iDca3blFZ8wAknCHd5KornKxNDlPSQaDGqbfHiMDn4M1L+2VA7I6qANL7dpV95i
 VA0zMbfbTpzKuKtBwriU7m+7deRFeZxfBTmvUh3bSXeKrSAey+RxSDdHIRH9/aFNAOfX+ii
 475Y5uAELg4k1gQedA/LA==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:qbzDh18zGjw=:dafAQ5kgc7nFnoH47fxe29
 c2ahPJ80LZ9PAMutNASf1zh+1gtlK9gVXnmNK8dZ4vHxF6pz02ZvRRc16nt2eHBgZ8/siH96E
 WVr6o8bhhF3/49/z0auwISiQiypQ+2iFJaJpvoOfC9oyO0xEK3bEUN9wLilSJJZCWC9CzQMEH
 t3qDIsK2SC13U38ApezLOkCozeYJqlNDjQ0/9J3BC2/TK4GpGqcw3aUPUHdoAjOPF8VlF0Mem
 sfOsjgUNMIc8SEiE5q28HEBtsxj0O6u5X15b09SC6tZogTIDQ1ZsRi1aRRFFFer9E34gJ+TWa
 C1eGu+rkRAJYQjBZIjniutdEW2CNJVsSENHWeSD4H1YbxrIi6WiZmcBKod3tmDYSz8L6Ayst9
 +s1U6wdZuNr5gQMygKE4cCLcvb7pOVerrFg6vnIsGugt6Ob/yIyv8FLQFfa+DI8/paHEIvD9B
 ragoxZpF8y63nTeeaPR0nqIseXdutnTUp5xfve3j+/RnxUW3T/eS2q57WH1Zn+Z0MS1ImnpuZ
 bPL6zjKwLClQi8oK0s5lro5dSq2Zy0npeweog0j0PFBr0YBLyFYx0xPsviJbkzpQq+ATdi1WZ
 Z/T1dDW7mw4wjFKD6uCflJ5UY3LxI2QD1BfZ6rBR8vw4Iys8H7hCNgWXZVw39grEy7vbDWSyJ
 xs/uAl3mRGP41LO2LF74pV3y/cWHauZdewA9+SKRTNgsfLVZKZXE97Xlooj60Tx76wsdh9mI3
 EP8rYoFdXnq86Zl+1W5i8oUAdrF72H7+F2I/ceNlYFMfEBq5E8Dfn8MexQ5nPmcmPfCzfNR5O
 BHrXUg9Cew5tcNpJuYvr95ZqDPjBPF/KvWuoaxt2zJxDoxzNrSWy+1DgHEGgNG7DDKd5herM/
 iGJAgnBSyGOO20n7Rh3GCNRRuhYRWSxUVUd5TEYW2g5VWBR8Hc5AFQCrckQlEhOd3QzJQZGEh
 +hm+5fkKmSSIRSDnB738PYrZ9iIDVoVtJN4POPh8rDggI9PNNxovd/7FR2gRbKsO6KlJCZGUM
 Hdpt9FByFjlyhBucdceENE6FWKNipNqhAiXHqEO0TRXmzlye4LyMT6uX/bjJujy4WpLLKrSDg
 E1bngCT1aN30ZEIjyrdr0u0wZw5nMNWXbN8Vh6E7OfU2HxBmms7YAOs7VwKJT2ESp62zs9yyS
 awi1Z2+haAF1jguEEHDDyuR61Gygfn977VHXmYylmcRe9WxR2+Pgf6pX/PVFsgRN/3HVSTxKm
 u8VkhiSp6BApB+moMdnaCeT+rCg8leUuZTrHk1w==
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi zimoun,

zimoun <zimon.toutoune@HIDDEN> writes:

>>      Should Guix be volatile software?
>>      http://stevelosh.com/blog/2012/04/volatile-software/
>
> Guix is not a volatile software and will never be. Because it is
> rooted in time-travelling.
> The tools "guix pull --commit=3D", "guix <command> --manifest=3D", "guix
> time-machine" or the "--roll-back" avoid to break what is currently
> working.

This is taking this a bit too easy. If I can no longer pull, because
that breaks my Emacs or Gnome, then Guix is broken for me: I can no
longer update my system without first adjusting my config.

> Number of people         Time it takes each person
> using that part of   X   to figure out what changed
> the program              and how to fix it
>
> Hum? I am not convinced that the cost would be high... Because 1. the
> number of people using Guix is not so high (yet!), so 2. I am almost
> sure we can name the people using "guix environment" in scripts ;-).

I=E2=80=99m not so sure. Guix is already used in scientific workflows, and =
there
is existing third-party documentation about using `guix environment`.

And can you name the people using `guix environment` by searching
backwards in their bash history?

> And 3. the time to figure out what changed is really low -- especially
> with warnings and hints -- and "guix environment foo -- make" would
> return an error because of dependencies missing.

It took me days to figure out the exact guix environment invocation that
allows me to build the tools for a paper I=E2=80=99m still working on. If t=
hat
breaks, that causes massive anxiety, because I then don=E2=80=99t know whet=
her
I=E2=80=99ll find the time to fix it before I run into deadlines.

> Other said, I do not see myself use-cases where the scripts using
> "guix environment" need to be robust for time-travelling -- the same
> script used with current, past and future Guix versions -- because as
> it was said elsewhere: "environment" can be seen like "temporary
> profile". And temporary means... well temporary. ;-)

The same script must always work with future versions. Otherwise the
software is volatile.

You don=E2=80=99t need to be able to go back in time, but the path forward =
must
be without breakage.

> Then, the section "The Tradeoff" advices "from newmodule import
> new_foo as foo" and IMO it is what the plan proposes with the variable
> GUIX_ENVIRONMENT_DEPRECATED (tricky point #4).

No, that=E2=80=99s the opposite: from newmodule import new_foo as foo means,
that you allow users to define an environment variable called
`GUIX_ENVIRONMENT_MODERN`.

> Last, "volatile" vs "stable" is mitigated by "The future of 'guix
> environment'" [1] which really predates the 1.0. ;-)

Yepp, but we=E2=80=99re after 1.0 now. This might have been a blocker for 1=
.0,
but it wasn=E2=80=99t.

>> Also: Software developers should avoid traumatic changes
>>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html
>
> "Traumatic changes"? Maybe a bit extreme for the change we are talking ab=
out...

I don=E2=80=99t think so. There=E2=80=99s the strong version where it=E2=80=
=99s obvious: It
leads people to leave a project instantly.

There=E2=80=99s the weaker version which is less obvious: That=E2=80=99s wh=
ere people
who invested efford to follow best practices suddenly find their project
to be written in legacy style, because the best practices changed.

> Well, at the end, what is explicitly your personal opinion?
>  a. Change the behaviour of "guix environment" using the proposed plan?
> or
>  b. Add a new command? Which one? "guix shell", "guix env" or "guix
> <you-name-it>"?

I would opt for b. And then for changing guix to give the most common
commands when called without argument (as `guix`) =E2=80=94 excluding
guix environment.

That would not avoid the slow version of traumatic changes, but if
guix environment would keep working and both guix env/guix shell/=E2=80=A6 =
and
guix environment used the same backend (just with different options),
then they would be minimized, because guix environment would not become
a second-class citizen.

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl377gMACgkQE++NRSQD
w+tujBAAxS1DE0VL+KlggoUcM1PXzAVqmznzZOn3/M24/n2tCWCiK7QfXBOCK3dt
QXSYpoozIV2ZHdjc8UpM6Y+xwr+WnJrQsvQAIKOwDT7Dzxa4RHsNV9PmFHOxyJFM
as7t4XxYfXJrp48n6baF/xywvrMcWe0L2F8x1e2PF0SXrHKMwb+cg+k0pE0H+02z
5n1fd4O6VetyPa3U0XQGcmMqqxDaPY7kfXCA+daqry4/T/F6xli0T9NOBK1C/a4I
IQP+YenYlyzKKXTCiZ+0mm6/vx+hGQzvkmGPDYsFsUTvz10dGLEBDoZOTHECcWVN
guYEHNDpItMrt/JueN4x7MXwV6eclviaIo8rHMIg1UO4F81KjRwN2Ejr4T46+utX
6uvE0k5QPH6Ol01sHDBvfNvC/XztGgN0BJtmsMn5CtbhQx1BWHbNrNVbJIY4Fzev
5fBwB7psKG4yDpb58xtgs84PbN5gAK3jW31brOGrTprYpPoQQxxIluXd02vk7j6T
/qNroGg3H3W1Q4hHEPCBdtJVAF2lAylCDraPo9eU4j/+odrQDMqB2ISfGbO69xQe
LVMvM0UaGVuf4LJfk0rED4eppm9sib0KjgE5Fdy3W9ur/hS94WIBO6XqC6w/35UG
WP9wMGDZGWY+donOfO3JZWSmzbjncsUhHJ32bXm6FlN/MWvkM8eIswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd++4DAAoJENzPDbMLwQVIPHAD/0ozQwSH
Xe6qMlZHPs8FDOqXxcX+3onf+Kir9UVQuxUl+jnJTh5FL9vlWvdRb5yk7vKXnY7D
2eZ5x68w3Y4sdl9hma+CiFit+M4H5vKQhOGpNTgKHllnVGJ5DFM96V8b4TZR9J3r
vr49IjXgbsWP6X+KCE2rULP+YjjzmiCcJIk7
=pDkB
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Dec 2019 21:39:32 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 16:39:32 2019
Received: from localhost ([127.0.0.1]:45617 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ii3W8-0004ja-Ep
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 16:39:32 -0500
Received: from lists.gnu.org ([209.51.188.17]:59663)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1ii3W7-0004jT-0Y
 for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 16:39:31 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:40198)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <arne_bab@HIDDEN>) id 1ii3W5-0000HV-DJ
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 16:39:30 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.1 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RCVD_IN_DNSWL_LOW,URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <arne_bab@HIDDEN>) id 1ii3W3-0008E3-C1
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 16:39:28 -0500
Received: from mout.web.de ([212.227.17.11]:60827)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <arne_bab@HIDDEN>)
 id 1ii3W2-000877-P0; Thu, 19 Dec 2019 16:39:27 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576791557;
 bh=N3U9uNOsNmyB0nXVK5/O8PmrMQoLcvt4g7XEpf3LjL4=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=DRt+SJacF+yk3XjMvx3oIerh3J6Td+X738IdXHgPo6pqbvdKEEcwrB4QnnrK0bNow
 6hrsuFeYcJcD+5grw9ojIyX5HIOSrxLaOxMDXH9E9HkXqjPEzPQ2y6nR2fsU7L+Pii
 LLuEumbAVx3jnpOGHpk+/CjZLz5WcSPsL78FCHyg=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb102
 [213.165.67.124]) with ESMTPSA (Nemesis) id 0MVcdn-1iBEWw0C5P-00Yxlz; Thu, 19
 Dec 2019 22:39:17 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
 <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
Date: Thu, 19 Dec 2019 22:39:13 +0100
Message-ID: <871rt03shq.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:JfifoonhvfdwLLBS00M57V+RXyAvKT7cNzpyhuonq6ADveu28LI
 grENkCU7iDca3blFZ8wAknCHd5KornKxNDlPSQaDGqbfHiMDn4M1L+2VA7I6qANL7dpV95i
 VA0zMbfbTpzKuKtBwriU7m+7deRFeZxfBTmvUh3bSXeKrSAey+RxSDdHIRH9/aFNAOfX+ii
 475Y5uAELg4k1gQedA/LA==
X-UI-Out-Filterresults: notjunk:1;V03:K0:qbzDh18zGjw=:dafAQ5kgc7nFnoH47fxe29
 c2ahPJ80LZ9PAMutNASf1zh+1gtlK9gVXnmNK8dZ4vHxF6pz02ZvRRc16nt2eHBgZ8/siH96E
 WVr6o8bhhF3/49/z0auwISiQiypQ+2iFJaJpvoOfC9oyO0xEK3bEUN9wLilSJJZCWC9CzQMEH
 t3qDIsK2SC13U38ApezLOkCozeYJqlNDjQ0/9J3BC2/TK4GpGqcw3aUPUHdoAjOPF8VlF0Mem
 sfOsjgUNMIc8SEiE5q28HEBtsxj0O6u5X15b09SC6tZogTIDQ1ZsRi1aRRFFFer9E34gJ+TWa
 C1eGu+rkRAJYQjBZIjniutdEW2CNJVsSENHWeSD4H1YbxrIi6WiZmcBKod3tmDYSz8L6Ayst9
 +s1U6wdZuNr5gQMygKE4cCLcvb7pOVerrFg6vnIsGugt6Ob/yIyv8FLQFfa+DI8/paHEIvD9B
 ragoxZpF8y63nTeeaPR0nqIseXdutnTUp5xfve3j+/RnxUW3T/eS2q57WH1Zn+Z0MS1ImnpuZ
 bPL6zjKwLClQi8oK0s5lro5dSq2Zy0npeweog0j0PFBr0YBLyFYx0xPsviJbkzpQq+ATdi1WZ
 Z/T1dDW7mw4wjFKD6uCflJ5UY3LxI2QD1BfZ6rBR8vw4Iys8H7hCNgWXZVw39grEy7vbDWSyJ
 xs/uAl3mRGP41LO2LF74pV3y/cWHauZdewA9+SKRTNgsfLVZKZXE97Xlooj60Tx76wsdh9mI3
 EP8rYoFdXnq86Zl+1W5i8oUAdrF72H7+F2I/ceNlYFMfEBq5E8Dfn8MexQ5nPmcmPfCzfNR5O
 BHrXUg9Cew5tcNpJuYvr95ZqDPjBPF/KvWuoaxt2zJxDoxzNrSWy+1DgHEGgNG7DDKd5herM/
 iGJAgnBSyGOO20n7Rh3GCNRRuhYRWSxUVUd5TEYW2g5VWBR8Hc5AFQCrckQlEhOd3QzJQZGEh
 +hm+5fkKmSSIRSDnB738PYrZ9iIDVoVtJN4POPh8rDggI9PNNxovd/7FR2gRbKsO6KlJCZGUM
 Hdpt9FByFjlyhBucdceENE6FWKNipNqhAiXHqEO0TRXmzlye4LyMT6uX/bjJujy4WpLLKrSDg
 E1bngCT1aN30ZEIjyrdr0u0wZw5nMNWXbN8Vh6E7OfU2HxBmms7YAOs7VwKJT2ESp62zs9yyS
 awi1Z2+haAF1jguEEHDDyuR61Gygfn977VHXmYylmcRe9WxR2+Pgf6pX/PVFsgRN/3HVSTxKm
 u8VkhiSp6BApB+moMdnaCeT+rCg8leUuZTrHk1w==
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 212.227.17.11
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable

Hi zimoun,

zimoun <zimon.toutoune@HIDDEN> writes:

>>      Should Guix be volatile software?
>>      http://stevelosh.com/blog/2012/04/volatile-software/
>
> Guix is not a volatile software and will never be. Because it is
> rooted in time-travelling.
> The tools "guix pull --commit=3D", "guix <command> --manifest=3D", "guix
> time-machine" or the "--roll-back" avoid to break what is currently
> working.

This is taking this a bit too easy. If I can no longer pull, because
that breaks my Emacs or Gnome, then Guix is broken for me: I can no
longer update my system without first adjusting my config.

> Number of people         Time it takes each person
> using that part of   X   to figure out what changed
> the program              and how to fix it
>
> Hum? I am not convinced that the cost would be high... Because 1. the
> number of people using Guix is not so high (yet!), so 2. I am almost
> sure we can name the people using "guix environment" in scripts ;-).

I=E2=80=99m not so sure. Guix is already used in scientific workflows, and =
there
is existing third-party documentation about using `guix environment`.

And can you name the people using `guix environment` by searching
backwards in their bash history?

> And 3. the time to figure out what changed is really low -- especially
> with warnings and hints -- and "guix environment foo -- make" would
> return an error because of dependencies missing.

It took me days to figure out the exact guix environment invocation that
allows me to build the tools for a paper I=E2=80=99m still working on. If t=
hat
breaks, that causes massive anxiety, because I then don=E2=80=99t know whet=
her
I=E2=80=99ll find the time to fix it before I run into deadlines.

> Other said, I do not see myself use-cases where the scripts using
> "guix environment" need to be robust for time-travelling -- the same
> script used with current, past and future Guix versions -- because as
> it was said elsewhere: "environment" can be seen like "temporary
> profile". And temporary means... well temporary. ;-)

The same script must always work with future versions. Otherwise the
software is volatile.

You don=E2=80=99t need to be able to go back in time, but the path forward =
must
be without breakage.

> Then, the section "The Tradeoff" advices "from newmodule import
> new_foo as foo" and IMO it is what the plan proposes with the variable
> GUIX_ENVIRONMENT_DEPRECATED (tricky point #4).

No, that=E2=80=99s the opposite: from newmodule import new_foo as foo means,
that you allow users to define an environment variable called
`GUIX_ENVIRONMENT_MODERN`.

> Last, "volatile" vs "stable" is mitigated by "The future of 'guix
> environment'" [1] which really predates the 1.0. ;-)

Yepp, but we=E2=80=99re after 1.0 now. This might have been a blocker for 1=
.0,
but it wasn=E2=80=99t.

>> Also: Software developers should avoid traumatic changes
>>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html
>
> "Traumatic changes"? Maybe a bit extreme for the change we are talking ab=
out...

I don=E2=80=99t think so. There=E2=80=99s the strong version where it=E2=80=
=99s obvious: It
leads people to leave a project instantly.

There=E2=80=99s the weaker version which is less obvious: That=E2=80=99s wh=
ere people
who invested efford to follow best practices suddenly find their project
to be written in legacy style, because the best practices changed.

> Well, at the end, what is explicitly your personal opinion?
>  a. Change the behaviour of "guix environment" using the proposed plan?
> or
>  b. Add a new command? Which one? "guix shell", "guix env" or "guix
> <you-name-it>"?

I would opt for b. And then for changing guix to give the most common
commands when called without argument (as `guix`) =E2=80=94 excluding
guix environment.

That would not avoid the slow version of traumatic changes, but if
guix environment would keep working and both guix env/guix shell/=E2=80=A6 =
and
guix environment used the same backend (just with different options),
then they would be minimized, because guix environment would not become
a second-class citizen.

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl377gMACgkQE++NRSQD
w+tujBAAxS1DE0VL+KlggoUcM1PXzAVqmznzZOn3/M24/n2tCWCiK7QfXBOCK3dt
QXSYpoozIV2ZHdjc8UpM6Y+xwr+WnJrQsvQAIKOwDT7Dzxa4RHsNV9PmFHOxyJFM
as7t4XxYfXJrp48n6baF/xywvrMcWe0L2F8x1e2PF0SXrHKMwb+cg+k0pE0H+02z
5n1fd4O6VetyPa3U0XQGcmMqqxDaPY7kfXCA+daqry4/T/F6xli0T9NOBK1C/a4I
IQP+YenYlyzKKXTCiZ+0mm6/vx+hGQzvkmGPDYsFsUTvz10dGLEBDoZOTHECcWVN
guYEHNDpItMrt/JueN4x7MXwV6eclviaIo8rHMIg1UO4F81KjRwN2Ejr4T46+utX
6uvE0k5QPH6Ol01sHDBvfNvC/XztGgN0BJtmsMn5CtbhQx1BWHbNrNVbJIY4Fzev
5fBwB7psKG4yDpb58xtgs84PbN5gAK3jW31brOGrTprYpPoQQxxIluXd02vk7j6T
/qNroGg3H3W1Q4hHEPCBdtJVAF2lAylCDraPo9eU4j/+odrQDMqB2ISfGbO69xQe
LVMvM0UaGVuf4LJfk0rED4eppm9sib0KjgE5Fdy3W9ur/hS94WIBO6XqC6w/35UG
WP9wMGDZGWY+donOfO3JZWSmzbjncsUhHJ32bXm6FlN/MWvkM8eIswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd++4DAAoJENzPDbMLwQVIPHAD/0ozQwSH
Xe6qMlZHPs8FDOqXxcX+3onf+Kir9UVQuxUl+jnJTh5FL9vlWvdRb5yk7vKXnY7D
2eZ5x68w3Y4sdl9hma+CiFit+M4H5vKQhOGpNTgKHllnVGJ5DFM96V8b4TZR9J3r
vr49IjXgbsWP6X+KCE2rULP+YjjzmiCcJIk7
=pDkB
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 19 Dec 2019 16:31:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 11:31:34 2019
Received: from localhost ([127.0.0.1]:45452 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihyi5-0005eS-SX
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 11:31:34 -0500
Received: from eggs.gnu.org ([209.51.188.92]:35182)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1ihyi5-0005eD-0G
 for 38529 <at> debbugs.gnu.org; Thu, 19 Dec 2019 11:31:33 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:36142)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1ihyhy-0007oa-F1; Thu, 19 Dec 2019 11:31:27 -0500
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=44774 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1ihyhx-0006WV-Sb; Thu, 19 Dec 2019 11:31:26 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Subject: Deprecating =?utf-8?Q?=E2=80=98guix_environment=E2=80=99=3F?=
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 29 Frimaire an 228 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Thu, 19 Dec 2019 17:31:24 +0100
In-Reply-To: <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN> (Konrad
 Hinsen's message of "Tue, 17 Dec 2019 07:49:21 +0100")
Message-ID: <87k16snuoz.fsf_-_@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: guix-devel@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hi Konrad,

Konrad Hinsen <konrad.hinsen@HIDDEN> skribis:

> On 16/12/2019 23:09, Ludovic Court=C3=A8s wrote:
>> So in a more algorithmic manner:
>>> 1. if ad-hoc and inputs-of is present at the same invocation: fail
>>> hard. (With an error like incompatible options present)
>>> 2. if only ad-hoc is present, then print a deprecation warning (yes,
>>> we could make this suspendable with an environment variable, like you
>>> described)
>>> 3. if only inputs-of present, then do the new behaviour.
>>> 4. if neither ad-hoc nor inputs-of present then
>>>    a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
>>>    b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
>>> new behaviour.
>> That sounds like a good plan to me.
>>
>> #4 is the trickiest, and I think it=E2=80=99d be good to give users a bi=
t of
>> time so they can start adjusting before deprecation is in effect.
>
> #4 is trickiest for another reason: there is no future-proof use of
> "guix environment" that works right now and will continue to work. Nor
> is there any way to see, when looking at a command line, whether it's
> old-style or new-style, if neither --ad-hoc nor --inputs-of are
> present. This means that all existing documentation (tutorials etc.)
> will become misleading in the future. Worse, even documentation
> written today, in full awareness of a coming change, can't do better
> than saying "watch out, this will do something else in the future".
>
> The first rule of backwards-compatibility is: never change the meaning
> of an existing valid command/API. Add new valid syntax, deprecate old
> valid syntax, but don't change the meaning of something that was and
> will be valid.

Yeah.

Clearly there=E2=80=99s a tension between that and keeping Guix open to cha=
nges.

> How about a more drastic measure: deprecate "guix environment" and
> introduce a new subcommand with the desired new behaviour?

That has the advantage of avoiding the problem you mention altogether
while also allowing for further changes.

The hard question then becomes: what do we call it?  I vote against
abbreviations.  :-)

Also, what other goals would we set for that command?  How would we
frame it in the set of commands?

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 19 Dec 2019 11:30:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 06:30:33 2019
Received: from localhost ([127.0.0.1]:44325 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihu0n-0002Qx-6a
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 06:30:33 -0500
Received: from mail-qv1-f53.google.com ([209.85.219.53]:45367)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ihu0l-0002Qd-40
 for 38529 <at> debbugs.gnu.org; Thu, 19 Dec 2019 06:30:31 -0500
Received: by mail-qv1-f53.google.com with SMTP id l14so2056798qvu.12
 for <38529 <at> debbugs.gnu.org>; Thu, 19 Dec 2019 03:30:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=sBxHxU3hrgyhV7XSTBtBf2RDjbLtRVFIElMqxwkOG1A=;
 b=MbVuaJtEVYJDhZY904Bf6EN5KTUqbRKlc7PUZey/Q9cCWsX0KXdnqLPQCH6zzxEqRd
 hpuA4vknGHw+lIi5JjgLDouBRCoIovHLlaS149/PZ27Kh8tp47rKmf0YKgCPhGKTAudL
 JjNofbgDii6EWq6MIjEKBeuRZEcE5GT4wRh9hxK2/ooP7G1+YxyBkIE+Y3SdzY8TS8eS
 0BCEGb/breFwWCFndqok2jXEuaXfg7jMCUZwCw17O/BWq884PJ6UKc+enNdyDA2dwHhX
 1GvwdreVkXaLeHTLU8uzfAqXlPC1/OYKC2T4DIHXXLUY0DqjTcj9bENq1lD1fepVt/wu
 kA3Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=sBxHxU3hrgyhV7XSTBtBf2RDjbLtRVFIElMqxwkOG1A=;
 b=X7v966PPzItnALH3C3aV5JJfYylgWTgqiFqETz5Vw3B0Nu6y5wml5K8j4ucmVy+lqt
 Gthu3gbaDLy5VmV7Kg7S0HE0enxjTUCPokuiAAmMVe/B8xvW964YTS+yvqKDwf1dj0Hp
 5J/SRsAKgUY9SHl4RJXlk1viqucqfcYc/YiGk1Z3FVh/zFmqWwuNa54td2D0+s41PYdC
 iqMh3P2moT8X66aqDs060fGYglpufY75GeMH7QMZi9jmkkjlNCDKaxOtMHt3ada9RCGT
 hwH5D/Uqh/9ni3Ts52DklwzOT9pyZQDCU8yp14iOd/il6CIVa4mVR/ETADP9jjiD1XHO
 ksOA==
X-Gm-Message-State: APjAAAXvAs5QGCJJuvU8usfcyvOanyqe8tpZc4UAkHVzBpFjYh7X1T2M
 JcZRpchjnD7NicdMFCzK2apxYojf0zVcTv1XSw4=
X-Google-Smtp-Source: APXvYqwF9jHV+vrPjXo7cDy9BY+3bab9G7jpTf1wnPXB0skk1pX9u7pUQKSY+DXf91iI/K7qi1cGpI5FCidV6vPh4SY=
X-Received: by 2002:a05:6214:3a1:: with SMTP id
 m1mr6790436qvy.77.1576755025485; 
 Thu, 19 Dec 2019 03:30:25 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
In-Reply-To: <87zhfp2w11.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 19 Dec 2019 12:30:14 +0100
Message-ID: <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Arne,

Thank you for the pointers.


On Wed, 18 Dec 2019 at 21:55, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> Konrad Hinsen <konrad.hinsen@HIDDEN> writes:

> >> Maybe I miss a point. It is not: "watch out, this will do something
> >> else in the future" but "watch out, this was doing something else in
> >> the past and the change happened the <date> in <commit>".
> >
> > Concrete example: I am writing a tutorial about using Guix for
> > reproducible research. It shows several uses of "guix environment", som=
e
> > of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my e=
xamples will
> > cease to work in a few months. What am I supposed to do about this?
>
> This is the point where we need to ask ourselves:
>
>      Should Guix be volatile software?
>      http://stevelosh.com/blog/2012/04/volatile-software/

Guix is not a volatile software and will never be. Because it is
rooted in time-travelling.
The tools "guix pull --commit=3D", "guix <command> --manifest=3D", "guix
time-machine" or the "--roll-back" avoid to break what is currently
working.
Well, the section "The situation" just cannot(*) happen with Guix.
That's why Guix is awesome! ;-)

(*) well if one correctly uses Guix which is another story ;-)
and it is not perfect yet... see all the discussion about manifest. :-)


Now, let recall the formula (already discussed in this thread :-))

Number of people         Time it takes each person
using that part of   X   to figure out what changed
the program              and how to fix it

Hum? I am not convinced that the cost would be high... Because 1. the
number of people using Guix is not so high (yet!), so 2. I am almost
sure we can name the people using "guix environment" in scripts ;-).
And 3. the time to figure out what changed is really low -- especially
with warnings and hints -- and "guix environment foo -- make" would
return an error because of dependencies missing.

Other said, I do not see myself use-cases where the scripts using
"guix environment" need to be robust for time-travelling -- the same
script used with current, past and future Guix versions -- because as
it was said elsewhere: "environment" can be seen like "temporary
profile". And temporary means... well temporary. ;-)

Then, the section "The Tradeoff" advices "from newmodule import
new_foo as foo" and IMO it is what the plan proposes with the variable
GUIX_ENVIRONMENT_DEPRECATED (tricky point #4).

Last, "volatile" vs "stable" is mitigated by "The future of 'guix
environment'" [1] which really predates the 1.0. ;-)

[1] https://lists.gnu.org/archive/html/guix-devel/2017-08/msg00300.html


As I said, I am not convinced by the argument: everything would be
broken, too much time to fix the break, etc. and this proposal would
lead to disaster for the end-user. But it is my opinion based on my
restricted personal experience.


> Also: Software developers should avoid traumatic changes
>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html

"Traumatic changes"? Maybe a bit extreme for the change we are talking abou=
t...



Well, at the end, what is explicitly your personal opinion?
 a. Change the behaviour of "guix environment" using the proposed plan?
or
 b. Add a new command? Which one? "guix shell", "guix env" or "guix
<you-name-it>"?


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 19 Dec 2019 11:30:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 19 06:30:33 2019
Received: from localhost ([127.0.0.1]:44323 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihu0m-0002Qv-Oh
	for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 06:30:33 -0500
Received: from lists.gnu.org ([209.51.188.17]:56194)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ihu0k-0002Qh-4E
 for submit <at> debbugs.gnu.org; Thu, 19 Dec 2019 06:30:31 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:39733)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ihu0i-0007P2-L5
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 06:30:29 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ihu0h-0002au-3T
 for bug-guix@HIDDEN; Thu, 19 Dec 2019 06:30:28 -0500
Received: from mail-qv1-xf35.google.com ([2607:f8b0:4864:20::f35]:39261)
 by eggs.gnu.org with esmtps (TLS1.0:RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <zimon.toutoune@HIDDEN>)
 id 1ihu0g-0002W0-RM; Thu, 19 Dec 2019 06:30:26 -0500
Received: by mail-qv1-xf35.google.com with SMTP id y8so2076477qvk.6;
 Thu, 19 Dec 2019 03:30:26 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=sBxHxU3hrgyhV7XSTBtBf2RDjbLtRVFIElMqxwkOG1A=;
 b=MbVuaJtEVYJDhZY904Bf6EN5KTUqbRKlc7PUZey/Q9cCWsX0KXdnqLPQCH6zzxEqRd
 hpuA4vknGHw+lIi5JjgLDouBRCoIovHLlaS149/PZ27Kh8tp47rKmf0YKgCPhGKTAudL
 JjNofbgDii6EWq6MIjEKBeuRZEcE5GT4wRh9hxK2/ooP7G1+YxyBkIE+Y3SdzY8TS8eS
 0BCEGb/breFwWCFndqok2jXEuaXfg7jMCUZwCw17O/BWq884PJ6UKc+enNdyDA2dwHhX
 1GvwdreVkXaLeHTLU8uzfAqXlPC1/OYKC2T4DIHXXLUY0DqjTcj9bENq1lD1fepVt/wu
 kA3Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=sBxHxU3hrgyhV7XSTBtBf2RDjbLtRVFIElMqxwkOG1A=;
 b=YGtSzyTNuIutJiH8X5gOCUDOkBnZ+u/QhunekXxoQRBwvf5KTbd4TdIVPYuyQ9YbcC
 UXr2ksEU1ObmjXVyjm0nxZlghu88DpwvXjUKVZBWSYJlZnJcSA6gZPuZq5zthx8fSxsI
 dRTj/tXIajiniTKJFbGCnx6hzpShsVA64NHQJzPtMrk3AXbf0zTU5kg0/AwDjCEwbgXn
 AGqjVxuaRwsQ9jTJkVmWqgnEFbcaIM6bAlYSZabhNwXcvgvy4EZVptDjOpjJal11tESg
 /us43yOffBsI4jsUbE57HHNtBBoWDQMyVD0+MC2t1BD/5uNivTwiWdoYmwiwcPYAjig8
 nEsA==
X-Gm-Message-State: APjAAAVka0C9Ledtrur6xL6fl/TKBIsFybqaU7mrxCDk4v0bhXRqMCA4
 VSvYHRHSbWAYUQuVGGqAlXi04lN5ageKgMTcU1E=
X-Google-Smtp-Source: APXvYqwF9jHV+vrPjXo7cDy9BY+3bab9G7jpTf1wnPXB0skk1pX9u7pUQKSY+DXf91iI/K7qi1cGpI5FCidV6vPh4SY=
X-Received: by 2002:a05:6214:3a1:: with SMTP id
 m1mr6790436qvy.77.1576755025485; 
 Thu, 19 Dec 2019 03:30:25 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN> <87zhfp2w11.fsf@HIDDEN>
In-Reply-To: <87zhfp2w11.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 19 Dec 2019 12:30:14 +0100
Message-ID: <CAJ3okZ3bHnOzOk2Cdtvh_NZbYGDfA+zzxrAsJk+7=gRYHaL7jw@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Arne Babenhauserheide <arne_bab@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
 recognized.
X-Received-From: 2607:f8b0:4864:20::f35
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, bug-guix@HIDDEN, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

Hi Arne,

Thank you for the pointers.


On Wed, 18 Dec 2019 at 21:55, Arne Babenhauserheide <arne_bab@HIDDEN> wrote=
:

> Konrad Hinsen <konrad.hinsen@HIDDEN> writes:

> >> Maybe I miss a point. It is not: "watch out, this will do something
> >> else in the future" but "watch out, this was doing something else in
> >> the past and the change happened the <date> in <commit>".
> >
> > Concrete example: I am writing a tutorial about using Guix for
> > reproducible research. It shows several uses of "guix environment", som=
e
> > of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my e=
xamples will
> > cease to work in a few months. What am I supposed to do about this?
>
> This is the point where we need to ask ourselves:
>
>      Should Guix be volatile software?
>      http://stevelosh.com/blog/2012/04/volatile-software/

Guix is not a volatile software and will never be. Because it is
rooted in time-travelling.
The tools "guix pull --commit=3D", "guix <command> --manifest=3D", "guix
time-machine" or the "--roll-back" avoid to break what is currently
working.
Well, the section "The situation" just cannot(*) happen with Guix.
That's why Guix is awesome! ;-)

(*) well if one correctly uses Guix which is another story ;-)
and it is not perfect yet... see all the discussion about manifest. :-)


Now, let recall the formula (already discussed in this thread :-))

Number of people         Time it takes each person
using that part of   X   to figure out what changed
the program              and how to fix it

Hum? I am not convinced that the cost would be high... Because 1. the
number of people using Guix is not so high (yet!), so 2. I am almost
sure we can name the people using "guix environment" in scripts ;-).
And 3. the time to figure out what changed is really low -- especially
with warnings and hints -- and "guix environment foo -- make" would
return an error because of dependencies missing.

Other said, I do not see myself use-cases where the scripts using
"guix environment" need to be robust for time-travelling -- the same
script used with current, past and future Guix versions -- because as
it was said elsewhere: "environment" can be seen like "temporary
profile". And temporary means... well temporary. ;-)

Then, the section "The Tradeoff" advices "from newmodule import
new_foo as foo" and IMO it is what the plan proposes with the variable
GUIX_ENVIRONMENT_DEPRECATED (tricky point #4).

Last, "volatile" vs "stable" is mitigated by "The future of 'guix
environment'" [1] which really predates the 1.0. ;-)

[1] https://lists.gnu.org/archive/html/guix-devel/2017-08/msg00300.html


As I said, I am not convinced by the argument: everything would be
broken, too much time to fix the break, etc. and this proposal would
lead to disaster for the end-user. But it is my opinion based on my
restricted personal experience.


> Also: Software developers should avoid traumatic changes
>       https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html

"Traumatic changes"? Maybe a bit extreme for the change we are talking abou=
t...



Well, at the end, what is explicitly your personal opinion?
 a. Change the behaviour of "guix environment" using the proposed plan?
or
 b. Add a new command? Which one? "guix shell", "guix env" or "guix
<you-name-it>"?


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 18 Dec 2019 21:01:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 18 16:01:21 2019
Received: from localhost ([127.0.0.1]:44005 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihgRd-0002Rv-Kk
	for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 16:01:21 -0500
Received: from lists.gnu.org ([209.51.188.17]:41946)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1ihgRc-0002Rn-Op
 for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 16:01:21 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:33203)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <arne_bab@HIDDEN>) id 1ihgRb-0000hs-FC
 for bug-guix@HIDDEN; Wed, 18 Dec 2019 16:01:20 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.8 required=5.0 tests=BAYES_50,FREEMAIL_FROM,
 RCVD_IN_DNSWL_NONE,URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <arne_bab@HIDDEN>) id 1ihgRa-0005Ys-0J
 for bug-guix@HIDDEN; Wed, 18 Dec 2019 16:01:19 -0500
Received: from mout.web.de ([212.227.15.4]:58355)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_128_CBC_SHA1:16)
 (Exim 4.71) (envelope-from <arne_bab@HIDDEN>)
 id 1ihgRZ-0005XY-9X; Wed, 18 Dec 2019 16:01:17 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576702874;
 bh=MPpsGOnmrxpNZuqzoAQHBNLOfq7v30QnT7att8msEDw=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=dXTphbxdXX8wPrfV32D3Njb5AdV/di24MMamexHmQp+eEub+9sO0UV7EKQV9P0YCl
 430cgv3EgSqjbBzNdVT1Q5/HnRYWfMCuQcAYp4rEbgSZDfEJ5e9YSbMe9TvI8oPX8x
 Yg1DJQG+yi1CJHiBe+aat3tZlF8twGiOzNCgIZbc=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb001
 [213.165.67.108]) with ESMTPSA (Nemesis) id 0Lx77p-1hbihb2SVN-016fRe; Wed, 18
 Dec 2019 21:55:58 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: bug-guix@HIDDEN
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <m1pngmrmst.fsf@HIDDEN>
Date: Wed, 18 Dec 2019 21:55:54 +0100
Message-ID: <87zhfp2w11.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:Pc2Z4LeKQRdzuEDJDIj4OhHUFe5+1XZdsUbSLzVM6v2RlInQJZj
 nsqMuHquWb8n4GPdlly6L3AfcwD3GboCvk1PhtHxMazxfRmX0LKeV0Ii2c8mlK8K57OUko9
 GGsCoW0Vj4pasz3ZE0kyGPRTAdJH3QJCdABwKWkDrx2qCm1h2NFsslwW8jxtuwPfZFTxtb6
 TgxCbVlH3OEFvNxgMg35Q==
X-UI-Out-Filterresults: notjunk:1;V03:K0:OxQbEDFHe+w=:SZvN0rUIn3d9hguhONDXtX
 n5vMwLSKizaILIuFlUPr/bYd9iEwZgAyx+qtB5ZAr7UE6nIq+LEvcMds2mqdcmoInuK/b1ye3
 vm3p9UQgCrEhKVjq2nSJsa1AWXdOmGZSvquT7tGnJ4hLg1tjtDGjkX0X8/R/Hqv8eY/iKH9i7
 Ve6yjG4Dreg8Or0JfHr3A5UUmNEp4ZlLQMIXaVXrUvfAVYAz4NrNNA+94NZkwLVFX6TPd4fqb
 jUmx7wVzAuGTC2idXjRTw1D+YpkdfQ+XWjgB+HhTSJ8WXumOOoBgp8ZMK7vpU98qxURu2ntTw
 SJDtgxIlxHSQ75RTWCfpoUpX67iw+CcyAeJJPufwF1+WGrkif4zfkZDIexQS+H/Fw7Hx8ftWh
 53WaTj4bCz44fzeOG7ZRh1F5HxoEdFkmudNrEfwUE3Cn9uqPzA4K8H5uPiCZVHpe5xn91GI58
 gvUnZ/DNJVT4e47rsNEMXStY8nu1Ueu1uo13oOV/WUnI/Y7pLNFbhby7XK31W85MakPopNUtR
 oGWOMJQRkIal6qxYqLXQneBS49Yh1cxbHzpKqQXCCwTHJORlVyw4YyS4JfhD6Xbb0u3AaYA4F
 2yaCBvWwjtWXWT1zeCOGxm7GQuf95AMK+awtIkWpKJKf5fOtFMeQufa/cgNXP0pQfN6BBB5fp
 lnZQLaqbMnERtD8GWqik7nToOv8Ihd2CBO2YtJ0Q4zlM06OfhaIbQG49sf/UFtNyTorsNXKTl
 2+W3ojnLDQ15waxoKYCOSZ6cKlYGQS0NGOruKVk03w6j6dBjgwEI+pcGtVeWWUfEzJTtZe6cu
 6feiI+Zn22WTklQ9EcgyxKnM7O6w7ShtGUK9MmYGAad6RKrwN9I+Kv6NgiaFImOImgOc93cNM
 cLD/17WqVQ3qCyJnK/Sb8lJ/hDmw6tBIuw7ZmXkMvZ8wbQm7XIvKHynXJg66fP6QJql9lUsE9
 2Gb6XlL/P95lIpE3vBokR2yni+gb0EhhypNqO1yGEelGBw4Gg86w92s9V6qbkBf4h0+qErHtL
 d+qhxOt2adOQrymwvOwlr4XMSiLoHK1fRob8bgqsOqQxrGL0er08emhRGY39h6UecnBrgTDWa
 +91kZVKgFL/m51f6iKqpubv9IMH5PeDGxs/SkD301I/oKxL4YIVQiwCGp7SomqXlakWa6bIAJ
 /0MF8id40D6LjYL6UpGxT+mEzg/0B3/pmw+VJH4M/u8eqehlqI4s5RE1VfZXexj/y+j9Itong
 iKHtPN2eqbS2t+I4rRTMnRmgnAPtPfax971sjCA==
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 212.227.15.4
X-Spam-Score: -1.4 (-)
X-Debbugs-Envelope-To: submit
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.4 (--)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Konrad Hinsen <konrad.hinsen@HIDDEN> writes:

> Hi Simon,
>
>> Maybe I miss a point. It is not: "watch out, this will do something
>> else in the future" but "watch out, this was doing something else in
>> the past and the change happened the <date> in <commit>".
>
> Concrete example: I am writing a tutorial about using Guix for
> reproducible research. It shows several uses of "guix environment", some
> of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my exa=
mples will
> cease to work in a few months. What am I supposed to do about this?

This is the point where we need to ask ourselves:

     Should Guix be volatile software?
     http://stevelosh.com/blog/2012/04/volatile-software/

Also: Software developers should avoid traumatic changes
      https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl36klwACgkQE++NRSQD
w+un/BAAm1Rm9x6XcSRau9mYwQhxcVFORqZNvPZAUQVixI3vBfoJ7UHig8Abbh26
oNdAkCLIUsZ4nQ8p7d9Ev8v17uOyvuw+8j+eiK9BgrmjXpd0f7cjuDuDTIX0QNBE
eXmncUDdG3CWnZ5Fa7jcNnGb6ANicnoCIhcTw3eMBCXS/CrqXGw7zIgIpwIUOKnS
IpS0RJTnb5rklJE6i5Y1XSAGYeYaMtQZfOnSn23ITgMqd/+ZEM8QojG8j5WKMRch
K0VE0p/1l7k0bL6elYcHVAyaCsUWILPJIH+pnYPt4hSQSBbgudZRcvdfVWJ+WXg8
fzCKaLKPaA0ZA1W+MLpeLqca4jn1ekpi3OzaDyvwp32FhaxSBbO+DdPuvA103bbZ
tmMV6PuBz7Pa9NsnRdH41NQlG7oFuo2+L2mEvkxwUYKabt0ge5kap/n7PXsATTew
X4I/jk4ugugUJBM5CJ47t1TleTq5UCk/fo76dlLkm0vFgaxWM7bSJKb/t1d1Ds4n
n0spHHSo61qMUrynj9LvgEDMHKCWDcDd/irLdwqRe+DpptayH/VH+4j8nwobX01z
BExhaU5hEjOhpSD80OE2feq2NQPWtezLjt+7r9veHzM8595iA4PQ7lsxMEWHDmmZ
tXJyA56Hn7HdW5ClIRaw9yiGHbQ7dDigkZg+lYJQbOh4b6YStiOIswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd+pJcAAoJENzPDbMLwQVIJoUD/05tDaFA
3KwZaT6Adz1/aQ5/3y9JTM3mOPVlD+ykvqupk4q/1flx96on9QNey5ZTAvF4wpqx
hphFLMl5qrkLGBpS7JosVu6eoqdBMy90PnxK1bTlJ6S3jpRjvJ8eHZwc7K8l+JX+
xJJ3GFodP8hzlHKApIprazykI3R72unqGhZS
=KV24
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 18 Dec 2019 20:56:08 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 18 15:56:08 2019
Received: from localhost ([127.0.0.1]:44002 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihgMZ-0002IW-W4
	for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 15:56:08 -0500
Received: from mout.web.de ([212.227.15.14]:57013)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <arne_bab@HIDDEN>) id 1ihgMY-0002Hy-4D
 for 38529 <at> debbugs.gnu.org; Wed, 18 Dec 2019 15:56:06 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=web.de;
 s=dbaedf251592; t=1576702558;
 bh=MPpsGOnmrxpNZuqzoAQHBNLOfq7v30QnT7att8msEDw=;
 h=X-UI-Sender-Class:References:From:To:Cc:Subject:In-reply-to:Date;
 b=r6ssi5zfFY1uoHp8heqmcMCaBU5s5hhsebYHcKqzY6yS/FIpOpc1cZ971d0Ar/OOV
 vSgEMP4cjywPNO39SQbzHhfKTyt9ju9v20A+z0pW0lb21MJCChD5WQ16nxzHffokFn
 arNbcOzjjUXQO338izD8VOA3emlCYINJtb/s2Gx0=
X-UI-Sender-Class: c548c8c5-30a9-4db5-a2e7-cb6cb037b8f9
Received: from fluss ([84.165.17.138]) by smtp.web.de (mrweb001
 [213.165.67.108]) with ESMTPSA (Nemesis) id 0Lx77p-1hbihb2SVN-016fRe; Wed, 18
 Dec 2019 21:55:58 +0100
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
User-agent: mu4e 1.2.0; emacs 26.1
From: Arne Babenhauserheide <arne_bab@HIDDEN>
To: bug-guix@HIDDEN
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-reply-to: <m1pngmrmst.fsf@HIDDEN>
Date: Wed, 18 Dec 2019 21:55:54 +0100
Message-ID: <87zhfp2w11.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-Provags-ID: V03:K1:Pc2Z4LeKQRdzuEDJDIj4OhHUFe5+1XZdsUbSLzVM6v2RlInQJZj
 nsqMuHquWb8n4GPdlly6L3AfcwD3GboCvk1PhtHxMazxfRmX0LKeV0Ii2c8mlK8K57OUko9
 GGsCoW0Vj4pasz3ZE0kyGPRTAdJH3QJCdABwKWkDrx2qCm1h2NFsslwW8jxtuwPfZFTxtb6
 TgxCbVlH3OEFvNxgMg35Q==
X-Spam-Flag: NO
X-UI-Out-Filterresults: notjunk:1;V03:K0:QpOUEejU7Hk=:2Pyve2R1jpG9dDzVFpmyj/
 P4zuLaPX/Jy9ConmgnRgBwSAWvTbRAYbi1aV8V5yrZWmz0HgkFjWzMUUvOGdF6geDJdxlKMoi
 8LIUu+poZCjn4lnAdZxT/aKS+3iAjrDZHRurrAyNQENbh6suVc/g+IK9ck44LpT1F7jqSwZ+m
 waoLIdpqpiWIiYBENJ1ph2YqtQRKL3KK6IGUOn6iXUIfQkNs89xCCtxWySXdDG6U/fLL0f/U5
 poIFD2ia1avQxiVPVIFTFN8BiTHwSVkmnz0+nseYsfkMSvi25jafQwoINH+19KWJGnkaPOrC0
 KIpAJKFz6BCXNdIGNOcZuxO+78lGDAEO99V2HeB7M+hSdyPR/TgtFFnfMI3fcG3z0qJ/npOL/
 p/ZUULtErwZteTRcIGNdx/Q3LdxdvZvYAeYI+5I2vFLXBmvR95NDigyN+8nLt/v7I4DnogDSV
 6YTzo36gzXuynO7+hKzXQp0jQRBY4y2GsGiQrXWUkwGK4wfejGWXLC5BTrLHtYqUoklEFT8N+
 QJPEJ394ylCpm+CarVFMsOlF6s61Lyq7/tmEZr4lqhIabrviSmUOuq8tEOJEPz7wPjhuRhkzc
 TEkSq/WXrSDsAhBqyXImDqx5Tih78n5p/K1FoLihSILGRjmU5KYKKtES7fW6I6SPuCJbEa0B3
 BIOD+pDeiIFUaxzvZuUmyyNFFtRGHgNjvc5DRTknj0XSoxF7uQPlvWtbBUVvKhwXV6B1SKOT6
 v/xcgGUkolHTvBpq+ezQH07MeAHStJnAXn7NFOZfN/ydsUb6kvpWztHFniwys/OGY1e8fQ76z
 4jTGVfzwEw8FLetErWfb3WzyCKBDDQvhZ8dL1k7TnmXXQDKrDUSXUipN6HjVGk+d2lk3ToGwN
 kWvxZypjSvEnn3M0GNcTdEyxWcrSjCEBmIe48T2Uye/T81RemZwKVQFvMEucV9f4OtjI7Fz3W
 qsZ0u1doBM7uouII82MtypxvR3cDpUtZ3ttbvLEgslenHHwcF0iCdx9vj194+W7wEWbN6zRt1
 hEzNSH0SkfJKbb0B5SBksMy8ka1CxxNoILN9CDAA2240gBa0zZUr3vdq/hFdTM2MNubCGTSfP
 YoQ5nY59oPM7tdQXuZoaJuIVQ6vpZkFCP6mTQEbut4uFVKy9Amz+lSp+1TOWcal/B3gsCMTI8
 Chtwr6Xb3TNE5l7KF8kWYLO6rk8CRGHCeQ38frzXLFDTJldMiv4Xiu1B0nPWvZNKL4h7/dxcS
 MXoaRZUwJ6BRoUBoMe+sIw8JS55qcpTm91W9pJw==
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--=-=-=
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable


Konrad Hinsen <konrad.hinsen@HIDDEN> writes:

> Hi Simon,
>
>> Maybe I miss a point. It is not: "watch out, this will do something
>> else in the future" but "watch out, this was doing something else in
>> the past and the change happened the <date> in <commit>".
>
> Concrete example: I am writing a tutorial about using Guix for
> reproducible research. It shows several uses of "guix environment", some
> of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my exa=
mples will
> cease to work in a few months. What am I supposed to do about this?

This is the point where we need to ask ourselves:

     Should Guix be volatile software?
     http://stevelosh.com/blog/2012/04/volatile-software/

Also: Software developers should avoid traumatic changes
      https://drewdevault.com/2019/11/26/Avoid-traumatic-changes.html

Best wishes,
Arne
=2D-
Unpolitisch sein
hei=C3=9Ft politisch sein
ohne es zu merken

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQIzBAEBCAAdFiEE801qEjXQSQPNItXAE++NRSQDw+sFAl36klwACgkQE++NRSQD
w+un/BAAm1Rm9x6XcSRau9mYwQhxcVFORqZNvPZAUQVixI3vBfoJ7UHig8Abbh26
oNdAkCLIUsZ4nQ8p7d9Ev8v17uOyvuw+8j+eiK9BgrmjXpd0f7cjuDuDTIX0QNBE
eXmncUDdG3CWnZ5Fa7jcNnGb6ANicnoCIhcTw3eMBCXS/CrqXGw7zIgIpwIUOKnS
IpS0RJTnb5rklJE6i5Y1XSAGYeYaMtQZfOnSn23ITgMqd/+ZEM8QojG8j5WKMRch
K0VE0p/1l7k0bL6elYcHVAyaCsUWILPJIH+pnYPt4hSQSBbgudZRcvdfVWJ+WXg8
fzCKaLKPaA0ZA1W+MLpeLqca4jn1ekpi3OzaDyvwp32FhaxSBbO+DdPuvA103bbZ
tmMV6PuBz7Pa9NsnRdH41NQlG7oFuo2+L2mEvkxwUYKabt0ge5kap/n7PXsATTew
X4I/jk4ugugUJBM5CJ47t1TleTq5UCk/fo76dlLkm0vFgaxWM7bSJKb/t1d1Ds4n
n0spHHSo61qMUrynj9LvgEDMHKCWDcDd/irLdwqRe+DpptayH/VH+4j8nwobX01z
BExhaU5hEjOhpSD80OE2feq2NQPWtezLjt+7r9veHzM8595iA4PQ7lsxMEWHDmmZ
tXJyA56Hn7HdW5ClIRaw9yiGHbQ7dDigkZg+lYJQbOh4b6YStiOIswQBAQgAHRYh
BN0ovebZh1yrzkqLHdzPDbMLwQVIBQJd+pJcAAoJENzPDbMLwQVIJoUD/05tDaFA
3KwZaT6Adz1/aQ5/3y9JTM3mOPVlD+ykvqupk4q/1flx96on9QNey5ZTAvF4wpqx
hphFLMl5qrkLGBpS7JosVu6eoqdBMy90PnxK1bTlJ6S3jpRjvJ8eHZwc7K8l+JX+
xJJ3GFodP8hzlHKApIprazykI3R72unqGhZS
=KV24
-----END PGP SIGNATURE-----
--=-=-=--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 18 Dec 2019 13:09:54 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 18 08:09:54 2019
Received: from localhost ([127.0.0.1]:42753 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihZ5O-0000kX-By
	for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 08:09:54 -0500
Received: from mail-qk1-f175.google.com ([209.85.222.175]:37601)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ihZ5M-0000kL-CJ
 for 38529 <at> debbugs.gnu.org; Wed, 18 Dec 2019 08:09:52 -0500
Received: by mail-qk1-f175.google.com with SMTP id 21so1487456qky.4
 for <38529 <at> debbugs.gnu.org>; Wed, 18 Dec 2019 05:09:52 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=x6imS9hbsEwFJK4DusfWns4LxpBZbSm1s4DGF6nkAlI=;
 b=jMa3TwSSnpXc3PdeDYegqpuHhiSLS1wifpgTKlmJTwWCJNnHRsR5NUIemyb19MUaEA
 HjYAfT07pnRBH/Lv+c82XBmLuao+sW0lNarRli2mfarCJvi0hNCksiuYabmNn6x0fi9C
 HZMAgIrsHiqFANBk39ChKXqY/3Op0Zv4FMEvkkPY0uKLYH9rOUpljVjyaEoSHBHzbrxJ
 y1a787kNMJh8F2j9S069SiCxi6vDW9SaqRVV8I/O024CapBTWDWkzGMUDny1NlNQAASu
 dlFswdNwXT608SboibTUUH4RFH0Mc7rNSNq5dTYFeq9tbN5vfmSSNW8qyDj+Vf/9rdb/
 yNyQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=x6imS9hbsEwFJK4DusfWns4LxpBZbSm1s4DGF6nkAlI=;
 b=CaS9AdMT5Neo947f/e8ZQQstK2pb7j18HCAMCjb5Nbs7nz9pQ2vNHMgmB3sLgN59nn
 owsGH/xAu+S7AyHHLDG5EVSrxm+bKajkv1f9+26BaM8sIEUsEJc0Fn9oZ+VdKveUdABT
 9D2sCgCTVvzOLIiZkQKuKp8Fg+jPsDZKUhk/upPZyYoR1qvfAQtGxwdkJ6JS6+u/BjwE
 u0rVSuuvKXM9i4N38xg+SkLtknKeJwohvuYdnukhf3Fg+IqLxrf59I96sQ4v0RUv+HbW
 cdoUyiAtSXOj9HMyUgAsib+KHT7xaSBg9RIbjNmNGp8zbk5IK/Cxc4GT5vUbiEjpoboE
 lmAw==
X-Gm-Message-State: APjAAAU7nH+DtoIzdXnSnroSfNnYhYncghxZ9Q4/wpvRuQUMAofEwVxB
 muPLpTlzt1Cd83QJ08eCGirGtBvdL5m5iSgNt5E=
X-Google-Smtp-Source: APXvYqz4THn6C+r3ArtIUfz51zh5umR16HD/eiZ647fgXgiE5SavhC5RzsqzzYBSp8MOiocY4rRapfyeEC9e+QvR0mA=
X-Received: by 2002:a37:684a:: with SMTP id d71mr2115050qkc.201.1576674586757; 
 Wed, 18 Dec 2019 05:09:46 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
 <m1pngmrmst.fsf@HIDDEN>
In-Reply-To: <m1pngmrmst.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Wed, 18 Dec 2019 14:09:35 +0100
Message-ID: <CAJ3okZ3zSS0Rbnu5eLhpYHPvSY1emaj=-estQcjRwiJ3=4RMMA@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Konrad,

On Wed, 18 Dec 2019 at 10:43, Konrad Hinsen <konrad.hinsen@HIDDEN> wr=
ote:
>
> Hi Simon,
>
> > Maybe I miss a point. It is not: "watch out, this will do something
> > else in the future" but "watch out, this was doing something else in
> > the past and the change happened the <date> in <commit>".
>
> Concrete example: I am writing a tutorial about using Guix for
> reproducible research. It shows several uses of "guix environment", some
> of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my exa=
mples will
> cease to work in a few months. What am I supposed to do about this?

Assuming "guix environment" would stay and following the proposed
plan, you would need to add GUIX_ENVIRONMENT_DEPRECATED=3D1 on the top
of your script. In this would not be a problem for travelling back in
time.


> > First, I am not convinced that there is not so much scripts that will
> > be broken. And second, I am not convinced neither that these very
> > scripts need time-traveling.
>
> Perhaps it's just me, but I use "guix environment" quite a lot in
> scripts, in order to make them more reproducible. Here's a simple
> example:
>
>    #!/usr/bin/env bash
>    guix environment --container --ad-hoc gcc-toolchain <<EOF
>    gcc pi.c -o pi
>    ./pi
>    EOF

With the proposed plan, this would stay the same. Even, the --ad-hoc
option could stay forever for backward compatibility.

The only issue is for example:

    #!/usr/bin/env bash
    guix environment --container gmsh <<EOF
    mkdir build
    cd build
    cmake ..
    make
    ./bin/gmsh
    EOF

And I not convinced that this kind of scripts need to be robust for
time-travelling, I mean it is easy to correct adding the --inputs-of
option or set the GUIX_ENVIRONMENT_DEPRECATED variable.


> > Yes, it is probably the most adequate to do. But it is sad to loose
> > the good name "guix environment"... and we know that naming is hard.
> > ;-)
>
> I definitely agree. As a lesson for the future, maybe we should use
> not-so-nice names for new commands during a kind of beta-testing phase.

What do you think about "guix shell" for the new "guix environment" behavio=
ur?

What the others think?
New name (easier) vs transitional plan (trickier)?
And new names proposal:
  -  guix env
  -  guix shell
?


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 18 Dec 2019 09:43:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Dec 18 04:43:58 2019
Received: from localhost ([127.0.0.1]:42686 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihVs5-00028o-PG
	for submit <at> debbugs.gnu.org; Wed, 18 Dec 2019 04:43:57 -0500
Received: from wout3-smtp.messagingengine.com ([64.147.123.19]:53599)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <konrad.hinsen@HIDDEN>) id 1ihVs3-00028Z-Bi
 for 38529 <at> debbugs.gnu.org; Wed, 18 Dec 2019 04:43:56 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.west.internal (Postfix) with ESMTP id 0072C579;
 Wed, 18 Dec 2019 04:43:48 -0500 (EST)
Received: from mailfrontend1 ([10.202.2.162])
 by compute7.internal (MEProxy); Wed, 18 Dec 2019 04:43:49 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=fastmail.net; h=
 from:to:cc:subject:in-reply-to:references:date:message-id
 :mime-version:content-type:content-transfer-encoding; s=fm2; bh=
 p3VBQo5g2Ny8g90XIYTwNnnMGQt1x6EsB27VukHf3Vc=; b=S9YZ7AutzzNBMqtr
 zWWEwfTjYPUVZ32rj7NhZm12OFMFuKbEGKPNcK1uNgMbWwW0MtfbdevqkVY0xvru
 DotN3bHOH8U0RBjZY5k2aZbSNd6IMlTohai7Lhi4u4eMEwa2uOGVBw191C28ITo0
 TgCLLxIL+giiesxh/zYWhYUBvxG6ZZBSAtkEBTnnEnMQNIus9DX4BzQdhppJwMYM
 Um9AM42F8S9up9WH8+GQT+tFumGM9FFeTJS39zG/LH3kqHSiWmxspkwq+c4Or0If
 N+a4+V0LRimDGeWdVBfyik4rdPtNSwsSe4V2N05jLc4IK9QRaWdv2Ow5SWTj1XM1
 62YFfw==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-transfer-encoding:content-type
 :date:from:in-reply-to:message-id:mime-version:references
 :subject:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm1; bh=p3VBQo5g2Ny8g90XIYTwNnnMGQt1x6EsB27VukHf3
 Vc=; b=P76Py0a7QITzyuHP8LWqeFLQphujTyr4M8YJAAyuQ91fH+Zz2NyTHA7BA
 x2fwEAex4KT32rhcosO+JhfmoISxkBD6LNfYCpHEWRDCf4gpfwDrVgoFTSCBrGmi
 9yPcLUj9C/qczA48LABbP4AaSdMUzrdyISYk2SDPMAzfwQZzTVY3Si+RexMJwST8
 NjeSoBLa2q9RbJiTrhCH1+Fo78mStgq849i8fCb80ixoJPMD1UbND6QygcHaCrKo
 hDbAAWNYuWHjARtFY0vVzvNrkPHsYYZFrVjj6JhNSp/9lrYKAW8tnR9nvi7oR4TK
 cr0X4JhBw+IMxd3SYNu4/2ziLYdVA==
X-ME-Sender: <xms:1PT5XS_Kvftg3sauiPZ9hzmKJDdv8oH-gTwPe-DonCxgeAz__NjEqg>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedufedrvddtledgtdehucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucesvcftvggtihhpihgvnhhtshculddquddttddmne
 cujfgurhephffvufgjfhffkfggtgfgsehtqhertddttdejnecuhfhrohhmpefmohhnrhgr
 ugcujfhinhhsvghnuceokhhonhhrrggurdhhihhnshgvnhesfhgrshhtmhgrihhlrdhnvg
 htqeenucfkphepkeeirddvgeejrdduieegrddvgeehnecurfgrrhgrmhepmhgrihhlfhhr
 ohhmpehkohhnrhgrugdrhhhinhhsvghnsehfrghsthhmrghilhdrnhgvthenucevlhhush
 htvghrufhiiigvpedt
X-ME-Proxy: <xmx:1PT5XYvHy7HLLVSDEDn_rClppPp2DZj8Pm5zJEoC15RRPplhOOWP_Q>
 <xmx:1PT5XS1B79r6KwypnewsSdfzpmuFS_zesGHrJh2lJP6JDPS-ZZcrYw>
 <xmx:1PT5XdQ-WwoZQ5Ch5h3mMVRih8n1Ky_I26LVqrKfSQ6tuHYvrxpV8A>
 <xmx:1PT5XX0YRKlPmFnWhHQk-Oh9lXaJfxMX-w5m6-7a8hrWfzc8olHZtA>
Received: from khs-macbook.home (lfbn-idf2-1-714-245.w86-247.abo.wanadoo.fr
 [86.247.164.245])
 by mail.messagingengine.com (Postfix) with ESMTPA id 6D96080060;
 Wed, 18 Dec 2019 04:43:47 -0500 (EST)
From: Konrad Hinsen <konrad.hinsen@HIDDEN>
To: zimoun <zimon.toutoune@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-Reply-To: <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
Date: Wed, 18 Dec 2019 10:43:46 +0100
Message-ID: <m1pngmrmst.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

Hi Simon,

> Maybe I miss a point. It is not: "watch out, this will do something
> else in the future" but "watch out, this was doing something else in
> the past and the change happened the <date> in <commit>".

Concrete example: I am writing a tutorial about using Guix for
reproducible research. It shows several uses of "guix environment", some
of them without '=E2=80=93add-hoc' or '=E2=80=93inputs-of'. I know my examp=
les will
cease to work in a few months. What am I supposed to do about this?

> First, I am not convinced that there is not so much scripts that will
> be broken. And second, I am not convinced neither that these very
> scripts need time-traveling.

Perhaps it's just me, but I use "guix environment" quite a lot in
scripts, in order to make them more reproducible. Here's a simple
example:

   #!/usr/bin/env bash
   guix environment --container --ad-hoc gcc-toolchain <<EOF
   gcc pi.c -o pi
   ./pi
   EOF
=20
>> The first rule of backwards-compatibility is: never change the meaning
>> of an existing valid command/API. Add new valid syntax, deprecate old
>> valid syntax, but don't change the meaning of something that was and
>> will be valid.
>
> I agree on the rule.
> But it is mitigated but the number of users and the popularity of the too=
l. ;-)

Indeed!

> Yes, it is probably the most adequate to do. But it is sad to loose
> the good name "guix environment"... and we know that naming is hard.
> ;-)

I definitely agree. As a lesson for the future, maybe we should use
not-so-nice names for new commands during a kind of beta-testing phase.

Cheers,
  Konrad




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 23:21:40 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 18:21:40 2019
Received: from localhost ([127.0.0.1]:42510 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihM9s-0007Kb-1R
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 18:21:40 -0500
Received: from imta-37.everyone.net ([216.200.145.37]:37228
 helo=imta-38.everyone.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bokr@HIDDEN>) id 1ihM9q-0007KR-4S
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 18:21:39 -0500
Received: from pps.filterd (localhost.localdomain [127.0.0.1])
 by imta-38.everyone.net (8.16.0.27/8.16.0.27) with SMTP id xBHN6Ydi020999;
 Tue, 17 Dec 2019 15:21:36 -0800
X-Eon-Originating-Account: mxsP5keRzWGPWWU7cKjTx_jDKcyaBLhFlsVNuFCveJg
X-Eon-Dm: m0117124.ppops.net
Received: by m0117124.mta.everyone.net (EON-AUTHRELAY2 - 32d0d199)
 id m0117124.5dc217e5.81854d; Tue, 17 Dec 2019 15:21:29 -0800
X-Eon-Sig: AQMHrIJd+WL5tNedgQIAAAAD,6fef501130572d87df5ca96da5c3ae35
X-Eip: y46gHrrXf9MbjUGPgxgE15MFlnoApDwcICt25nGSwUg
Date: Tue, 17 Dec 2019 15:21:18 -0800
From: Bengt Richter <bokr@HIDDEN>
To: =?utf-8?B?R8OhYm9y?= Boskovits <boskovits@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
Message-ID: <20191217232118.GA14151@HIDDEN>
References: <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
 <20191217223048.GA3741@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <20191217223048.GA3741@HIDDEN>
User-Agent: Mutt/1.12.2 (2019-09-21)
X-Proofpoint-Virus-Version: vendor=fsecure engine=2.50.10434:, ,
 definitions=2019-12-17_04:, , signatures=0
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0
 priorityscore=1501 malwarescore=0
 suspectscore=0 phishscore=0 bulkscore=0 spamscore=0 clxscore=1034
 lowpriorityscore=0 mlxscore=0 impostorscore=0 mlxlogscore=743 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.0.1-1911140001
 definitions=main-1912170184
X-Spam-Score: -0.5 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Bengt Richter <bokr@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Forgot to add:
┌──────────────────────────────────────────────────────────────────────────┐
│          guile -c '(use-modules (ice-9 session))(apropos "env")          │
├──────────────────────────────────────────────────────────────────────────┤
│ (guile): getenv  #<procedure getenv (_)>                                 │
│ (guile): environ #<procedure environ (#:optional _)>                     │
│ (guile): setenv #<procedure setenv (name value)>                         │
│ (guile): interaction-environment #<procedure interaction-environment ()> │
│ (guile): putenv #<procedure putenv (_)>                                  │
│ (guile): unsetenv #<procedure unsetenv (name)>                           │
└──────────────────────────────────────────────────────────────────────────┘

BTW, it would be really handy to be able to type
   guile -apropos rest of line as regex
for the effect of
   ,a rest of line as regex
in the guile repl
-- 
Regards,
Bengt Richter




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 22:31:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 17:31:02 2019
Received: from localhost ([127.0.0.1]:42487 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihLMs-00062D-7j
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 17:31:02 -0500
Received: from imta-37.everyone.net ([216.200.145.37]:50140
 helo=imta-38.everyone.net)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <bokr@HIDDEN>) id 1ihLMp-00061n-S5
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 17:31:00 -0500
Received: from pps.filterd (m0004962.ppops.net [127.0.0.1])
 by imta-38.everyone.net (8.16.0.27/8.16.0.27) with SMTP id xBHMUsRd027056;
 Tue, 17 Dec 2019 14:30:58 -0800
X-Eon-Originating-Account: LAeu8Xxg4VzSEV28KRI9A64haOuTE5Ps44UP64XNyDQ
X-Eon-Dm: m0116953.ppops.net
Received: by m0116953.mta.everyone.net (EON-AUTHRELAY2 - 32d0d199)
 id m0116953.5dc217d1.994c0d; Tue, 17 Dec 2019 14:30:56 -0800
X-Eon-Sig: AQMHrIJd+VcgBPT8HgIAAAAE,8caca47ca5bda20c0691e28ce9e01142
X-Eip: AfM7qjzAls0mRzvTR5AghlujzJ4IuxJhbN95ElI9ajE
Date: Tue, 17 Dec 2019 14:30:48 -0800
From: Bengt Richter <bokr@HIDDEN>
To: =?utf-8?B?R8OhYm9y?= Boskovits <boskovits@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
Message-ID: <20191217223048.GA3741@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
 <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Disposition: inline
Content-Transfer-Encoding: 8bit
In-Reply-To: <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
User-Agent: Mutt/1.12.2 (2019-09-21)
X-Proofpoint-Virus-Version: vendor=fsecure engine=2.50.10434:, ,
 definitions=2019-12-17_04:, , signatures=0
X-Proofpoint-Spam-Details: rule=notspam policy=default score=0
 priorityscore=1501 malwarescore=0
 suspectscore=0 phishscore=0 bulkscore=0 spamscore=0 clxscore=1034
 lowpriorityscore=0 mlxscore=0 impostorscore=0 mlxlogscore=999 adultscore=0
 classifier=spam adjust=0 reason=mlx scancount=1 engine=8.0.1-1911140001
 definitions=main-1912170179
X-Spam-Score: -0.4 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, Konrad Hinsen <konrad.hinsen@HIDDEN>,
 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Reply-To: Bengt Richter <bokr@HIDDEN>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.4 (-)

Hi Gábor, Konrad, et al

On +2019-12-17 10:14:12 +0100, Gábor Boskovits wrote:
> Hello Konrad,
> 
> Konrad Hinsen <konrad.hinsen@HIDDEN> ezt írta (időpont: 2019. dec.
> 17., Ke 7:52):
> 
> > On 16/12/2019 23:09, Ludovic Courtès wrote:
> > > So in a more algorithmic manner:
> > >> 1. if ad-hoc and inputs-of is present at the same invocation: fail
> > >> hard. (With an error like incompatible options present)
> > >> 2. if only ad-hoc is present, then print a deprecation warning (yes,
> > >> we could make this suspendable with an environment variable, like you
> > >> described)
> > >> 3. if only inputs-of present, then do the new behaviour.
> > >> 4. if neither ad-hoc nor inputs-of present then
> > >>    a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
> > >>    b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> > >> new behaviour.
> > > That sounds like a good plan to me.
> > >
> > > #4 is the trickiest, and I think it’d be good to give users a bit of
> > > time so they can start adjusting before deprecation is in effect.
> >
> > #4 is trickiest for another reason: there is no future-proof use of
> > "guix environment" that works right now and will continue to work. Nor
> > is there any way to see, when looking at a command line, whether it's
> > old-style or new-style, if neither --ad-hoc nor --inputs-of are present.
> > This means that all existing documentation (tutorials etc.) will become
> > misleading in the future. Worse, even documentation written today, in
> > full awareness of a coming change, can't do better than saying "watch
> > out, this will do something else in the future".
> >
> > The first rule of backwards-compatibility is: never change the meaning
> > of an existing valid command/API. Add new valid syntax, deprecate old
> > valid syntax, but don't change the meaning of something that was and
> > will be valid.
> >

I think it is important to consider context when talking about meaning.

1. the level and the interpreter of the command:
   The first level is usually the shell (typicallly bash) from logind,
   but there is systemd and/or shepherd before that, and there is bootloader
   and UEFI and before that also accepting and/or passing commands through
   to the kernel via the kernel command line (cf. cat /proc/cmdline ).

   The general pattern I mostly see for a given interpreter is
   
   verb -adverb* (-adjective-for: object-name)* sub-command? implicit-or-object-for-verb*

   Consider whether your new name reinforces a good convention or forks it.
   Consider whether proposed usage translates easily to a natural language explanation.
   Does guix have a cli design best practices doc, BTW?
   
   right now we are talking about the use case where
   verb=guix and subcommand=environment

2. project community conventions
   Specialized areas often have their own jargon and abbreviated refrences
   so an unfortunate choice of name can cause distracting disambiguation searches.

Before settling on a new name xxx, even for a sub-command, I would say at least
first do the following at the command line:
   which xxx
   xxx --version
   xxx --help
   info xxx
   man xxx
   apropos xxx
   
   #check for same prefix, case-insensitively,
   # e.g. env might be tempting, as seen in this thread :)
--8<---------------cut here---------------start------------->8---
   echo $PATH|tr : $'\n'|while read pdir;do (find "$pdir" -maxdepth 1 -iname "env*" 2>/dev/null);done
--8<---------------cut here---------------end--------------->8---
   # -name "*xxx*" may also be a good idea, but the prefix is most important
   # env* produces
   /usr/bin/env
   /usr/bin/envsubst

   guix search xxx
   guix package -A xxx
   wikipedia search on xxx, e.g.
       lynx -dump -force_html -nolist https://en.wikipedia.org/w/index.php?search=xxx |less

   You get the idea, I'm sure ;-)
   
> > How about a more drastic measure: deprecate "guix environment" and
> > introduce a new subcommand with the desired new behaviour?
> >
SGTM, with some caveats

Good, since calling different things by the same name is always going to be problematic.
Iffy, since calling the same thing by different names may reduce future naming options,
   and may muddy the peer-name namespace, so maybe consider using sub-commands or -adverb.

> That is also the other option I was thinking about. Do you have any good
> idea in mind as how to call it? Of course the classic guix environment2
> comes to my mind, but it does not look very appealing to me.
>

Me neither :)

> >
> > Cheers,
> >
> >    Konrad.
> >
> Best regard,
> g_bor
> 

HTH in some way :)

-- 
Regards,
Bengt Richter




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 17:08:04 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 12:08:04 2019
Received: from localhost ([127.0.0.1]:42336 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihGKK-000415-74
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 12:08:04 -0500
Received: from mail-qk1-f178.google.com ([209.85.222.178]:43092)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ihGKJ-00040R-5D
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 12:08:03 -0500
Received: by mail-qk1-f178.google.com with SMTP id t129so2637751qke.10
 for <38529 <at> debbugs.gnu.org>; Tue, 17 Dec 2019 09:08:03 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=0uGojQhEq31dlx1V0us9T1Svh/f0OZWldNXrHycZtOc=;
 b=WaZmTS/6vzIqeQFBNdDlNwyoSjFonQo9ghATdjvRBgr7aFZ1UsELTfMjeEvhchSpwb
 VzzewiY5u8+IOgidM42dFD/jbSeZOtwdSBM6KmKNbQNdVthlFEx5mlSRa/ltGGWnErhV
 2CwAJmqGBGVdH4UIz1y1HNs+eG2guGgfansNmFy8uWBkFgAqxNsezcTHCBXXMBRaFJrJ
 79BZpylSueKckdKOwh3oNNbTW+f0sI9Bqk4twDYiT1Eeaj3w2rb5w9hTCBVKdoOlAiST
 GDAJG/7q+xdix9mlgOUTMNxux4csU6rUQsS2iHmmDOFH0s1fAt+mqDqhN7y1YikLwVL9
 jObg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=0uGojQhEq31dlx1V0us9T1Svh/f0OZWldNXrHycZtOc=;
 b=HLbQ6TeTHdvgHx6AQ4UCtIraKZPOKeNa+wbo87FG6xMD4Ti0pSy++pjcdzT3hi2uVl
 BCN9O4CqYMtCw53mE46VmBWQIaNTWz+dJHcual9QK1BoqY5vEDUERcarn182aaXb59m0
 TxAPNuXmwztG3xFF9tDWUTe6+/7xH+Uum3WwDJowY21oMt8+PZjCGIHVEvkzjUN+UAqm
 g7MWQ7G1q57HczkrQFSvcJoyLp6qBmiNIGSVQ+YVK0uPOuY70R48abLPt7sF/2AdWP3a
 s5UsPv+WBTke7i98+CcSzTWQxp+za3QnXNrDWJS7UuG9DyXmhCEQeUdbXJsESbcao82C
 NLlg==
X-Gm-Message-State: APjAAAVwLT+zJnHWkYFiC9xhg0XM4PMBP69xS4eptJWfSrsPGhkKTLGU
 YKQffa27K3U7IOElGUyyl7GKKMoezCNbAi8gEXw=
X-Google-Smtp-Source: APXvYqwYM9jJjLVw2E6Xi76cYoUil5zHRDEdxph+w2UykleyRgOV+Ob1gSFLtaVLBskbZpZZuQOktsVHj7K62pLV4sI=
X-Received: by 2002:a05:620a:1592:: with SMTP id
 d18mr6149675qkk.80.1576602477686; 
 Tue, 17 Dec 2019 09:07:57 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
In-Reply-To: <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Tue, 17 Dec 2019 18:07:45 +0100
Message-ID: <CAJ3okZ0Fw=02cDwdn5GuiDCyUNOUY=YaGyrFyHE5qWsOQTLASQ@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix Devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Konrad,

On Tue, 17 Dec 2019 at 07:52, Konrad Hinsen <konrad.hinsen@HIDDEN> wr=
ote:
>
> On 16/12/2019 23:09, Ludovic Court=C3=A8s wrote:
> > So in a more algorithmic manner:
> >> 1. if ad-hoc and inputs-of is present at the same invocation: fail
> >> hard. (With an error like incompatible options present)
> >> 2. if only ad-hoc is present, then print a deprecation warning (yes,
> >> we could make this suspendable with an environment variable, like you
> >> described)
> >> 3. if only inputs-of present, then do the new behaviour.
> >> 4. if neither ad-hoc nor inputs-of present then
> >>    a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
> >>    b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> >> new behaviour.
> > That sounds like a good plan to me.
> >
> > #4 is the trickiest, and I think it=E2=80=99d be good to give users a b=
it of
> > time so they can start adjusting before deprecation is in effect.
>
> #4 is trickiest for another reason: there is no future-proof use of
> "guix environment" that works right now and will continue to work. Nor
> is there any way to see, when looking at a command line, whether it's
> old-style or new-style, if neither --ad-hoc nor --inputs-of are present.
> This means that all existing documentation (tutorials etc.) will become
> misleading in the future. Worse, even documentation written today, in
> full awareness of a coming change, can't do better than saying "watch
> out, this will do something else in the future".

I do not understand what is the issue for the time-traveling if it is
documented.
Maybe I miss a point. It is not: "watch out, this will do something
else in the future" but "watch out, this was doing something else in
the past and the change happened the <date> in <commit>".

First, I am not convinced that there is not so much scripts that will
be broken. And second, I am not convinced neither that these very
scripts need time-traveling.


> The first rule of backwards-compatibility is: never change the meaning
> of an existing valid command/API. Add new valid syntax, deprecate old
> valid syntax, but don't change the meaning of something that was and
> will be valid.

I agree on the rule.
But it is mitigated but the number of users and the popularity of the tool.=
 ;-)


> How about a more drastic measure: deprecate "guix environment" and
> introduce a new subcommand with the desired new behaviour?

Yes, it is probably the most adequate to do. But it is sad to loose
the good name "guix environment"... and we know that naming is hard.
;-)

What about "guix shell"?


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 14:22:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 09:22:28 2019
Received: from localhost ([127.0.0.1]:40885 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihDk4-0003uG-EG
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 09:22:28 -0500
Received: from mout01.posteo.de ([185.67.36.65]:50521)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <brettg@HIDDEN>) id 1ihDk2-0003u3-A0
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 09:22:26 -0500
Received: from submission (posteo.de [89.146.220.130]) 
 by mout01.posteo.de (Postfix) with ESMTPS id F39BB160060
 for <38529 <at> debbugs.gnu.org>; Tue, 17 Dec 2019 15:22:19 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1576592540; bh=riuXq1/WkHeMDUk6avf2F9C6mOk1x7JBKwDAR9EvgzU=;
 h=Date:From:To:Cc:Subject:From;
 b=ZVK6h/QkDDLxgEKl/o7DFNTdI8YUUHwhGbuz88YXkD4FuXcPY/2E3ts2SWc28VbZM
 z+vwmThzHZriXNewwMtDocqjGBXyaWFTY7oRklVOXbgubAv7rfSg0EdWxtVG2WVPsD
 hOxWSQx6JET+FpCfWY3Y4SrFGvljDyQ0tbgdkRHGxrNzun11/xv5gMOp2gMo7nJVOF
 +206iAbDhYjhSP8ACRqotZFbMF6VDSbSX7+ahArzW5/1arO4sdZklEgoYdDl208Z1H
 1OMRX2uuBhf8M/bUurn1yPQlgQ1lCAYOIewsKuZRjvIcOmsLa4KVvlB9SrhTcma2CH
 whWjvSx5rbWDw==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 47cgMG0jMdz6tm9;
 Tue, 17 Dec 2019 15:22:17 +0100 (CET)
Date: Tue, 17 Dec 2019 14:22:15 +0000 (UTC)
From: Brett Gilio <brettg@HIDDEN>
To: Kyle Meyer <kyle@HIDDEN>
Message-ID: <4ee893ad-b489-4e98-b716-e418cd3b8049@localhost>
In-Reply-To: <87pngncc0n.fsf@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
 <87pngncc0n.fsf@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
MIME-Version: 1.0
Content-Type: text/plain; charset=UTF-8
Content-Transfer-Encoding: quoted-printable
X-Correlation-ID: <4ee893ad-b489-4e98-b716-e418cd3b8049@localhost>
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>,
 =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>,
 Konrad Hinsen <konrad.hinsen@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)



Dec 17, 2019 7:34:17 AM Kyle Meyer :

> G=E1bor Boskovits writes:
>
>
> > Konrad Hinsen ezt =EDrta (id?pont: 2019. dec.
> > 17., Ke 7:52):
> >
> [...]
>
> >
> > > How about a more drastic measure: deprecate "guix environment" and
> > > introduce a new subcommand with the desired new behaviour?
> > >
> > >
> > That is also the other option I was thinking about. Do you have any goo=
d
> > idea in mind as how to call it? Of course the classic guix environment2
> > comes to my mind, but it does not look very appealing to me.
> >
>
> Perhaps "guix env"?
>

+1 for guix env





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 13:33:34 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 08:33:34 2019
Received: from localhost ([127.0.0.1]:40854 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ihCyk-0002eY-IG
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 08:33:34 -0500
Received: from pb-smtp1.pobox.com ([64.147.108.70]:65309)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <kyle@HIDDEN>) id 1ihCyh-0002eP-LW
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 08:33:32 -0500
Received: from pb-smtp1.pobox.com (unknown [127.0.0.1])
 by pb-smtp1.pobox.com (Postfix) with ESMTP id 905B41A532;
 Tue, 17 Dec 2019 08:33:30 -0500 (EST) (envelope-from kyle@HIDDEN)
DKIM-Signature: v=1; a=rsa-sha1; c=relaxed; d=pobox.com; h=from:to:cc
 :subject:in-reply-to:references:date:message-id:mime-version
 :content-type:content-transfer-encoding; s=sasl; bh=ReKxnVQeJn5B
 xQGmcUmCuHgf7sI=; b=TA5oIj5gLcgmK2tcB5olLT7MTql90Jndu4eHCeNIQst7
 rkvJ9eWshdcdRM0eeZxBSF94gxkziX5mIgAsg1ubePs1P+u4AWzhdTheaQBkR03a
 xynjWl0s34xgf+AW8uVfx2IBC+Gj5fuk7RYRFUT3sCwHd5530Faz+Ee3JNAJpXw=
Received: from pb-smtp1.nyi.icgroup.com (unknown [127.0.0.1])
 by pb-smtp1.pobox.com (Postfix) with ESMTP id 87FDE1A531;
 Tue, 17 Dec 2019 08:33:30 -0500 (EST) (envelope-from kyle@HIDDEN)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed; d=kyleam.com;
 h=from:to:cc:subject:in-reply-to:references:date:message-id:mime-version:content-type:content-transfer-encoding;
 s=mesmtp; bh=Pmzi0SE0d1HOH/dEemh7N5qUS7kOjtnZ8+EwuLYSUfE=;
 b=NIYu7YLLwxb+Yyek9USiNG+SLA4wHT7HMUL4/OGVg4eUNlLfyA0mmnq1FRpIXRMC0ivHnOqLlc8XC0k6FjDeZ0jlSflPHTfKs4oVCRLNWYdF9f95ReyoIAc9450RxX31bUzpgoXjMBILLX/p7o9qy4WHJunBX2/1zx6heb36N78=
Received: from localhost (unknown [45.33.91.115])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by pb-smtp1.pobox.com (Postfix) with ESMTPSA id E061B1A530;
 Tue, 17 Dec 2019 08:33:29 -0500 (EST) (envelope-from kyle@HIDDEN)
From: Kyle Meyer <kyle@HIDDEN>
To: =?utf-8?Q?G=C3=A1bor?= Boskovits <boskovits@HIDDEN>, Konrad Hinsen
 <konrad.hinsen@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
In-Reply-To: <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
 <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
Date: Tue, 17 Dec 2019 13:33:28 +0000
Message-ID: <87pngncc0n.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-Pobox-Relay-ID: D01276FA-20D1-11EA-AD42-C28CBED8090B-24757444!pb-smtp1.pobox.com
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

G=C3=A1bor Boskovits <boskovits@HIDDEN> writes:

> Konrad Hinsen <konrad.hinsen@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2=
019. dec.
> 17., Ke 7:52):
[...]
>> How about a more drastic measure: deprecate "guix environment" and
>> introduce a new subcommand with the desired new behaviour?
>>
> That is also the other option I was thinking about. Do you have any good
> idea in mind as how to call it? Of course the classic guix environment2
> comes to my mind, but it does not look very appealing to me.

Perhaps "guix env"?




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 09:14:33 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 04:14:33 2019
Received: from localhost ([127.0.0.1]:40703 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ih8w4-0000Y6-T2
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 04:14:33 -0500
Received: from mail-ed1-f49.google.com ([209.85.208.49]:32873)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <boskovits@HIDDEN>) id 1ih8w3-0000Xt-Li
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 04:14:32 -0500
Received: by mail-ed1-f49.google.com with SMTP id r21so7472491edq.0
 for <38529 <at> debbugs.gnu.org>; Tue, 17 Dec 2019 01:14:31 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=2hj4cQm+vmScuj6unsA5YNXbeCJGiy+q+tAEF4SQLyc=;
 b=LeR8m6aMOXzuLmUdYxYv96r9Mi3HhJ0/MMyIfRI9605Rh2/8aPpbuK4cnIO1+uYIBl
 p9pFDAbY6jNdjn/E0zikXeCejy6cHwRh38W3im4kO0vLlEI43stVA3V5vFjwgXj2LqiA
 wqHbV9jF3o5nvsQghw88pmTMQMzZxGmM8kDbL7lXB7nY+zDIfoHbZjtVMZCdDXQo4uho
 OswZ0zaqm417CTqVKQImQ/0UE9VC16iHy4seqJe23+p2LFnWkc6Um92R06zj+28FhEio
 Rra5/xZvUjADdMmDCHvzhL2Y/20PeNUUzEeX8zHQD4snKdvNXE1ZxGM3TVFUILR1KcFO
 RjXg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=2hj4cQm+vmScuj6unsA5YNXbeCJGiy+q+tAEF4SQLyc=;
 b=TjyCh2kU4VQZzQeVrjT8aY19rTdqqGn7gYbjknOuVx+dTqOsWor8IqShX65BVf35BZ
 FJdNCC2ce77nEX1G3ZJxFofI2atpcluBh0FK9qHeMFzD8SZ1fnQd3bGiGN6KhgIAb/8X
 3movWMa8F0pLuTQjJtd/YUr6zASVEx7sSbT3o6PBCNigOrox5588UOcs4Cv9brfSIKt4
 zEhFGBQiwfRGQlq7OWHMpMVsLd6Z+nt/7Krgwt32cf9C286mXR6kOBzzwkL4Pz83IO7G
 vMkOnMZOpaUajY8ehyoUUWJ+jHJKjWCuxqa1Km71P0723RcMfmHaynp6RnP9aCTq7BZS
 d8TA==
X-Gm-Message-State: APjAAAUtgi1QLYdZ9wYnIZL6gOXarWBW0nJOJODpnhQpvJnNu+X0bpYh
 SWx9b5hOS09knPfdOLZHLaBIBOBCRIrCSl35cA==
X-Google-Smtp-Source: APXvYqyMHThZk7ACD8oRSLdctHpNN02ibBAuNynJGehh6yQ4fKrBQd8TIFH/ecIlSMR47UdEJlijyvIDoYZRNjd4HTo=
X-Received: by 2002:a17:906:4047:: with SMTP id
 y7mr3869400ejj.78.1576574065732; 
 Tue, 17 Dec 2019 01:14:25 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN> <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
In-Reply-To: <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
From: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Date: Tue, 17 Dec 2019 10:14:12 +0100
Message-ID: <CAE4v=pjc5pWiaaB17tJnpO=O0=M5xrEWhyvWMLRaiLy5V19Y5Q@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: Konrad Hinsen <konrad.hinsen@HIDDEN>
Content-Type: multipart/alternative; boundary="0000000000002673950599e2c132"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000002673950599e2c132
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Hello Konrad,

Konrad Hinsen <konrad.hinsen@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 201=
9. dec.
17., Ke 7:52):

> On 16/12/2019 23:09, Ludovic Court=C3=A8s wrote:
> > So in a more algorithmic manner:
> >> 1. if ad-hoc and inputs-of is present at the same invocation: fail
> >> hard. (With an error like incompatible options present)
> >> 2. if only ad-hoc is present, then print a deprecation warning (yes,
> >> we could make this suspendable with an environment variable, like you
> >> described)
> >> 3. if only inputs-of present, then do the new behaviour.
> >> 4. if neither ad-hoc nor inputs-of present then
> >>    a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
> >>    b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> >> new behaviour.
> > That sounds like a good plan to me.
> >
> > #4 is the trickiest, and I think it=E2=80=99d be good to give users a b=
it of
> > time so they can start adjusting before deprecation is in effect.
>
> #4 is trickiest for another reason: there is no future-proof use of
> "guix environment" that works right now and will continue to work. Nor
> is there any way to see, when looking at a command line, whether it's
> old-style or new-style, if neither --ad-hoc nor --inputs-of are present.
> This means that all existing documentation (tutorials etc.) will become
> misleading in the future. Worse, even documentation written today, in
> full awareness of a coming change, can't do better than saying "watch
> out, this will do something else in the future".
>
> The first rule of backwards-compatibility is: never change the meaning
> of an existing valid command/API. Add new valid syntax, deprecate old
> valid syntax, but don't change the meaning of something that was and
> will be valid.
>
> How about a more drastic measure: deprecate "guix environment" and
> introduce a new subcommand with the desired new behaviour?
>
That is also the other option I was thinking about. Do you have any good
idea in mind as how to call it? Of course the classic guix environment2
comes to my mind, but it does not look very appealing to me.

>
>
> Cheers,
>
>    Konrad.
>
Best regard,
g_bor

>
>
>
>

--0000000000002673950599e2c132
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"auto"><div>Hello Konrad,<br><br><div class=3D"gmail_quote"><div=
 dir=3D"ltr" class=3D"gmail_attr">Konrad Hinsen &lt;<a href=3D"mailto:konra=
d.hinsen@HIDDEN">konrad.hinsen@HIDDEN</a>&gt; ezt =C3=ADrta (id=
=C5=91pont: 2019. dec. 17., Ke 7:52):<br></div><blockquote class=3D"gmail_q=
uote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:1e=
x">On 16/12/2019 23:09, Ludovic Court=C3=A8s wrote:<br>
&gt; So in a more algorithmic manner:<br>
&gt;&gt; 1. if ad-hoc and inputs-of is present at the same invocation: fail=
<br>
&gt;&gt; hard. (With an error like incompatible options present)<br>
&gt;&gt; 2. if only ad-hoc is present, then print a deprecation warning (ye=
s,<br>
&gt;&gt; we could make this suspendable with an environment variable, like =
you<br>
&gt;&gt; described)<br>
&gt;&gt; 3. if only inputs-of present, then do the new behaviour.<br>
&gt;&gt; 4. if neither ad-hoc nor inputs-of present then<br>
&gt;&gt;=C2=A0 =C2=A0 a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the curren=
t behaviour,<br>
&gt;&gt;=C2=A0 =C2=A0 b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is=
 not 1: do the<br>
&gt;&gt; new behaviour.<br>
&gt; That sounds like a good plan to me.<br>
&gt;<br>
&gt; #4 is the trickiest, and I think it=E2=80=99d be good to give users a =
bit of<br>
&gt; time so they can start adjusting before deprecation is in effect.<br>
<br>
#4 is trickiest for another reason: there is no future-proof use of <br>
&quot;guix environment&quot; that works right now and will continue to work=
. Nor <br>
is there any way to see, when looking at a command line, whether it&#39;s <=
br>
old-style or new-style, if neither --ad-hoc nor --inputs-of are present. <b=
r>
This means that all existing documentation (tutorials etc.) will become <br=
>
misleading in the future. Worse, even documentation written today, in <br>
full awareness of a coming change, can&#39;t do better than saying &quot;wa=
tch <br>
out, this will do something else in the future&quot;.<br>
<br>
The first rule of backwards-compatibility is: never change the meaning <br>
of an existing valid command/API. Add new valid syntax, deprecate old <br>
valid syntax, but don&#39;t change the meaning of something that was and <b=
r>
will be valid.<br>
<br>
How about a more drastic measure: deprecate &quot;guix environment&quot; an=
d <br>
introduce a new subcommand with the desired new behaviour?<br></blockquote>=
</div></div><div dir=3D"auto">That is also the other option I was thinking =
about. Do you have any good idea in mind as how to call it? Of course the c=
lassic guix environment2 comes to my mind, but it does not look very appeal=
ing to me.</div><div dir=3D"auto"><div class=3D"gmail_quote"><blockquote cl=
ass=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;p=
adding-left:1ex">
<br>
<br>
Cheers,<br>
<br>
=C2=A0=C2=A0 Konrad.<br></blockquote></div></div><div dir=3D"auto">Best reg=
ard,</div><div dir=3D"auto">g_bor</div><div dir=3D"auto"><div class=3D"gmai=
l_quote"><blockquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;borde=
r-left:1px #ccc solid;padding-left:1ex">
<br>
<br>
<br>
</blockquote></div></div></div>

--0000000000002673950599e2c132--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 17 Dec 2019 06:49:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 17 01:49:31 2019
Received: from localhost ([127.0.0.1]:40632 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ih6fi-0005L7-Tu
	for submit <at> debbugs.gnu.org; Tue, 17 Dec 2019 01:49:31 -0500
Received: from out2-smtp.messagingengine.com ([66.111.4.26]:50321)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <konrad.hinsen@HIDDEN>) id 1ih6fg-0005Kv-NY
 for 38529 <at> debbugs.gnu.org; Tue, 17 Dec 2019 01:49:29 -0500
Received: from compute7.internal (compute7.nyi.internal [10.202.2.47])
 by mailout.nyi.internal (Postfix) with ESMTP id 7D93B22050;
 Tue, 17 Dec 2019 01:49:23 -0500 (EST)
Received: from mailfrontend1 ([10.202.2.162])
 by compute7.internal (MEProxy); Tue, 17 Dec 2019 01:49:23 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=fastmail.net; h=
 subject:to:references:from:message-id:date:mime-version
 :in-reply-to:content-type:content-transfer-encoding; s=fm2; bh=H
 fUsfHGFCfiiAhWbCgXSDsH/Ag22NVczrcxr8lnTI/I=; b=nxrryElVVjyVz+YJd
 NwBrLXk70h0CQmN/jyA9eyTwawklNdY4/Sg4dJca263wSlaT7A/gxuO/kXspJ9Ya
 RVESYa7R7+PUwsfxLb1vGdhOURdcexCwdZUH0M9fkLwbMTwuunUv2dN+XD8NRu9s
 STaPxOpcUKgjDPR20g+pygiU4qiyBow38B18YLP4iW8RFdO0Ab1MQYumkvJDsDq5
 nNq/BiV3Qd9AXJaXddebQ7i876ouOHTS5KZOa+UucDK0JLNPhtxiLIK2Rmjw0QFc
 DfGoasTZll+aJ8eeDclpRvSw2oCzYooGjw0hfx+jJ/rdnbu0pO0vW380kvkPhHZ3
 EPmAA==
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=content-transfer-encoding:content-type
 :date:from:in-reply-to:message-id:mime-version:references
 :subject:to:x-me-proxy:x-me-proxy:x-me-sender:x-me-sender
 :x-sasl-enc; s=fm1; bh=HfUsfHGFCfiiAhWbCgXSDsH/Ag22NVczrcxr8lnTI
 /I=; b=ptGK2iYFag9ECt1QPMYuqE0cdX8AA7y4ujOeKQKYdG6ncIfdTvIo9JvjZ
 lJ85CaofQabYuazZCgSouaXgiw2YQjwiN3QXrWtUYw/RN2YReY2D6QgmAnc3otjf
 QibrAsMTHGydNyQvEE9ueLGCce6DximuKmTAeoAvWjcqzZawUUF4w/l8aaszvoUb
 v7tqVM0c2HGM7f7uNOYBh/V29VVk0RZgix5QjxJ7WuUWWgHj4zKov1RQOTDBBgZK
 78POso4oaDaOO0q8PecUQCMF2CTRGjCwscTeyQjSbBfw2Ez+4c/637JBPj8OM7I5
 CuvQ30d/WSoOJaTVuhODlvnualzig==
X-ME-Sender: <xms:c3r4XWR_5qMZlqUJJXcfKZFw1Tvy8-P9bvCF4NdILXCxnjfbckDshQ>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedufedrvddtiedguddttdcutefuodetggdotefrod
 ftvfcurfhrohhfihhlvgemucfhrghsthforghilhdpqfgfvfdpuffrtefokffrpgfnqfgh
 necuuegrihhlohhuthemuceftddtnecunecujfgurhepuffvfhfhkffffgggjggtgfesth
 ekredttdefjeenucfhrhhomhepmfhonhhrrgguucfjihhnshgvnhcuoehkohhnrhgrugdr
 hhhinhhsvghnsehfrghsthhmrghilhdrnhgvtheqnecukfhppeekiedrvdegjedrudeige
 drvdegheenucfrrghrrghmpehmrghilhhfrhhomhepkhhonhhrrggurdhhihhnshgvnhes
 fhgrshhtmhgrihhlrdhnvghtnecuvehluhhsthgvrhfuihiivgeptd
X-ME-Proxy: <xmx:c3r4XZlyNAzDv2U4CZeRc9O6FiSw4p7BxX60ux-X5pr4cZY37OIBLw>
 <xmx:c3r4XUvAOMVJf02e7-wO245ofUAQryStE8l3eTpFTbGVOALjI-6_nQ>
 <xmx:c3r4Xc9I6ZvDs2gMbD8EQaETs7tTdHBMu2kJHJqU9mXaudUm4X2lTg>
 <xmx:c3r4XZM3RmhKeW9Djd3Yv1H6sP8QYJXD51PLeciyM25wPbqAF-_m_w>
Received: from khs-macbook.home (lfbn-idf2-1-714-245.w86-247.abo.wanadoo.fr
 [86.247.164.245])
 by mail.messagingengine.com (Postfix) with ESMTPA id C3AB68005B;
 Tue, 17 Dec 2019 01:49:22 -0500 (EST)
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: guix-devel@HIDDEN, 38529 <at> debbugs.gnu.org
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <87k16vdise.fsf@HIDDEN>
From: Konrad Hinsen <konrad.hinsen@HIDDEN>
Message-ID: <e992ac46-37b9-ba12-83cc-6694427acd31@HIDDEN>
Date: Tue, 17 Dec 2019 07:49:21 +0100
User-Agent: Mozilla/5.0 (Macintosh; Intel Mac OS X 10.14; rv:60.0)
 Gecko/20100101 Thunderbird/60.9.1
MIME-Version: 1.0
In-Reply-To: <87k16vdise.fsf@HIDDEN>
Content-Type: text/plain; charset=utf-8; format=flowed
Content-Transfer-Encoding: 8bit
Content-Language: en-US
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On 16/12/2019 23:09, Ludovic Courtès wrote:
> So in a more algorithmic manner:
>> 1. if ad-hoc and inputs-of is present at the same invocation: fail
>> hard. (With an error like incompatible options present)
>> 2. if only ad-hoc is present, then print a deprecation warning (yes,
>> we could make this suspendable with an environment variable, like you
>> described)
>> 3. if only inputs-of present, then do the new behaviour.
>> 4. if neither ad-hoc nor inputs-of present then
>>    a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
>>    b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
>> new behaviour.
> That sounds like a good plan to me.
>
> #4 is the trickiest, and I think it’d be good to give users a bit of
> time so they can start adjusting before deprecation is in effect.

#4 is trickiest for another reason: there is no future-proof use of 
"guix environment" that works right now and will continue to work. Nor 
is there any way to see, when looking at a command line, whether it's 
old-style or new-style, if neither --ad-hoc nor --inputs-of are present. 
This means that all existing documentation (tutorials etc.) will become 
misleading in the future. Worse, even documentation written today, in 
full awareness of a coming change, can't do better than saying "watch 
out, this will do something else in the future".

The first rule of backwards-compatibility is: never change the meaning 
of an existing valid command/API. Add new valid syntax, deprecate old 
valid syntax, but don't change the meaning of something that was and 
will be valid.

How about a more drastic measure: deprecate "guix environment" and 
introduce a new subcommand with the desired new behaviour?


Cheers,

   Konrad.






Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 16 Dec 2019 22:09:48 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 16 17:09:48 2019
Received: from localhost ([127.0.0.1]:40436 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1igyYl-0005cY-U1
	for submit <at> debbugs.gnu.org; Mon, 16 Dec 2019 17:09:48 -0500
Received: from eggs.gnu.org ([209.51.188.92]:54865)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1igyYj-0005cL-Kd
 for 38529 <at> debbugs.gnu.org; Mon, 16 Dec 2019 17:09:45 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:38992)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1igyYe-0004uO-9A; Mon, 16 Dec 2019 17:09:40 -0500
Received: from [2a01:e0a:1d:7270:af76:b9b:ca24:c465] (port=42946 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1igyYd-0000ky-JL; Mon, 16 Dec 2019 17:09:39 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: =?utf-8?Q?G=C3=A1bor?= Boskovits <boskovits@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
Date: Mon, 16 Dec 2019 23:09:37 +0100
In-Reply-To: <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 (=?utf-8?Q?=22G=C3=A1bor?= Boskovits"'s message of "Fri, 13 Dec 2019
 17:27:52 +0100")
Message-ID: <87k16vdise.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hello,

G=C3=A1bor Boskovits <boskovits@HIDDEN> skribis:

> So in a more algorithmic manner:
> 1. if ad-hoc and inputs-of is present at the same invocation: fail
> hard. (With an error like incompatible options present)
> 2. if only ad-hoc is present, then print a deprecation warning (yes,
> we could make this suspendable with an environment variable, like you
> described)
> 3. if only inputs-of present, then do the new behaviour.
> 4. if neither ad-hoc nor inputs-of present then
>   a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
>   b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> new behaviour.

That sounds like a good plan to me.

#4 is the trickiest, and I think it=E2=80=99d be good to give users a bit of
time so they can start adjusting before deprecation is in effect.

Namely, we could start by introducing =E2=80=98--inputs-of=E2=80=99 and emi=
tting a
warning in case #4 to suggest the use of =E2=80=98--inputs-of=E2=80=99.  Ap=
art from the
warning, case #4 would still behave the same as now.

Three (?) months later, we implement what you describe above.  Hopefully
by that time many people got used to =E2=80=98--inputs-of=E2=80=99.

Thoughts?

Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 13 Dec 2019 16:41:58 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 11:41:58 2019
Received: from localhost ([127.0.0.1]:34595 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifo0s-0003m5-DZ
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 11:41:58 -0500
Received: from mail-ed1-f43.google.com ([209.85.208.43]:47099)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <boskovits@HIDDEN>) id 1ifo0r-0003lt-IQ
 for 38529 <at> debbugs.gnu.org; Fri, 13 Dec 2019 11:41:57 -0500
Received: by mail-ed1-f43.google.com with SMTP id m8so2515184edi.13
 for <38529 <at> debbugs.gnu.org>; Fri, 13 Dec 2019 08:41:57 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=L9ABuk/w82Q0e5r26ccTZ/XqzWrhcWS3s2axsJW7usY=;
 b=f8+rdU1ex3HgAXtiJNVvhTZ6/P/8TrCHJ5uqaAwmzOqf3A51PXvAcqU2nb1yvtXZMK
 MASJgr6aBJe7OdhCOPZdRWH2ro23E2KjwoTpqNQuHQmPKOXWQzT7giTblETYknsXq6Y+
 4JARxvu13u03Vhf4Q970sbRgyKI/vCshOnmMZFdioXpJH4NZkYMqrDZXtmCFJGQcZdoL
 fJ053YTVjSTcgXrqIPEpE9S7RSneFufns+aCUsQT7e9Pn8OSsDozGIKiKbzk9DQqEkbM
 ynLHrrnKtr9HN2JDnKGG5qIttD5n9rMjkn5T3n1moT2RY8LTqz9HKW1yspMP0BCgESnC
 CQZg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=L9ABuk/w82Q0e5r26ccTZ/XqzWrhcWS3s2axsJW7usY=;
 b=NUo0Hiv1Rv7NEHUP35CLDLq1RK32cIURNXUFHosEKTjGKqmcUUxcX5AnINqa44bAHl
 zfthsI8YVBGDGEczv9qEUBJq7lo0Ae3uBRNbgNzF/gRwjfT0EMXEQm125vjqf2K1Ttgw
 vzxQyfwSfaJbzP1HxXToGGXj3+c8iY87Sl7kvxiJVGFcIxR4ZfZfMVtkBd/u1AqWpkl9
 Guxlxoz+N7ICCSMuqNrS0SRsK/YevmDNRZodxuQDrko+um7xvjir/XNyr62D5CDfiiko
 o4NL5XaksmSddxJPw4dKcnbUo9U+pAxWCPeUquvKW67a4wBn6nqkhMypnvFdvhj7Fm7V
 jrQQ==
X-Gm-Message-State: APjAAAWmzeDBL2iKZTpWN4Kz5wHE5SWY9cAVEvVNy4As8jNVOgv7AmSo
 enK/rMD9O7JWDLdRqL0ty68+vusb6jqgkbPPBw==
X-Google-Smtp-Source: APXvYqzHICx84F/hMG5Wq7zkJxVb/oM/pogFdAS2mJ4rRCr8Z/SgZoGnDQ3Ee6jD+LFo+Yk4wP3a7eMhu/Rt9dFfiZs=
X-Received: by 2002:a17:906:2344:: with SMTP id
 m4mr17303175eja.110.1576255311529; 
 Fri, 13 Dec 2019 08:41:51 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
 <CAJ3okZ1L_nmhdOwsxFmmTA3v9GiB=6NU2jSZFF7AgY-fctHtsA@HIDDEN>
In-Reply-To: <CAJ3okZ1L_nmhdOwsxFmmTA3v9GiB=6NU2jSZFF7AgY-fctHtsA@HIDDEN>
From: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Date: Fri, 13 Dec 2019 17:41:40 +0100
Message-ID: <CAE4v=pj_+UpJrbM77upTfRsxvmVHyCBXRi-2_bZB5fbHz6cgNQ@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: zimoun <zimon.toutoune@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello Zimoun,

zimoun <zimon.toutoune@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2019. dec. 1=
3., P, 17:32):
>
> Hi G=C3=A1bor,
>
> Sorry to be slow. :-)

I probably just did not express myself clearly enough.

>
> On Fri, 13 Dec 2019 at 17:28, G=C3=A1bor Boskovits <boskovits@HIDDEN> =
wrote:
>
>
> > So in a more algorithmic manner:
> > 1. if ad-hoc and inputs-of is present at the same invocation: fail
> > hard. (With an error like incompatible options present)
> > 2. if only ad-hoc is present, then print a deprecation warning (yes,
> > we could make this suspendable with an environment variable, like you
> > described)
> > 3. if only inputs-of present, then do the new behaviour.
> > 4. if neither ad-hoc nor inputs-of present then
> >   a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
> >   b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> > new behaviour.
> >
> > This would minimze friction, as there will be a few scripts falling und=
er 4.
> > This would also allow mirgating such scripts one by one. be defining
> > GUIX_ENVIRONMENT_DEPRECATED to 1 in some startup file, and using
> > GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ... in scripts that ar=
e
> > fixed to use the new syntax.
> >
> >
> > What do you think?
>
> I am perfectly aligned! :-)

Great!

> It is exactly what I have tried to describe.
> Sorry again for being slow.

I am sorry for the confusion, my communication tends to slugghish, an
I am also a bit bound to
do some hand-waving :) I hope to improve on that

>
> Thank you.
> Do you plan to implement it? Do I give a try?

I would like to hear something from Ludo, as he was also a participant
of the IRC discussion.

After that I would not mind if you gave it a try, if you would like.
Otherwise I will implement it.

>
>
> All the best,
> simon


Best regards,
g_bor
--=20
OpenPGP Key Fingerprint: 7988:3B9F:7D6A:4DBF:3719:0367:2506:A96C:CF63:0B21




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 13 Dec 2019 16:32:52 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 11:32:52 2019
Received: from localhost ([127.0.0.1]:34587 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifns4-0003Z7-Ce
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 11:32:52 -0500
Received: from mail-qk1-f174.google.com ([209.85.222.174]:38023)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ifns2-0003Yt-8u
 for 38529 <at> debbugs.gnu.org; Fri, 13 Dec 2019 11:32:50 -0500
Received: by mail-qk1-f174.google.com with SMTP id k6so59541qki.5
 for <38529 <at> debbugs.gnu.org>; Fri, 13 Dec 2019 08:32:50 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=VBHydOd8ZGlVXWN8rOz0dkTM8CksioTEmKizcW8LmcY=;
 b=bIY9rtElC68cyuZeKfPLAnF/YKy0VbeeGPMBxRpPAL+Zh0TZEFaij2cLLys6LjHB9T
 Jerqb/7v7EIBuOEH8taRs5R9lB8y7cGkReP0LQRWeQFWl+gq3YWn09FJkNG0q2lVWuGO
 Hyf5CnFijDGou6pbjXD9eCglB560vn57TLtibnScn1l2l8sZufmkL/10JJ/0heMwd1Vc
 1k7L0w5y+Ktu9J2mtKCljL7bnveUI4oTGxrGGteBBbnr9n0tg1vYYPCjjOcmQK2sEyKL
 f0TIWM2rLin+PmBXvizL/E9f9gT5eXFJbt0VAdqaauKYiLGLaGWMKUtwSSOk1VlhgwQq
 xLEQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=VBHydOd8ZGlVXWN8rOz0dkTM8CksioTEmKizcW8LmcY=;
 b=eYWGx6d/hDQUXyV6VjjEJhR7Pt0zaqXTNE9ELKbTZqZNn2vHPP/89IsSMnIrcEPprW
 6x69ZgnLuxh7K+LmG4UCWtPwbhwdw8utgZGTu63umqI1l3R8jbiMUjcqgTLqSAVIoFaK
 kt3pFpfs8i3m+mliJjwlOg8663WWC6S6vHEIShyGTJfSr/33k3AT1T4Ba9z3Htow7vCh
 M5FmkZSDttcUiI2uZl0mWzgsTkHmcA4CQxMYbhqNZ/KbyEeR1VAuWhJt4CWEjc6eyYU2
 rYPiy01oFu4F69zGxr7bY9rXnz+jQiQEKQKVUXxnnBFeyhlBWyVYARaiRDNcpsUNuHqf
 qXLw==
X-Gm-Message-State: APjAAAV5RrBNFTMt5EfinpaPZhXsUGNPIdgZ2jyZRFmKHX894Q8UM4SR
 ZxklRs6amTDC6pVf8Jxr8A9EEcctKSA6jlJfqtg=
X-Google-Smtp-Source: APXvYqzrsXkfdCjS7tPwshf+RtXZ+HcxgBZYECjxGAVooqXvI6VtDg4mcNzZLcKMzr+1pR+FSJVrBKWggDxszQt1ADY=
X-Received: by 2002:a37:684a:: with SMTP id d71mr13053993qkc.201.1576254764826; 
 Fri, 13 Dec 2019 08:32:44 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
 <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
In-Reply-To: <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 13 Dec 2019 17:32:33 +0100
Message-ID: <CAJ3okZ1L_nmhdOwsxFmmTA3v9GiB=6NU2jSZFF7AgY-fctHtsA@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi G=C3=A1bor,

Sorry to be slow. :-)

On Fri, 13 Dec 2019 at 17:28, G=C3=A1bor Boskovits <boskovits@HIDDEN> wr=
ote:


> So in a more algorithmic manner:
> 1. if ad-hoc and inputs-of is present at the same invocation: fail
> hard. (With an error like incompatible options present)
> 2. if only ad-hoc is present, then print a deprecation warning (yes,
> we could make this suspendable with an environment variable, like you
> described)
> 3. if only inputs-of present, then do the new behaviour.
> 4. if neither ad-hoc nor inputs-of present then
>   a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
>   b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
> new behaviour.
>
> This would minimze friction, as there will be a few scripts falling under=
 4.
> This would also allow mirgating such scripts one by one. be defining
> GUIX_ENVIRONMENT_DEPRECATED to 1 in some startup file, and using
> GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ... in scripts that are
> fixed to use the new syntax.
>
>
> What do you think?

I am perfectly aligned! :-)
It is exactly what I have tried to describe.
Sorry again for being slow.

Thank you.
Do you plan to implement it? Do I give a try?


All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 13 Dec 2019 16:28:12 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 11:28:12 2019
Received: from localhost ([127.0.0.1]:34577 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifnnX-0003Q3-MN
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 11:28:12 -0500
Received: from mail-ed1-f51.google.com ([209.85.208.51]:43932)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <boskovits@HIDDEN>) id 1ifnnV-0003Pg-SL
 for 38529 <at> debbugs.gnu.org; Fri, 13 Dec 2019 11:28:10 -0500
Received: by mail-ed1-f51.google.com with SMTP id dc19so2489719edb.10
 for <38529 <at> debbugs.gnu.org>; Fri, 13 Dec 2019 08:28:09 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=2NP1cQkM4fMWiaVW9bOK21A4075D2ml8t4SHrJ5DyVk=;
 b=XVs6Bx7xwkhBBqc3fxwNx0yPLJuPf0gqYTwUslgYXk1eF4R+IkPPI3vF7vSlp43lY/
 uhh9d96NUH9inU0MHVWsgbr4ilk4P8912DwZMjGwHGH9sv7rPcweBfqDbkTuQDcZwleg
 qhVurmQjlfG7dboH9fUIALyelgeEoHQEWW0MJ7DDflKYIEkHWXVzGVWCpC0mYbTWg6FJ
 jtd3QArm+2KjjLzyocQWuTMnHU3iM9CodeAD8nl+e0K+iHfAiWwjwuRf1QrFUh7GSppL
 wxqZs/bjivZ+fkktbscHK9GPAjWC75mu/XrB/LfAbzqVD465Lvos21CPA2LYiMG7Mmb8
 jlYw==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=2NP1cQkM4fMWiaVW9bOK21A4075D2ml8t4SHrJ5DyVk=;
 b=mV3Ft5pZfgZfvJl+m3iTflYqRAY5idAPX6OwlMuFtAmyTPzbnZd2dstXGEFrGC/jIy
 I0n+uJcd8MnnEXMkiWWk6mi+QLvkuE6rBsRC2mCp0tNfYOe6ZDb7YG60yAqzp22BgZMS
 yJLPdzbn1qGq0+VccnpZWAgKiBEUBDN+gQjxfNZeWUKH9Q5kmvIfhL/UgKcOeVLy/gCC
 zLP3j781pKIGu3s6Mtzel2YJvoWo33jy+L+vsf0nhVjQ7OBsX/Rm0n+u4YqwLbPlGWS8
 0s1dBpxkbzrlC86quv2Yvhtl5H1nZgb7rHP+4xdbZXQnrg9I7g6ljOJXYQPJjn5igqBe
 JrWw==
X-Gm-Message-State: APjAAAVOzI4tbXDOuRvopeoiV+qcRvr0FN6smb6cad1ZdfbL3Ysjdotd
 OaRiHIkFcUhDT4XQf5kTp7QGa+tNe8nxCj6P1A==
X-Google-Smtp-Source: APXvYqwRxvy4aC76Rub+33kLslkiGif0UV13nRZMYi5+uAbznxXGHpfTv+QWM2Z3MrxuFqm+dbptlg+OBJj5SXMfvr8=
X-Received: by 2002:a50:fb13:: with SMTP id d19mr5090909edq.87.1576254484042; 
 Fri, 13 Dec 2019 08:28:04 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
 <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
In-Reply-To: <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
From: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Date: Fri, 13 Dec 2019 17:27:52 +0100
Message-ID: <CAE4v=pgevGwP6+jSY-+0DPdtvK60sEvd-uibqhRawuo6N1pL-Q@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: zimoun <zimon.toutoune@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello,

Let me try again :)

zimoun <zimon.toutoune@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2019. dec. 1=
3., P, 13:02):
>
> Hi G=C3=A1bor,
>
>
> On Thu, 12 Dec 2019 at 21:54, G=C3=A1bor Boskovits <boskovits@HIDDEN> =
wrote:
>
> > zimoun <zimon.toutoune@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2019. de=
c. 12., Cs=C3=BC 17:47):
>
> >> Maybe I miss a point. Is the aim to conserve the "--ad-hoc" option
> >> with a different effect? Or why do we want to conserve this option
> >> name?
> >> It appears to me simpler to give another name, for example
> >> "--inputs-of". And it is more meaningful.
> >
> > Sorry for the confusion. Ad-hoc should be retained with the same effect=
, so that we do not break existing scripts.
> > Renamin the option would be ok. It even makes sense to me.
>
> What I propose is:
>
>   - keep the option "--ad-hoc" with the current behavior; so same effect
>   - add a new option "--inputs-of" with the new behavior; name more meani=
ngful
>   - and two env variables; to not break existing scripts
>
>
> >> First, when "--ad-hoc" is used then it reports a warning: deprecated
> >> option and falls in the current behavior.
> >> When "--inputs-of" is used then it falls in the new behavior.
> >> Therefore, no needs of the ugly "--ignore-deprecated-ad-hoc".
> >
> > That could be done. The problem is caused by uses of guix environment t=
hat does not use any of these options. Those mean different things after th=
e change.
>
> The transition to such use-case was described below with the
> introduction of 2 env variables. :-)
>
>
> >>  # Alice
> >>  $ guix environment foo --ad-hoc bar
> >>  Warning: deprecated... explanations...
> >>                instead use:
> >>                 guix environment bar --inputs-of foo
> >>
> >>  # Bob
> >>  $ guix environment bar --inputs-of foo
> >>
> >>
> >> Second, the previous "guix environment foo" (dependencies of foo) is
> >> inconsistent with the new "guix environment bar" (only the package
> >> bar). Therefore, let introduce the GUIX_ENVIRONMENT_DEPRECATED
> >> variable to distinguish both, as you said.
> >
> > Ok.
>
> It is the easy part. ;-)
>
>
> Now the hard part: avoid to break existing scripts.
>
> >>  # Alice
> >>  $ guix environment foo
> >>  Warning: previous behavior requires GUIX_ENVIRONMENT_DEPRECATED=3D1
> >>                turn off the warning: GUIX_ENVIRONMENT_NOWARNING=3D1
> >>
> >> And Alice has now a new shell with the package foo. If she wants the
> >> dependencies, she has two options:
> >>
> >> $ GUIX_ENVIRONMENT=3D1 guix environment foo
> >> or
> >> $ guix environment --inputs-of foo
> >>
> >>
> >>  # Bob
> >>  $ guix environment bar
> >>  Warning: previous behavior requires GUIX_ENVIRONMENT
> >>
> >> And if Bob is annoyed by the warnings each time, he globally turns off
> >> with the variable GUIX_ENVIRONMENT_NOWARNING=3D1.
> >>
> >>
> >> Couple of months later -- after the period adoption -- we remove the
> >> variables GUIX_ENVIRONMENT_NOWARNING and GUIX_ENVIRONMENT_DEPRECATED;
> >> still keeping the warning with the "--ad-hoc" option. And then, after
> >> we can remove the "--ad-hoc" option if required.
>
>
> > We could recommend simply to use something like:
> > GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ...
> > Instead in existing scripts that are fixed to use the new syntax. This =
indeed looks like a better solution, and it is less of a maintenance burden=
. Good idea.
>
> My point is: the new variable GUIX_ENVIRONMENT_DEPRECATED should only
> be used by the scripts that call "guix environment pkg" without the
> options "--ad-hoc" or "--inputs-of". And I think that it represents
> really few scripts in real life. :-)
>
>
> > Summarizing:
> > Introduce the environment variable.
> > For fixed scripts recommend unsetting the environment variable.
>
> I am not to get your plan. :-)
>
>
> Cheers,
> simon

So in a more algorithmic manner:
1. if ad-hoc and inputs-of is present at the same invocation: fail
hard. (With an error like incompatible options present)
2. if only ad-hoc is present, then print a deprecation warning (yes,
we could make this suspendable with an environment variable, like you
described)
3. if only inputs-of present, then do the new behaviour.
4. if neither ad-hoc nor inputs-of present then
  a. if GUIX_ENVIRONMENT_DEPRECATED is 1: do the current behaviour,
  b. if GUIX_ENVIRONMENT_DEPRECATED is undefined, or is not 1: do the
new behaviour.

This would minimze friction, as there will be a few scripts falling under 4=
.
This would also allow mirgating such scripts one by one. be defining
GUIX_ENVIRONMENT_DEPRECATED to 1 in some startup file, and using
GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ... in scripts that are
fixed to use the new syntax.


What do you think?

Best regards,
g_bor
--=20
OpenPGP Key Fingerprint: 7988:3B9F:7D6A:4DBF:3719:0367:2506:A96C:CF63:0B21




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 13 Dec 2019 12:02:46 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Dec 13 07:02:46 2019
Received: from localhost ([127.0.0.1]:33112 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifjeg-0003iA-4E
	for submit <at> debbugs.gnu.org; Fri, 13 Dec 2019 07:02:46 -0500
Received: from mail-qv1-f52.google.com ([209.85.219.52]:39761)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ifjee-0003hy-HJ
 for 38529 <at> debbugs.gnu.org; Fri, 13 Dec 2019 07:02:44 -0500
Received: by mail-qv1-f52.google.com with SMTP id y8so714621qvk.6
 for <38529 <at> debbugs.gnu.org>; Fri, 13 Dec 2019 04:02:44 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=AFW8jejzKYYAQqr2tKcY5AO9gxKaJhzyYzQ7ve1w7OU=;
 b=klhkggYfGuVuzaKgLDUFQuZur6A/x0F8ECek8QUQk6LnNUM0C8rBRTDleyi46/56ck
 2q6JsB662njmcr5fTWnUjtDdihVmnKdmRMfg0Wa92r8Rv+7A9tlPuoX8IDtndkZnwQiO
 9cHclB78XEV0ANKVUSUJJo5uPxbLhxVHz/RvaekgkzNnHH2/+FPA9kZsavZkKZ8SyCwf
 Opr17wmoBvBECYFwU3I+Msym/zRCY3CC/TNixn+bZWeu+/nreG11m8+aW/uyWvbuug6N
 25M/vft7JX6EQwevIemvFD7ft7Z4VazFOyh5kVymuWIDvQ6Uz0pt8cPnb63CylnkQDoi
 8x6w==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=AFW8jejzKYYAQqr2tKcY5AO9gxKaJhzyYzQ7ve1w7OU=;
 b=f5cOAkdx6AR8k+xKmjZMMJ6/gVETvyXtjea79nY4LE5qfjczWcGz3Bx67gEADTQ90v
 CiAxAYPgqma13eNq6GtTp8bZTWmWWo500xMs03rCoHU5HdGyK5+oqK9/s8aTwmF6xSSj
 vaKQKDTb+OXE4ei0eGvKAuXWYKI4SnRAPbcJ78m8IUSucmse4Retqxg/T3WtARez8HEr
 NTdWJ2ZVsMBnLRjRv8vR6YUqepXwsGlKAnFrkXGYKCflY46DH03wXj6atKwBxW/t2OMo
 NNKdYFc7uv37Gw+yIMVNtwoGK4hMKDjQlk8LuF2IukYsLpnIV7WcF9F6LmqRHR7kkFEn
 pNQA==
X-Gm-Message-State: APjAAAVhWMYxxyQ+0O20R3TV7yKDVcSU4hKgBPRv3sP4x+elbjo2CT+y
 n4ffL0aPHv+3IhpyhdND1P9uboCjZ1XjVLOvaAg=
X-Google-Smtp-Source: APXvYqyFavqQWDJslJP1cvKEPOxMQ7hzCdnNe8QklNu2gXSwBBKVupYjWaslgzKEBcRBMzo0Vd9xXBUWeg3A4s2nZ84=
X-Received: by 2002:a0c:f703:: with SMTP id w3mr13083275qvn.6.1576238559043;
 Fri, 13 Dec 2019 04:02:39 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
 <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
In-Reply-To: <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Fri, 13 Dec 2019 13:02:27 +0100
Message-ID: <CAJ3okZ3gJDdDKWERLANp+7ueSirEZ7hH=YKa3nhCAzCzAz1TGg@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi G=C3=A1bor,


On Thu, 12 Dec 2019 at 21:54, G=C3=A1bor Boskovits <boskovits@HIDDEN> wr=
ote:

> zimoun <zimon.toutoune@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2019. dec.=
 12., Cs=C3=BC 17:47):

>> Maybe I miss a point. Is the aim to conserve the "--ad-hoc" option
>> with a different effect? Or why do we want to conserve this option
>> name?
>> It appears to me simpler to give another name, for example
>> "--inputs-of". And it is more meaningful.
>
> Sorry for the confusion. Ad-hoc should be retained with the same effect, =
so that we do not break existing scripts.
> Renamin the option would be ok. It even makes sense to me.

What I propose is:

  - keep the option "--ad-hoc" with the current behavior; so same effect
  - add a new option "--inputs-of" with the new behavior; name more meaning=
ful
  - and two env variables; to not break existing scripts


>> First, when "--ad-hoc" is used then it reports a warning: deprecated
>> option and falls in the current behavior.
>> When "--inputs-of" is used then it falls in the new behavior.
>> Therefore, no needs of the ugly "--ignore-deprecated-ad-hoc".
>
> That could be done. The problem is caused by uses of guix environment tha=
t does not use any of these options. Those mean different things after the =
change.

The transition to such use-case was described below with the
introduction of 2 env variables. :-)


>>  # Alice
>>  $ guix environment foo --ad-hoc bar
>>  Warning: deprecated... explanations...
>>                instead use:
>>                 guix environment bar --inputs-of foo
>>
>>  # Bob
>>  $ guix environment bar --inputs-of foo
>>
>>
>> Second, the previous "guix environment foo" (dependencies of foo) is
>> inconsistent with the new "guix environment bar" (only the package
>> bar). Therefore, let introduce the GUIX_ENVIRONMENT_DEPRECATED
>> variable to distinguish both, as you said.
>
> Ok.

It is the easy part. ;-)


Now the hard part: avoid to break existing scripts.

>>  # Alice
>>  $ guix environment foo
>>  Warning: previous behavior requires GUIX_ENVIRONMENT_DEPRECATED=3D1
>>                turn off the warning: GUIX_ENVIRONMENT_NOWARNING=3D1
>>
>> And Alice has now a new shell with the package foo. If she wants the
>> dependencies, she has two options:
>>
>> $ GUIX_ENVIRONMENT=3D1 guix environment foo
>> or
>> $ guix environment --inputs-of foo
>>
>>
>>  # Bob
>>  $ guix environment bar
>>  Warning: previous behavior requires GUIX_ENVIRONMENT
>>
>> And if Bob is annoyed by the warnings each time, he globally turns off
>> with the variable GUIX_ENVIRONMENT_NOWARNING=3D1.
>>
>>
>> Couple of months later -- after the period adoption -- we remove the
>> variables GUIX_ENVIRONMENT_NOWARNING and GUIX_ENVIRONMENT_DEPRECATED;
>> still keeping the warning with the "--ad-hoc" option. And then, after
>> we can remove the "--ad-hoc" option if required.


> We could recommend simply to use something like:
> GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ...
> Instead in existing scripts that are fixed to use the new syntax. This in=
deed looks like a better solution, and it is less of a maintenance burden. =
Good idea.

My point is: the new variable GUIX_ENVIRONMENT_DEPRECATED should only
be used by the scripts that call "guix environment pkg" without the
options "--ad-hoc" or "--inputs-of". And I think that it represents
really few scripts in real life. :-)


> Summarizing:
> Introduce the environment variable.
> For fixed scripts recommend unsetting the environment variable.

I am not to get your plan. :-)


Cheers,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 12 Dec 2019 20:55:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 15:55:02 2019
Received: from localhost ([127.0.0.1]:60958 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifVUE-0003xw-Bb
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 15:55:02 -0500
Received: from mail-ed1-f53.google.com ([209.85.208.53]:38124)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <boskovits@HIDDEN>) id 1ifVUC-0003xP-86
 for 38529 <at> debbugs.gnu.org; Thu, 12 Dec 2019 15:55:00 -0500
Received: by mail-ed1-f53.google.com with SMTP id i6so185684edr.5
 for <38529 <at> debbugs.gnu.org>; Thu, 12 Dec 2019 12:55:00 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=9G1pPW8PzSkOB8wbN/iVmfhSIm9k263KLHZfVafP23o=;
 b=BDU76t/EsJKb7Y04YDMtBlDP13qfgQwopkAe1BjxB3PnyNwQ8Qo97kta6DHiKX8uu4
 zOJWSnyYQM19qKAXoIAKgUGFPs8NWrQFMTQSeRKzmbTzKMwrdHhzQSul4xAerXrV5jms
 pR0Ed3BErmFWjJ8fKrHNJsC24IU5cLriPkirZOF/2FyzNh6/hOXk5cUXGdgHWCRQWq7o
 ElCqj7GoM+gCoBLdBjn76QLmlxXe28DyIMeQcZQqdmL+7fXJWKd1zKjtXjF/qx5/tunV
 Qa1nVJIqxHuMDVN89EX+KZpcBvPpNniciEQX9IpwSSoUUkW5SVly7ovpzq0YTz8J3ong
 SR+Q==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=9G1pPW8PzSkOB8wbN/iVmfhSIm9k263KLHZfVafP23o=;
 b=QaItg8GrWTbiR7jCnt0EMDn4553T4xI1MzEQtMOvo2G59UQKt9rdiK87ZPpb89hSp0
 Ad2UFYvyIDYOgEdCQJOb8eyvAo0yJgXuhS6qY3oC8NzqSJnpb++Go2iZvhLDdAPTb5+7
 Yt4N246+Pt3Ft9FJ38cEqsMG7u3c5mSHVg/YRzIQ1ShOx8pk0AxgJYjx02VD6M0EXvdo
 9mqzJB0G8EqREsX7JmH+cdTWUW9zO2nh2TZpU4YoN0QoTX5He+Nbigmot4A2yclLS3Ym
 6N6t/azep9HM/WoXfS7VOwhqgP6VE2ns0frh6StiZQWabeOUNvLLBkQXRb18uhwulahw
 cxbQ==
X-Gm-Message-State: APjAAAVEnxBr9zM0SZwCSNQ9kFwO1LXjgNeHc8IWvn3BDjz5CropWnPt
 YmHjO9cQzbJi49fh1T7HMwTgFwQ0yS8Z7FKaVA==
X-Google-Smtp-Source: APXvYqyyqGR9PBnI96w6grCFfTOr51cJBPekV67ectgx6fnEQu9ALbHKNJ6PO69vWR5IIV+fwUZnF6aA9Gl4WSsipOo=
X-Received: by 2002:a50:fb13:: with SMTP id d19mr152082edq.87.1576184094280;
 Thu, 12 Dec 2019 12:54:54 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
 <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
In-Reply-To: <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
From: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Date: Thu, 12 Dec 2019 21:54:41 +0100
Message-ID: <CAE4v=piMnBhHWpbB60qMRnnDNwqkuddfNv7cEihr9+5-52k2OA@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: zimoun <zimon.toutoune@HIDDEN>
Content-Type: multipart/alternative; boundary="0000000000000a512b059987f5d8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

--0000000000000a512b059987f5d8
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

Hello,

zimoun <zimon.toutoune@HIDDEN> ezt =C3=ADrta (id=C5=91pont: 2019. dec. 1=
2., Cs=C3=BC
17:47):

> Hi G=C3=A1bor,
>
> Thank you for summarizing the discussion on IRC that I missed.
>
> Maybe I miss a point. Is the aim to conserve the "--ad-hoc" option
> with a different effect? Or why do we want to conserve this option
> name?
> It appears to me simpler to give another name, for example
> "--inputs-of". And it is more meaningful.
>
Sorry for the confusion. Ad-hoc should be retained with the same effect, so
that we do not break existing scripts.
Renamin the option would be ok. It even makes sense to me.

>
>
> To be concrete, the different cases; (-) means current behavior and
> (+) the new one:
>
> 1.
> - guix environment foo
> + guix environment --inputs-of foo
>
> 2.
> - guix environment --ad-hoc bar
> + guix environment bar
>
>
> First, when "--ad-hoc" is used then it reports a warning: deprecated
> option and falls in the current behavior.
> When "--inputs-of" is used then it falls in the new behavior.
> Therefore, no needs of the ugly "--ignore-deprecated-ad-hoc".
>
That could be done. The problem is caused by uses of guix environment that
does not use any of these options. Those mean different things after the
change.

>
>
> In other words, with the same future guix version,
>
>  # Alice
>  $ guix environment foo --ad-hoc bar
>  Warning: deprecated... explanations...
>                instead use:
>                 guix environment bar --inputs-of foo
>
>  # Bob
>  $ guix environment bar --inputs-of foo
>
>
> Second, the previous "guix environment foo" (dependencies of foo) is
> inconsistent with the new "guix environment bar" (only the package
> bar). Therefore, let introduce the GUIX_ENVIRONMENT_DEPRECATED
> variable to distinguish both, as you said.
>
Ok.

>
>  # Alice
>  $ guix environment foo
>  Warning: previous behavior requires GUIX_ENVIRONMENT_DEPRECATED=3D1
>                turn off the warning: GUIX_ENVIRONMENT_NOWARNING=3D1
>
> And Alice has now a new shell with the package foo. If she wants the
> dependencies, she has two options:
>
> $ GUIX_ENVIRONMENT=3D1 guix environment foo
> or
> $ guix environment --inputs-of foo
>
>
>  # Bob
>  $ guix environment bar
>  Warning: previous behavior requires GUIX_ENVIRONMENT
>
> And if Bob is annoyed by the warnings each time, he globally turns off
> with the variable GUIX_ENVIRONMENT_NOWARNING=3D1.
>
>
> Couple of months later -- after the period adoption -- we remove the
> variables GUIX_ENVIRONMENT_NOWARNING and GUIX_ENVIRONMENT_DEPRECATED;
> still keeping the warning with the "--ad-hoc" option. And then, after
> we can remove the "--ad-hoc" option if required.
>
>
> Maybe a miss a point. But the addition of the flag appears
> "--too-long-to-type" to me ugly.
>
We could recommend simply to use something like:
GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ...
Instead in existing scripts that are fixed to use the new syntax. This
indeed looks like a better solution, and it is less of a maintenance
burden. Good idea.

>
>
> What do you think?
>
> All the best,
> simon
>

Summarizing:
Introduce the environment variable.
For fixed scripts recommend unsetting the environment variable.

That looks like a better plan. Thanks for your insights.

Best regards,
g_bor

>

--0000000000000a512b059987f5d8
Content-Type: text/html; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable

<div dir=3D"auto"><div>Hello,<br><br><div class=3D"gmail_quote"><div dir=3D=
"ltr" class=3D"gmail_attr">zimoun &lt;<a href=3D"mailto:zimon.toutoune@gmai=
l.com">zimon.toutoune@HIDDEN</a>&gt; ezt =C3=ADrta (id=C5=91pont: 2019. =
dec. 12., Cs=C3=BC 17:47):<br></div><blockquote class=3D"gmail_quote" style=
=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:1ex">Hi G=C3=
=A1bor,<br>
<br>
Thank you for summarizing the discussion on IRC that I missed.<br>
<br>
Maybe I miss a point. Is the aim to conserve the &quot;--ad-hoc&quot; optio=
n<br>
with a different effect? Or why do we want to conserve this option<br>
name?<br>
It appears to me simpler to give another name, for example<br>
&quot;--inputs-of&quot;. And it is more meaningful.<br></blockquote></div><=
/div><div dir=3D"auto">Sorry for the confusion. Ad-hoc should be retained w=
ith the same effect, so that we do not break existing scripts.</div><div di=
r=3D"auto">Renamin the option would be ok. It even makes sense to me.</div>=
<div dir=3D"auto"><div class=3D"gmail_quote"><blockquote class=3D"gmail_quo=
te" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:1ex"=
>
<br>
<br>
To be concrete, the different cases; (-) means current behavior and<br>
(+) the new one:<br>
<br>
1.<br>
- guix environment foo<br>
+ guix environment --inputs-of foo<br>
<br>
2.<br>
- guix environment --ad-hoc bar<br>
+ guix environment bar<br>
<br>
<br>
First, when &quot;--ad-hoc&quot; is used then it reports a warning: depreca=
ted<br>
option and falls in the current behavior.<br>
When &quot;--inputs-of&quot; is used then it falls in the new behavior.<br>
Therefore, no needs of the ugly &quot;--ignore-deprecated-ad-hoc&quot;.<br>=
</blockquote></div></div><div dir=3D"auto">That could be done. The problem =
is caused by uses of guix environment that does not use any of these option=
s. Those mean different things after the change.</div><div dir=3D"auto"><di=
v class=3D"gmail_quote"><blockquote class=3D"gmail_quote" style=3D"margin:0=
 0 0 .8ex;border-left:1px #ccc solid;padding-left:1ex">
<br>
<br>
In other words, with the same future guix version,<br>
<br>
=C2=A0# Alice<br>
=C2=A0$ guix environment foo --ad-hoc bar<br>
=C2=A0Warning: deprecated... explanations...<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0instead use:<br>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 guix environment ba=
r --inputs-of foo<br>
<br>
=C2=A0# Bob<br>
=C2=A0$ guix environment bar --inputs-of foo<br>
<br>
<br>
Second, the previous &quot;guix environment foo&quot; (dependencies of foo)=
 is<br>
inconsistent with the new &quot;guix environment bar&quot; (only the packag=
e<br>
bar). Therefore, let introduce the GUIX_ENVIRONMENT_DEPRECATED<br>
variable to distinguish both, as you said.<br></blockquote></div></div><div=
 dir=3D"auto">Ok.</div><div dir=3D"auto"><div class=3D"gmail_quote"><blockq=
uote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #ccc =
solid;padding-left:1ex">
<br>
=C2=A0# Alice<br>
=C2=A0$ guix environment foo<br>
=C2=A0Warning: previous behavior requires GUIX_ENVIRONMENT_DEPRECATED=3D1<b=
r>
=C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0 =C2=A0turn off the warning=
: GUIX_ENVIRONMENT_NOWARNING=3D1<br>
<br>
And Alice has now a new shell with the package foo. If she wants the<br>
dependencies, she has two options:<br>
<br>
$ GUIX_ENVIRONMENT=3D1 guix environment foo<br>
or<br>
$ guix environment --inputs-of foo<br>
<br>
<br>
=C2=A0# Bob<br>
=C2=A0$ guix environment bar<br>
=C2=A0Warning: previous behavior requires GUIX_ENVIRONMENT<br>
<br>
And if Bob is annoyed by the warnings each time, he globally turns off<br>
with the variable GUIX_ENVIRONMENT_NOWARNING=3D1.<br>
<br>
<br>
Couple of months later -- after the period adoption -- we remove the<br>
variables GUIX_ENVIRONMENT_NOWARNING and GUIX_ENVIRONMENT_DEPRECATED;<br>
still keeping the warning with the &quot;--ad-hoc&quot; option. And then, a=
fter<br>
we can remove the &quot;--ad-hoc&quot; option if required.<br>
<br>
<br>
Maybe a miss a point. But the addition of the flag appears<br>
&quot;--too-long-to-type&quot; to me ugly.<br></blockquote></div></div><div=
 dir=3D"auto">We could recommend simply to use something like:</div><div di=
r=3D"auto">GUIX_ENVIRONMENT_DEPRECATED=3D0 guix environment ...</div><div d=
ir=3D"auto">Instead in existing scripts that are fixed to use the new synta=
x. This indeed looks like a better solution, and it is less of a maintenanc=
e burden. Good idea.</div><div dir=3D"auto"><div class=3D"gmail_quote"><blo=
ckquote class=3D"gmail_quote" style=3D"margin:0 0 0 .8ex;border-left:1px #c=
cc solid;padding-left:1ex">
<br>
<br>
What do you think?<br>
<br>
All the best,<br>
simon<br></blockquote></div></div><div dir=3D"auto"><br></div><div dir=3D"a=
uto">Summarizing:</div><div dir=3D"auto">Introduce the environment variable=
.</div><div dir=3D"auto">For fixed scripts recommend unsetting the environm=
ent variable.</div><div dir=3D"auto"><br></div><div dir=3D"auto">That looks=
 like a better plan. Thanks for your insights.</div><div dir=3D"auto"><br><=
/div><div dir=3D"auto">Best regards,</div><div dir=3D"auto">g_bor</div><div=
 dir=3D"auto"><div class=3D"gmail_quote"><blockquote class=3D"gmail_quote" =
style=3D"margin:0 0 0 .8ex;border-left:1px #ccc solid;padding-left:1ex">
</blockquote></div></div></div>

--0000000000000a512b059987f5d8--




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 12 Dec 2019 19:34:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 14:34:15 2019
Received: from localhost ([127.0.0.1]:60918 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifUE3-00019T-5r
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 14:34:15 -0500
Received: from mail-qv1-f53.google.com ([209.85.219.53]:33980)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ifUE1-00019E-WC
 for 38529 <at> debbugs.gnu.org; Thu, 12 Dec 2019 14:34:14 -0500
Received: by mail-qv1-f53.google.com with SMTP id o18so1440820qvf.1
 for <38529 <at> debbugs.gnu.org>; Thu, 12 Dec 2019 11:34:13 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=a0R+ht8tbIUmOEpxiorTw7b4biLiPoo/FTrj91bYvd0=;
 b=NsHLLrPIbpeN7uqLPhX2FQ6Lg9KYacF95N2YWMrKuVTJatDhyKC5CZgjbvQ5Y9rB4l
 UBauUhy1U8nzXksGxA0nL3UY3h9drVrRtEtBGYqh+BlcYP/IMJbTZChHzgNtKYYE29QO
 T9oObIvLtKoKOQvonILCnZS7E2Vi9lDf2dKwIY+A677iqq7tMvWDgDZdu4BVpw2bGlrI
 dZjmhQ656hwqc5HWAlvAiH+6UtVpw27hWxYN06K0N67FLuQOwd4OEpqNS2TRRPMewvXF
 eS81VZgmhXbuijR73ntqCB8Dadq6XLCmpzO7Q5ankT39Lq80FEcK4ln98F0hPzl7EYAh
 QJdA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=a0R+ht8tbIUmOEpxiorTw7b4biLiPoo/FTrj91bYvd0=;
 b=WppAdZzZGhdzrCuSYq43hDTV2VIKk4d7SE+aNzv1CPymRUwwdpNibzwi7nhGj0nlEu
 UORFw/R+aC+O/imJKHVW9V/WH3FNRNQFNVMA2F/4Ssj5G9wBQLYX/5zCTndzaWnt0CS6
 7yeEnkivMLd2DlrgQtl+M5pGoj1S6PApzCa5tX3ARhdcsKd1PR6KLlbTqBokvOa+4/Hz
 aEhbDo+YV6opXr1o6d0lXQ4LaTKrUof0x8NoRvhanj4SwyrjI8aC0meJwO6J5r9abpKW
 ODk+NwGaRtoBXHsx8bh0MHNGp+IEWXsD9ZynvPV6/4B2wPjNV1owwW3zZLPrMk+kgPA5
 5JGg==
X-Gm-Message-State: APjAAAUC1co+L5tlnq+wsKQ2kWj4/Vdi+B7lkGq4dy0owXS0v/VuqSD/
 cWYlysVl0MEZyUlh9giTEU/SxdG+EnPUkQGuXyM=
X-Google-Smtp-Source: APXvYqyXdHDo3Uwd418N3Pp4ie/AvP0nn0n5KXX6C6rgCECasj4CdW47lcUPPxawhmiOxT/sU8CiQ+sVUhAgq1TgbCA=
X-Received: by 2002:a05:6214:108a:: with SMTP id
 o10mr9642468qvr.246.1576179248520; 
 Thu, 12 Dec 2019 11:34:08 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <e56ae49d56e50c40a8e1d279e7d0b2b14761935b.camel@HIDDEN>
In-Reply-To: <e56ae49d56e50c40a8e1d279e7d0b2b14761935b.camel@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 12 Dec 2019 20:33:57 +0100
Message-ID: <CAJ3okZ0Xi1vi13pogXs=6O-yw3VQwJfLCo2hsxVNEcgbCmctnQ@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
To: Jesse Gibbons <jgibbons2357@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Pierre Neidhardt <mail@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

On Mon, 9 Dec 2019 at 18:38, Jesse Gibbons <jgibbons2357@HIDDEN> wrote:

> for example, "guix environment --pure --ad-hoc pavucontrol -- pavucontrol"
> gives me an error:
> No protocol specified
> Unable to init server: Could not connect: Connection
> refused

I do not experiment this error.


> Similarly, "guix environment --pure --ad-hoc gnubik -- gnubik" gives me an
> error:
> No protocol specified
>
> (gnubik:29707): Gtk-WARNING **: 10:03:28.753: cannot open display: :1

I do not experiment this error.


> "guix environment --pure --ad-hoc gedit -- gedit":
> No protocol specified
> Unable to init server: Could not connect: Connection refused
>
> (org.gnome.gedit:31542): Gtk-WARNING **: 10:08:07.401: cannot open display:
> :1

Instead I experiment this warning:

(org.gnome.gedit:19087): dconf-WARNING **: 20:31:27.734: failed to
commit changes to dconf: Failed to execute child process ?dbus-launch?
(No such file or directory)



All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 12 Dec 2019 16:47:41 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 11:47:41 2019
Received: from localhost ([127.0.0.1]:60861 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifRcr-0001n1-E9
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 11:47:41 -0500
Received: from mail-qt1-f177.google.com ([209.85.160.177]:43275)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ifRcp-0001mp-QZ
 for 38529 <at> debbugs.gnu.org; Thu, 12 Dec 2019 11:47:40 -0500
Received: by mail-qt1-f177.google.com with SMTP id b3so2793297qti.10
 for <38529 <at> debbugs.gnu.org>; Thu, 12 Dec 2019 08:47:39 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc:content-transfer-encoding;
 bh=S0N+x3skxl/FOQrUezCIHvai21YHs6+v9X6+5Vq51uY=;
 b=hb8YhuMPoEFvAIKZmoDGnAFaT0tad5Ug2Zq2vEvCxmQ18oGoMkPIsvIVk80f28ZpcT
 MLZnx+6N0fQO74oRbkRPOY71zoeS60VVwGz6HL11SL46VAGWfWXik0cFvR22YvjnchJR
 pNPYNe2P50T3lKz1no2M9bRWo83OCH9OeQCJSYxFL4r1s4JRkuGtFxuA4TnVwh12dRTm
 KhUJ5QMAcR7SCT5XAIH9rQmHKb5IKBW2mmSVboyXOXVcdJXSwPmTHg33yqNEwe4A06rb
 VkuACuzO/UD5Z9Fp3jJGPUAJzOVzZVsoX4H/TueGBzaKehxWzrx8CIxu5TEjbKEe1Rop
 RjNA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc:content-transfer-encoding;
 bh=S0N+x3skxl/FOQrUezCIHvai21YHs6+v9X6+5Vq51uY=;
 b=mFSdvHGW/3rjgFKm3C+D5Xw/Gm23sdvjQoaJ3CXJTBkPPG9/js05NT4Kaxhds9qGuM
 bQ/C/9jrl1WM49oA/FKOiZy+RK/S9aIKBf6Ku8puw2K28d31tYNYa2zZv9cCyBdSwPbk
 r47edHJYn7OLN9UzzgKQHjapH8XIANvY7pJ55nMD0+vPGfYjBYZ4mXOmJgCFw+9IWuyW
 J++6IOvgoMduJJRbTytnPHtbH7fJYo66wYgbuK1QqOCV60WfT1kZ1Drt4qVJT7u68g+2
 WYpucXw9U19+FRGiNiSCYeR+CX+WC0uwmViUs+4MDK0Ea3EIIwgz4CNRlRr2VoVDgTTH
 PysQ==
X-Gm-Message-State: APjAAAVJZfmC761f/ed8xg6MrAXyTFxGI6R+MO0r1jpsc+byjhqwgeyz
 f2Ry5YFiVjIXKYXoluHbLaEKMTFTHykyCbV+a5k=
X-Google-Smtp-Source: APXvYqxTa7oVZ00H6LjVE7jLa07Yrrc7LKurbHq6X8YQhebvskv9P+PBaA3rPgWUqOtrvxOOQXjgaWdWjzcub1KYL8k=
X-Received: by 2002:ac8:7417:: with SMTP id p23mr8136804qtq.313.1576169254145; 
 Thu, 12 Dec 2019 08:47:34 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
In-Reply-To: <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Thu, 12 Dec 2019 17:47:23 +0100
Message-ID: <CAJ3okZ3+-yAfRpYDHz-jYONguOPWjff0iWZ_7NPEz6x5mbOO1w@HIDDEN>
Subject: Re: bug#38529: Make --ad-hoc the default for guix environment
 proposed deprecation mechanism
To: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Content-Transfer-Encoding: quoted-printable
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Guix-devel <guix-devel@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi G=C3=A1bor,

Thank you for summarizing the discussion on IRC that I missed.

Maybe I miss a point. Is the aim to conserve the "--ad-hoc" option
with a different effect? Or why do we want to conserve this option
name?
It appears to me simpler to give another name, for example
"--inputs-of". And it is more meaningful.


To be concrete, the different cases; (-) means current behavior and
(+) the new one:

1.
- guix environment foo
+ guix environment --inputs-of foo

2.
- guix environment --ad-hoc bar
+ guix environment bar


First, when "--ad-hoc" is used then it reports a warning: deprecated
option and falls in the current behavior.
When "--inputs-of" is used then it falls in the new behavior.
Therefore, no needs of the ugly "--ignore-deprecated-ad-hoc".


In other words, with the same future guix version,

 # Alice
 $ guix environment foo --ad-hoc bar
 Warning: deprecated... explanations...
               instead use:
                guix environment bar --inputs-of foo

 # Bob
 $ guix environment bar --inputs-of foo


Second, the previous "guix environment foo" (dependencies of foo) is
inconsistent with the new "guix environment bar" (only the package
bar). Therefore, let introduce the GUIX_ENVIRONMENT_DEPRECATED
variable to distinguish both, as you said.

 # Alice
 $ guix environment foo
 Warning: previous behavior requires GUIX_ENVIRONMENT_DEPRECATED=3D1
               turn off the warning: GUIX_ENVIRONMENT_NOWARNING=3D1

And Alice has now a new shell with the package foo. If she wants the
dependencies, she has two options:

$ GUIX_ENVIRONMENT=3D1 guix environment foo
or
$ guix environment --inputs-of foo


 # Bob
 $ guix environment bar
 Warning: previous behavior requires GUIX_ENVIRONMENT

And if Bob is annoyed by the warnings each time, he globally turns off
with the variable GUIX_ENVIRONMENT_NOWARNING=3D1.


Couple of months later -- after the period adoption -- we remove the
variables GUIX_ENVIRONMENT_NOWARNING and GUIX_ENVIRONMENT_DEPRECATED;
still keeping the warning with the "--ad-hoc" option. And then, after
we can remove the "--ad-hoc" option if required.


Maybe a miss a point. But the addition of the flag appears
"--too-long-to-type" to me ugly.


What do you think?

All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 12 Dec 2019 11:24:03 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Dec 12 06:24:03 2019
Received: from localhost ([127.0.0.1]:59091 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ifMZf-00050V-5y
	for submit <at> debbugs.gnu.org; Thu, 12 Dec 2019 06:24:03 -0500
Received: from mail-ed1-f48.google.com ([209.85.208.48]:41401)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <boskovits@HIDDEN>) id 1ifMZd-0004zu-Gv
 for 38529 <at> debbugs.gnu.org; Thu, 12 Dec 2019 06:24:01 -0500
Received: by mail-ed1-f48.google.com with SMTP id c26so1476333eds.8
 for <38529 <at> debbugs.gnu.org>; Thu, 12 Dec 2019 03:24:01 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=gaTw6OIQ/0DnYikjerPQ3r1fjBEqBv2S/Xo+2LIYxTg=;
 b=DT7RU6NoRA1xvJOKfLS0vJnwBw26rmcf9HCV7AIDqp4gjlKkaR3BzhbQocyWE820ay
 Vx44lNNYcVW2NE5ms3F6UgmYCMXHk0n3ArbNwJDlxjGyjcsVFPaTr0omL8nd0IdJz4Y+
 Up3vaBWQ7nU3HlegZOHOai+NtD+MbkYbvEm0fp/aQFene73XPjJoaQgo2QXLEsHXtiFa
 6dpOPEWyJup35BITiU+iYLzzGI3BwyzkSEV2/clkAXFRtBXeFwTU+XDH8kaxSp9qMKSQ
 outhzMXTleCmWiPyM7vSbjphqbw5ha4J7mbT8OYE+7+odGtnr1163TOAwwYOKFrqHbww
 /+Cg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=gaTw6OIQ/0DnYikjerPQ3r1fjBEqBv2S/Xo+2LIYxTg=;
 b=FGN0wUQc0D6NBPW9Sr/5ccwetcgT08hRgi8JmpDVLtIVtm28Wed5puMwTQrNX7C0hZ
 FYRaA71m1Bu8fKkt398i/yRgppCAKXQpw2BAKpKIeaaVpDBCMXkF13SjeRaWddwNRKmc
 5lGI1XE/A1D29flxz5O0gQG7L/LIzHsi35zbOeNmA84qucHQhoBx+TM+b00KIB+w/69K
 4XTnC1R4wCfK0X1ett77a9+/vwJ5FqXHqSG3zX/S0h2USOfJIE330bATSVJeL+Cg1DxF
 C7ksDp6/w4ERPLTCuuP1g42LFshFvpNweDMQVDX/8V4gCvyopeJiEBjhLi5XlIcWKJBz
 VZwQ==
X-Gm-Message-State: APjAAAVYxq+x3qKPmn+o50JqBsYFLpqgO5mAvt5QeVbfiVHp73MsmMNr
 HY7GDU28WSRwsOIAIIWGwi+0uhvsS5FL5hsQIg==
X-Google-Smtp-Source: APXvYqysKgFEUDFqS/6tbgotdkVPsnBY+5Up9KAiF/kcaNFAKu/n5vssVVqdffDkdbX8sGMMIIBgs0RmEq4eizcTKos=
X-Received: by 2002:a17:906:8394:: with SMTP id
 p20mr9236621ejx.136.1576149835556; 
 Thu, 12 Dec 2019 03:23:55 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
In-Reply-To: <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
From: =?UTF-8?Q?G=C3=A1bor_Boskovits?= <boskovits@HIDDEN>
Date: Thu, 12 Dec 2019 12:23:44 +0100
Message-ID: <CAE4v=phY+7CTKMf8Y3a9p4okfqtMGOWu9kd2Nu6oCJW8OsK3Lw@HIDDEN>
Subject: Make --ad-hoc the default for guix environment proposed deprecation
 mechanism
To: Guix-devel <guix-devel@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hello guix,

Based on discussion on IRC the following plan for deprecation might work.
Comments are welcome:

1.
Make guix environment aware of an environment variable:
GUIX_ENVIRONMENT_DEPRECATED_AD_HOC
if this is defined, then fall back to the current behaviour.

Motivation: this would enable most script users to bypass the problem,
while fixing them, but it makes the users aware that they are using a
deprecated feature.
At the same time this should come with a news entry, an any other
announcements should be made that we usually do, so that support don't
get overloaded. Is should also be announced that two releases later
the code supporting this will be removed, so that we don't have to
maintain it, but allow enough time for adoption.

2. add a flag to guix environment, something like
--ignore-deprecated-ad-hoc, that makes guix environment ignore the
environment variable, and default to the new behaviour.

Motivation: so that scripts can be fixed individually by modifying the
guix environment call to the new version, and adding the flag, so that
it does not cause a problem in the trasitional period while the
environment variable is defined.

3. on the specified release remove the environment variable support
code, and make the flag a noop, and also deprecated.

4. later if needed after an adoption period we can remove the flag.


Best regards,
g_bor
-- 
OpenPGP Key Fingerprint: 7988:3B9F:7D6A:4DBF:3719:0367:2506:A96C:CF63:0B21




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 10 Dec 2019 17:16:35 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Tue Dec 10 12:16:35 2019
Received: from localhost ([127.0.0.1]:56532 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iej7j-0001Ro-If
	for submit <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:16:35 -0500
Received: from eggs.gnu.org ([209.51.188.92]:57758)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <ludo@HIDDEN>) id 1iej7i-0001Rc-DV
 for 38529 <at> debbugs.gnu.org; Tue, 10 Dec 2019 12:16:34 -0500
Received: from fencepost.gnu.org ([2001:470:142:3::e]:55919)
 by eggs.gnu.org with esmtp (Exim 4.71) (envelope-from <ludo@HIDDEN>)
 id 1iej7c-0000Jd-U0; Tue, 10 Dec 2019 12:16:28 -0500
Received: from [2001:660:6102:320:e120:2c8f:8909:cdfe] (port=53704 helo=ribbon)
 by fencepost.gnu.org with esmtpsa (TLS1.2:RSA_AES_256_CBC_SHA1:256)
 (Exim 4.82) (envelope-from <ludo@HIDDEN>)
 id 1iej7b-0004lF-OS; Tue, 10 Dec 2019 12:16:28 -0500
From: =?utf-8?Q?Ludovic_Court=C3=A8s?= <ludo@HIDDEN>
To: "Thompson\, David" <dthompson2@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAJ=RwfabiMuyx_JXP+KU76kCCRAX0zofN14YJ5wEi-YMwNW_YQ@HIDDEN>
X-URL: http://www.fdn.fr/~lcourtes/
X-Revolutionary-Date: 20 Frimaire an 228 de la =?utf-8?Q?R=C3=A9volution?=
X-PGP-Key-ID: 0x090B11993D9AEBB5
X-PGP-Key: http://www.fdn.fr/~lcourtes/ludovic.asc
X-PGP-Fingerprint: 3CE4 6455 8A84 FDC6 9DB4  0CFB 090B 1199 3D9A EBB5
X-OS: x86_64-pc-linux-gnu
Date: Tue, 10 Dec 2019 18:16:26 +0100
In-Reply-To: <CAJ=RwfabiMuyx_JXP+KU76kCCRAX0zofN14YJ5wEi-YMwNW_YQ@HIDDEN>
 (David Thompson's message of "Mon, 9 Dec 2019 13:46:20 -0500")
Message-ID: <87o8wgksnp.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain; charset=utf-8
Content-Transfer-Encoding: quoted-printable
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: Pierre Neidhardt <mail@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

Hello!

"Thompson, David" <dthompson2@HIDDEN> skribis:

> I have long thought that --ad-hoc should be implied, as that is the
> mode I use 99% of the time, but I disagree that --pure should be the
> default.

I very much agree with that.  I don=E2=80=99t think =E2=80=98--pure=E2=80=
=99 should be the
default, because there are valid use cases for that.

As for =E2=80=98--ad-hoc=E2=80=99: making it the default is technically eas=
y.  The
difficulty is to come up with a nice transition/deprecation mechanism so
that we don=E2=80=99t break everyone=E2=80=99s script overnight.

Ideas on how to achieve it are welcome!

Thanks,
Ludo=E2=80=99.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 9 Dec 2019 20:17:42 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 15:17:41 2019
Received: from localhost ([127.0.0.1]:54454 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1iePTR-0000S9-Lo
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 15:17:41 -0500
Received: from mout01.posteo.de ([185.67.36.65]:39755)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <brettg@HIDDEN>) id 1iePTO-0000Rs-HE
 for 38529 <at> debbugs.gnu.org; Mon, 09 Dec 2019 15:17:39 -0500
Received: from submission (posteo.de [89.146.220.130]) 
 by mout01.posteo.de (Postfix) with ESMTPS id 00AF9160062
 for <38529 <at> debbugs.gnu.org>; Mon,  9 Dec 2019 21:17:31 +0100 (CET)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/simple; d=posteo.net; s=2017;
 t=1575922652; bh=2ANSwyXjO2aPKJuJfe22hxsIWmAzhXjAREt1pW9SBaA=;
 h=From:To:Cc:Subject:Date:From;
 b=cmkmo2SxSfULSm9maN/STgk7fCUd44ic5Repfw3e8Av2CdoeuPsQink9Uq7cH+RyL
 3nU9vV0saC4LZs2YhXaOqFj3SOTOPbEVFcriuQqNfMNQBcI+yskv5WRxGDf+Xz6OWC
 HlId9Zs5m/wFADCJDks7+PTAVddsDx93mK8xqmC1q4VbNF4u1wXaM+PXdEvQGzDpJK
 /DZ6KElvA9HjHZP9NwgVefz4s5Mt3BJ0UC84F/b4NAcyncobdU5lJmccUBva1nJc24
 6/FkcMKdqYyP9pNKuHY2tt6dy20WJkJFtIddiDnNK2zR2nJDrxpt4+BKqrZuoCqY39
 zzqRuwxkvPUrA==
Received: from customer (localhost [127.0.0.1])
 by submission (posteo.de) with ESMTPSA id 47Wvck2Bdmz6tmK;
 Mon,  9 Dec 2019 21:17:25 +0100 (CET)
From: Brett Gilio <brettg@HIDDEN>
To: "Thompson\, David" <dthompson2@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
 <CAJ=RwfabiMuyx_JXP+KU76kCCRAX0zofN14YJ5wEi-YMwNW_YQ@HIDDEN>
Date: Mon, 09 Dec 2019 14:17:24 -0600
In-Reply-To: <CAJ=RwfabiMuyx_JXP+KU76kCCRAX0zofN14YJ5wEi-YMwNW_YQ@HIDDEN>
 (David Thompson's message of "Mon, 9 Dec 2019 13:46:20 -0500")
Message-ID: <87blshuucr.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -2.3 (--)
X-Debbugs-Envelope-To: 38529
Cc: Pierre Neidhardt <mail@HIDDEN>, 38529 <at> debbugs.gnu.org,
 zimoun <zimon.toutoune@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -3.3 (---)

"Thompson, David" <dthompson2@HIDDEN> writes:

> Hi,
>
> I have long thought that --ad-hoc should be implied, as that is the
> mode I use 99% of the time, but I disagree that --pure should be the
> default. Most of the time I (and I suspect most other users) just want
> to temporarily augment the current environment with a package or two
> and I think that shouldn't require any special flags (neither --ad-hoc
> nor --pure).  The current default behavior of making an environment
> from package dependencies is because that's how nix-shell worked (or
> at least how I thought it worked) and 'guix environment' was created
> as a clone of that tool.
>
> - Dave

I was waiting for somebody to say this. But, I am 100% in agreement with
Dave as far as the behavior of --pure. I really would like to see either
nothing change, or we make --ad-hoc the implied default.

My reasoning confers with Dave's logic.

-- 
Brett M. Gilio
https://git.sr.ht/~brettgilio/




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 9 Dec 2019 18:46:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 13:46:39 2019
Received: from localhost ([127.0.0.1]:54419 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieO3L-0005k0-9Q
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 13:46:39 -0500
Received: from mail-vs1-f42.google.com ([209.85.217.42]:33892)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dthompson2@HIDDEN>) id 1ieO3J-0005jj-Ep
 for 38529 <at> debbugs.gnu.org; Mon, 09 Dec 2019 13:46:38 -0500
Received: by mail-vs1-f42.google.com with SMTP id g15so11109253vsf.1
 for <38529 <at> debbugs.gnu.org>; Mon, 09 Dec 2019 10:46:37 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=worcester-edu.20150623.gappssmtp.com; s=20150623;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=POzIvzoaNBi6tgQOpEc0XlYBz9Ew73t4hg3H88JMKwY=;
 b=h9O1YXXqc3V+HFvKIysK2JL1a0nQFP1+bTb3Rpx/Duf7PvMn5fR5oMEEQAcCVWh+rz
 Qc7zUi0/qvDh8DLidMkuRO25e2iY/BA2sUX9krKIWgzUEgyLMkUNKyS654wTFeWrwgTX
 4Cs/bOdMekurtpi5y33SfSsuPcT8porHywZrpjgA9b3EU8PpDApqSc1FjrR5+ez+UoVn
 tusOYs0y/0DYrzKehM249S7tQX1utYOjlXSnt87o7WFwgNfKje7gMr96J8ayxTEdhwJW
 GSFOEFVVGPe8QvXL/Q8DLMRp0A9KQgQ9ZddRsfpgLax/YPj1/8ByBDuWLFQFt6XuV+yX
 a6CQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=POzIvzoaNBi6tgQOpEc0XlYBz9Ew73t4hg3H88JMKwY=;
 b=NgnETbpoK2j1LdoGWZASpSiPAw1dJUAnTffrgdxdqEGkU8SpKk5tDjJLDW36zlBMb3
 W4w3YDe0EHDj1jTkqykcKshSyuywkcA3uEu4rNouV3NbEznp6l8MgBe+i8qNr8+VWVcj
 XfAVR3dNt4hK0O2q4VjXPQ21RvhjJ4jEnbZD45Ergjfp38iqhM1oNwUOXMUhLh8q0L6/
 fIZpYmDfrFvABSs6ye00Kp2V2xC0UyBa0U5I6ShotFAmbE4cxp5Z7OQ9ZLdZP30spfBm
 9+iDUHhqG85jOKEhpfEemDSbpDVJva9KZKMdTMYAJmV23U6sQYuj5Dj6khMa9w8IFcNd
 wJrg==
X-Gm-Message-State: APjAAAWSA810bQZBzUbARq7clihULJPkv7a2xMZzMzo19XT8Tvv2EEbg
 cf2BwAGVGehZc6w6g+SU829nIfiKN8tHYyroxJb19w==
X-Google-Smtp-Source: APXvYqz9aGRVOaDcEPICDIlc1uaXvEg/yY1Mc0GdCfBrfCM+jUfmoOEQxTza2Kc2ObgkZbs6oUGqudKcT0g1PY2l9Sg=
X-Received: by 2002:a05:6102:5e5:: with SMTP id
 w5mr18066559vsf.163.1575917191832; 
 Mon, 09 Dec 2019 10:46:31 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
 <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
In-Reply-To: <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
From: "Thompson, David" <dthompson2@HIDDEN>
Date: Mon, 9 Dec 2019 13:46:20 -0500
Message-ID: <CAJ=RwfabiMuyx_JXP+KU76kCCRAX0zofN14YJ5wEi-YMwNW_YQ@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
To: zimoun <zimon.toutoune@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: -0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: Pierre Neidhardt <mail@HIDDEN>, 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi,

I have long thought that --ad-hoc should be implied, as that is the
mode I use 99% of the time, but I disagree that --pure should be the
default. Most of the time I (and I suspect most other users) just want
to temporarily augment the current environment with a package or two
and I think that shouldn't require any special flags (neither --ad-hoc
nor --pure).  The current default behavior of making an environment
from package dependencies is because that's how nix-shell worked (or
at least how I thought it worked) and 'guix environment' was created
as a clone of that tool.

- Dave




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 9 Dec 2019 17:37:22 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 12:37:22 2019
Received: from localhost ([127.0.0.1]:54401 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieMyH-0003T2-SQ
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 12:37:22 -0500
Received: from mail-pg1-f173.google.com ([209.85.215.173]:45310)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <jgibbons2357@HIDDEN>) id 1ieMyG-0003Sq-MF
 for 38529 <at> debbugs.gnu.org; Mon, 09 Dec 2019 12:37:21 -0500
Received: by mail-pg1-f173.google.com with SMTP id b9so7058409pgk.12
 for <38529 <at> debbugs.gnu.org>; Mon, 09 Dec 2019 09:37:20 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=message-id:subject:from:to:in-reply-to:references:date:mime-version
 :user-agent:content-transfer-encoding;
 bh=UBWw84kW4/k8mS/Odoggyg0V0O/qQ4idirnEGZtTH1E=;
 b=UQ3fDK+wiUIYsc23GtOw9d1IiwmbEpJsDJNTxG5U2MwGqIgNGXfmAP3DykC4drYbDC
 WMmxBznHLbvMz4OZMU0nUhc0j1csdEUmY7QteDrgfCBNC1Z/P4bwD3ROJfHI1C1vTz7k
 u6wCE/6SfnwrF/vZf1Bgrysj4sbxHlaivOTBFIZQ9c2w9F0GM1M5dkjAbdUC45ZFSMCA
 wpM1lYpF/EtKkwwYzMqZFnh4yjoS1w9V+lKYLB97mY2ziUAScppBzTO9RzT3KH7fryv9
 IYVQEtpUbMJuQ0UoY9mkRCV5eU0T7qOyA5k6pq+dxNoQz1i1gpKUCOdwVF6Rf7MuoCXO
 XtYg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:message-id:subject:from:to:in-reply-to
 :references:date:mime-version:user-agent:content-transfer-encoding;
 bh=UBWw84kW4/k8mS/Odoggyg0V0O/qQ4idirnEGZtTH1E=;
 b=FX/YHLB8gSkXHT/J+nL9qUuYIvoNY8LpY0TyELgHWM0Ecas1ELD+AUzSkUj93aAqz8
 LuYwz8uvTTAWY4o7igq0cyn6kFJr+ZldHeAkvVt1be8RzFDBAYZ///IYfQxD3Q9JwHPK
 KsEgesHdXrbtTeylKA69sksThPWO4U7auDTwRmVEibYi6uVp6eNwM77jGTqQAmFONg9Q
 9BlCv0XgGEIwMfCRCf8ygwX7WQMZs0f6nROJmk/ZExLVzykbwaI0E5AauaQ/wCTv5+A8
 D1YwJn/t6DJiOeRMangEIB9uVxb3k5Fjy6t0oAZfGzc39jI7rCROwCXPVGFfz3YcgXU8
 VrKA==
X-Gm-Message-State: APjAAAUuDjWGONICgwE1suGtBDFrZ7hqOpMoH9coDA/sS6Qa2XRIkwGB
 OYU4TbsUcUgW0tYbrsKmfufV5u4I
X-Google-Smtp-Source: APXvYqzCngLuAaJLBtKBuXIqiDW/d76ciSsHdLBvynQWhW4rknnpqMXQbGQZNuKy8ugTf2Fiqy6A1g==
X-Received: by 2002:aa7:8d45:: with SMTP id s5mr7021179pfe.148.1575913034687; 
 Mon, 09 Dec 2019 09:37:14 -0800 (PST)
Received: from piranhaplant.local ([199.68.53.171])
 by smtp.googlemail.com with ESMTPSA id b7sm42117pjo.3.2019.12.09.09.37.13
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Mon, 09 Dec 2019 09:37:13 -0800 (PST)
Message-ID: <e56ae49d56e50c40a8e1d279e7d0b2b14761935b.camel@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
From: Jesse Gibbons <jgibbons2357@HIDDEN>
To: Pierre Neidhardt <mail@HIDDEN>, 38529 <at> debbugs.gnu.org
In-Reply-To: <87eexeu8mo.fsf@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
Date: Mon, 09 Dec 2019 10:37:12 -0700
MIME-Version: 1.0
User-Agent: Evolution 3.30.5 
Content-Transfer-Encoding: 7bit
X-Spam-Score: 0.3 (/)
X-Debbugs-Envelope-To: 38529
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -0.7 (/)

On Sun, 2019-12-08 at 16:42 +0100, Pierre Neidhardt wrote:
> --pure seems to be the more sensible behaviour.  "Impure" environments
> can have unexpected behaviours, so it makes sense to only allow them
> when the user explicitly asks for it.
> 
--pure environments sometimes miss important environment variables. Try
running any app that depends on X and doesn't fallback to a console mode in
a pure environment.
for example, "guix environment --pure --ad-hoc pavucontrol -- pavucontrol"
gives me an error: 
No protocol specified
Unable to init server: Could not connect: Connection
refused



Similarly, "guix environment --pure --ad-hoc gnubik -- gnubik" gives me an
error:
No protocol specified

(gnubik:29707): Gtk-WARNING **: 10:03:28.753: cannot open display: :1





"guix environment --pure --ad-hoc gedit -- gedit":
No protocol specified
Unable to init server: Could not connect: Connection refused

(org.gnome.gedit:31542): Gtk-WARNING **: 10:08:07.401: cannot open display:
:1



Making --pure the default for "guix environment" would make things more
complicated for users wanting to temporarily run GUI apps unless we fix this
issue first. I furthermore suspect some tests fail because of this issue.





Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 9 Dec 2019 05:23:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Mon Dec 09 00:23:18 2019
Received: from localhost ([127.0.0.1]:52505 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ieBVt-0000O7-Td
	for submit <at> debbugs.gnu.org; Mon, 09 Dec 2019 00:23:18 -0500
Received: from mail-qv1-f53.google.com ([209.85.219.53]:41256)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <maxim.cournoyer@HIDDEN>) id 1ieBVs-0000Np-FO
 for 38529 <at> debbugs.gnu.org; Mon, 09 Dec 2019 00:23:16 -0500
Received: by mail-qv1-f53.google.com with SMTP id b18so2176470qvo.8
 for <38529 <at> debbugs.gnu.org>; Sun, 08 Dec 2019 21:23:16 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:references:date:in-reply-to:message-id
 :user-agent:mime-version;
 bh=QlxLMicTrL3L18KMTrjDdAM7XYirktxmp8eUBeQ5Lu8=;
 b=iJU3mix0+NPWUbS019ue2fs8nwkdxQX6zqybQ1lxncR45nq4QAm5bTDas5FdJ3V86y
 HugDWyXQ8BZdTkUtIibO4CyyZ5s70hcmRZ8VvSZKnBtFCdbVTNKJzpflvPtLlIjf9gSN
 //zYC7hxWzpLy1eqFOLM7dmTdZDDHP0FO5v7Wy3XVMzzwCxoUpbPtuLGbuY5x44zvEGG
 3obZQw57Dj2Y8xYAZqDlVgbxouPECUPGFh0K60kV3NMCQaMpsWt3PPirgVrGDhMMnfkI
 FqY1VLsO0prrX+f2TQCv07vusNAx54nIYBFE6jv/7+gP+WLM0qxbUrEeAZOk84zhAVb3
 ltBA==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:references:date:in-reply-to
 :message-id:user-agent:mime-version;
 bh=QlxLMicTrL3L18KMTrjDdAM7XYirktxmp8eUBeQ5Lu8=;
 b=LNa/aVGNPJspF6WpG2xzU++ZXHvlcSATNFXD6ktzYI+Ni+BuM604LjLi5xkr5hkJKD
 oZOESkPyw3G+wz5BFlsOvueF1PLPst9cur/lcXuiaN4zkSbUj5oAAy+8W9lgkECR8kGn
 WBY9w3Q7ycw3aCZ2VAkLhUguL20e4fOWURro+qB3JDZv0pgRYEGhGO1VNttnJgvJME08
 IJaw4xHU6kStNbOngh9cvTA3cTue0DjumDIcogc2iOIP5vevtwf5cT+fA9xXIX+e1okD
 r2E2i4dG3q/h2v8LQmXlEssdbG0LC+Y++Z+DeGrjUNiz2KtYkVP5E8GbWNTuc/mG4T52
 Qpcg==
X-Gm-Message-State: APjAAAXqiKRkUQRRs0xhuJUnTML9uUrYgTLbRFvgzKBdDL7ReiawRzu+
 K5Z6eR0gV8pxnoXQUZoiy74kJ6/h
X-Google-Smtp-Source: APXvYqzQXIoALwDQAjRZGhfn2VnOiUhMCa9rEH6/kVhEsAr9mSRo3P/9sM3UhThA0fao5gbXOGGYdw==
X-Received: by 2002:a05:6214:8c3:: with SMTP id
 da3mr21646111qvb.249.1575868990717; 
 Sun, 08 Dec 2019 21:23:10 -0800 (PST)
Received: from x200 ([204.48.76.45])
 by smtp.gmail.com with ESMTPSA id x19sm7145517qtm.47.2019.12.08.21.23.09
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Sun, 08 Dec 2019 21:23:10 -0800 (PST)
From: Maxim Cournoyer <maxim.cournoyer@HIDDEN>
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
References: <87eexeu8mo.fsf@HIDDEN>
Date: Mon, 09 Dec 2019 14:23:07 +0900
In-Reply-To: <87eexeu8mo.fsf@HIDDEN> (Pierre Neidhardt's message of
 "Sun, 08 Dec 2019 16:42:07 +0100")
Message-ID: <87tv6aoyx0.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/26.3 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: -0.1 (/)
X-Debbugs-Envelope-To: 38529
Cc: 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.1 (-)

Hi Pierre,

Pierre Neidhardt <mail@HIDDEN> writes:

> --pure seems to be the more sensible behaviour.  "Impure" environments
> can have unexpected behaviours, so it makes sense to only allow them
> when the user explicitly asks for it.

Unfortunately Guix packages often don't work well with --pure.  Be it
magit that depends on git, or Emacs that depend or coreutils, etc.,
there are many things that are expected to be propagated and aren't
explicitly, by omission or sometimes for closure's size sake (when the
feature is optional).  We could argue that is a good reason for the
proposed change :-).

I think environments are great mostly for hacking and trying stuff
quickly, where the guarantees of Guix do not matter as much as for
profiles (and if they did, you'd be better with guix environment
--container anyway).

So, I guess that makes me more on the side of "let's no change the
defaults for now".

Maxim




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 8 Dec 2019 22:43:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 17:43:15 2019
Received: from localhost ([127.0.0.1]:52400 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ie5Gk-0001pq-2z
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 17:43:15 -0500
Received: from out5-smtp.messagingengine.com ([66.111.4.29]:45387)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <leo@HIDDEN>) id 1ie5Gh-0001pc-G6
 for 38529 <at> debbugs.gnu.org; Sun, 08 Dec 2019 17:43:12 -0500
Received: from compute4.internal (compute4.nyi.internal [10.202.2.44])
 by mailout.nyi.internal (Postfix) with ESMTP id 22AFE22785;
 Sun,  8 Dec 2019 17:43:06 -0500 (EST)
Received: from mailfrontend2 ([10.202.2.163])
 by compute4.internal (MEProxy); Sun, 08 Dec 2019 17:43:06 -0500
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=famulari.name;
 h=date:from:to:cc:subject:message-id:references:mime-version
 :content-type:in-reply-to; s=mesmtp; bh=DVEz0Qcyvd+nK8XkuWbXLRAr
 JeyZtoLlPUlFQswb9tU=; b=KFCip6BUbJI4q6/Vxypj0qs74Il8umfJo6VaCHit
 fSuW1cHaHalpcVb58zMUY5C3oaEtLvr9SWqMgBrifHDPf3kTpgKiNXBJ4O7NTEju
 gvdBT2y+Gv21SbYf54Arv96OaBEQa8267D84xpIX1xmwuxjs6tS8G0rwlZgVYm4p
 mWY=
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=
 messagingengine.com; h=cc:content-type:date:from:in-reply-to
 :message-id:mime-version:references:subject:to:x-me-proxy
 :x-me-proxy:x-me-sender:x-me-sender:x-sasl-enc; s=fm1; bh=DVEz0Q
 cyvd+nK8XkuWbXLRArJeyZtoLlPUlFQswb9tU=; b=H5kK3QDxaEr0IAxTJ/O4DN
 z2RRfp3wJ9NKWi+cF/BIH1C5oWY2FmiCppo/TXODt2g+Bg++PjxVDJgcb9XDT4rW
 i/V20+bJV+j6f+fl4ipOMBbFlhiaFt41/x4RHrh1WH0IwYpkj3GTPyFirVdu22M6
 mHGnYF0AA8MCqK5WScJgfwfdEPpswWPCXdCULVWQMFXuU9IdaO+6l8ha0LPQmrIB
 AkUXu/u3D+PAVY/2ZR52UPSma5YQNpDfyjFGrt1YQx2rSKRzkvq6yAfcTHtVBT/A
 TBLm/r5sCSpChzYN7heBKRmPe0KDriVh8KsnyaZJr9zYCYctHg+FfOZqIcPCsaCA
 ==
X-ME-Sender: <xms:eXztXc55z0vJ3ZL93BvztWaGOq7TsW4ez6eL4xnBjE5ecDBQcFL2Uw>
X-ME-Proxy-Cause: gggruggvucftvghtrhhoucdtuddrgedufedrudekkedgtdduucetufdoteggodetrfdotf
 fvucfrrhhofhhilhgvmecuhfgrshhtofgrihhlpdfqfgfvpdfurfetoffkrfgpnffqhgen
 uceurghilhhouhhtmecufedttdenucenucfjughrpeffhffvuffkfhggtggujggfsehttd
 ertddtredvnecuhfhrohhmpefnvghoucfhrghmuhhlrghrihcuoehlvghosehfrghmuhhl
 rghrihdrnhgrmhgvqeenucfkphepjeeirdduvdegrddufeekrdeifeenucfrrghrrghmpe
 hmrghilhhfrhhomheplhgvohesfhgrmhhulhgrrhhirdhnrghmvgenucevlhhushhtvghr
 ufhiiigvpedt
X-ME-Proxy: <xmx:eXztXag8Stn43sJQl1o0LLrojjRH_e439tVbUU4McL60xvSIrUEYwQ>
 <xmx:eXztXR0pG3YHwjUEHV9j7S5bsL_L472dek7GycNjQivNj7KXTAsGJg>
 <xmx:eXztXbAlypo6QIFVfA1CAneiFiXlB2qblvkD-PkiZtptPe1ukvO9pw>
 <xmx:enztXRSpXL5YRa-B1E_RrHPacUMwJW3wvh5ON3GEk-M_Lf3bSTG8WA>
Received: from localhost (c-76-124-138-63.hsd1.pa.comcast.net [76.124.138.63])
 by mail.messagingengine.com (Postfix) with ESMTPA id 5EC5130600DB;
 Sun,  8 Dec 2019 17:43:05 -0500 (EST)
Date: Sun, 8 Dec 2019 17:43:04 -0500
From: Leo Famulari <leo@HIDDEN>
To: Pierre Neidhardt <mail@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
Message-ID: <20191208224304.GA4213@HIDDEN>
References: <87eexeu8mo.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: text/plain; charset=us-ascii
Content-Disposition: inline
In-Reply-To: <87eexeu8mo.fsf@HIDDEN>
User-Agent: Mutt/1.12.2 (2019-09-21)
X-Spam-Score: -0.7 (/)
X-Debbugs-Envelope-To: 38529
Cc: 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.7 (-)

On Sun, Dec 08, 2019 at 04:42:07PM +0100, Pierre Neidhardt wrote:
> --pure seems to be the more sensible behaviour.  "Impure" environments
> can have unexpected behaviours, so it makes sense to only allow them
> when the user explicitly asks for it.

I don't have an opinion about this in general except that I think that
--ad-hoc should continue to work the way it does now, without --pure
being implied.




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at 38529 <at> debbugs.gnu.org:


Received: (at 38529) by debbugs.gnu.org; 8 Dec 2019 21:03:55 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 16:03:55 2019
Received: from localhost ([127.0.0.1]:52297 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1ie3ic-0003Xi-1e
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 16:03:54 -0500
Received: from mail-qt1-f178.google.com ([209.85.160.178]:40688)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <zimon.toutoune@HIDDEN>) id 1ie3ia-0003XW-EA
 for 38529 <at> debbugs.gnu.org; Sun, 08 Dec 2019 16:03:52 -0500
Received: by mail-qt1-f178.google.com with SMTP id t17so6846513qtr.7
 for <38529 <at> debbugs.gnu.org>; Sun, 08 Dec 2019 13:03:52 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=mime-version:references:in-reply-to:from:date:message-id:subject:to
 :cc; bh=aLnTjjhi0I0Iu07t7xVuxQq405awNn/1ci+4V/YgOPI=;
 b=gq6m0k25SIPAWgODGZklnqfkcUdMWgy9NDo9bs5kaZLsbYouKRm78e4ZTw4lCuZAUk
 Hhg9eAOj8eQ+BjssyOrg7rAJTXTd2d1BNHLpniwMpcxTRsxX0Yg7PNFNaLgelm3k+JiL
 aJukc9hevIaQK061I44epL6zOEzD+ODyvW/qCiYmK+paPkzomH2o37k5RJTNpJB+R1e2
 Zu30lqw+yo+E7AVuiKvEUdnXQY+4kAxeOUwMQoCzl2PjSiT7rrq+oLeely2lpa7yjqbw
 DkQAnN8Pl/w8MnTJYhX1uDQvlg42xZIOwYs+IxA6cjjOKZNmBXi7xn7TzcyHS4/yhwo5
 z/gg==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:mime-version:references:in-reply-to:from:date
 :message-id:subject:to:cc;
 bh=aLnTjjhi0I0Iu07t7xVuxQq405awNn/1ci+4V/YgOPI=;
 b=C6PhvZRCwmJWZHFLlsRQWh7+8u6mW9gNzngJxRcZPFYBVfxBiK9eCt6OWDVjJ3UHp/
 zFKyLz6dTrE8rfYJ9OeBuCYlnBrkrnsb+6KUYCJB5C/ohQtF+SdVOqQquB/YG/HhFJqW
 4VBn9Og5a6A8Neh5onWnZvWxAZ3mv0aXkO5UHPwxf2Fq725yE/pLfzym1LDTqZfExTJx
 x2/uAiZ9eIcJz7UMkZ7Fol5YgtBQ8oU0TUm/3ySMVT9wZkDg1V44r9//19VfEIZrydZr
 hwUuMWTOj1jxZRJoK6TgF/gqRUhXa1Gl0rYaILACFv6DA24spgYWJzN4STvFuiPOr7e3
 VWTA==
X-Gm-Message-State: APjAAAXKI5y2NBV3xKhDHYWFTEXGgU/W+nNybP/NoahWzY8mfyaT0aMy
 n9MNrF/SjIYbKSM0NJc+Tu5sLD7dG/eExpu8Y4k=
X-Google-Smtp-Source: APXvYqy7LfaKdsFzg7Di9t0KQ5fUD65JHDnWG4OwlhpM7LqZgK+y8S2FY4w5yeV360QKoVXj08fd36+hVyMD8dfX5Kg=
X-Received: by 2002:aed:2270:: with SMTP id o45mr22436606qtc.217.1575839027062; 
 Sun, 08 Dec 2019 13:03:47 -0800 (PST)
MIME-Version: 1.0
References: <87eexeu8mo.fsf@HIDDEN>
In-Reply-To: <87eexeu8mo.fsf@HIDDEN>
From: zimoun <zimon.toutoune@HIDDEN>
Date: Sun, 8 Dec 2019 22:03:35 +0100
Message-ID: <CAJ3okZ3WnG87m=jQw08M9ER+=9FS0NVx=uALHK_-4LuD50KhvA@HIDDEN>
Subject: Re: bug#38529: Make --pure the default for `guix environment'?
To: Pierre Neidhardt <mail@HIDDEN>
Content-Type: text/plain; charset="UTF-8"
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 38529
Cc: 38529 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Hi Pierre,

I agree.

And also change the default which populates by the dependencies. Something like:

  guix environment foo --inputs-of bar

should spawn an environment containing foo and the dependencies bar.
Well, keeping the --ad-hoc option for compatibility.


What do you think?

All the best,
simon




Information forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 8 Dec 2019 15:42:15 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sun Dec 08 10:42:15 2019
Received: from localhost ([127.0.0.1]:52071 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1idyhK-0007w4-OO
	for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 10:42:14 -0500
Received: from lists.gnu.org ([209.51.188.17]:56779)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <mail@HIDDEN>) id 1idyhI-0007vw-PA
 for submit <at> debbugs.gnu.org; Sun, 08 Dec 2019 10:42:13 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:59417)
 by lists.gnu.org with esmtp (Exim 4.90_1)
 (envelope-from <mail@HIDDEN>) id 1idyhH-0003iU-Jy
 for bug-guix@HIDDEN; Sun, 08 Dec 2019 10:42:12 -0500
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=0.1 required=5.0 tests=BAYES_50,RCVD_IN_DNSWL_LOW,
 URIBL_BLOCKED autolearn=disabled version=3.3.2
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
 (envelope-from <mail@HIDDEN>) id 1idyhG-0007Tc-Es
 for bug-guix@HIDDEN; Sun, 08 Dec 2019 10:42:11 -0500
Received: from relay3-d.mail.gandi.net ([217.70.183.195]:49539)
 by eggs.gnu.org with esmtps (TLS1.0:DHE_RSA_AES_256_CBC_SHA1:32)
 (Exim 4.71) (envelope-from <mail@HIDDEN>) id 1idyhG-0007Ib-6D
 for bug-guix@HIDDEN; Sun, 08 Dec 2019 10:42:10 -0500
X-Originating-IP: 92.169.151.76
Received: from bababa (lfbn-1-4156-76.w92-169.abo.wanadoo.fr [92.169.151.76])
 (Authenticated sender: mail@HIDDEN)
 by relay3-d.mail.gandi.net (Postfix) with ESMTPSA id 0F4E360005
 for <bug-guix@HIDDEN>; Sun,  8 Dec 2019 15:42:07 +0000 (UTC)
From: Pierre Neidhardt <mail@HIDDEN>
To: bug-guix@HIDDEN
Subject: Make --pure the default for `guix environment'?
Date: Sun, 08 Dec 2019 16:42:07 +0100
Message-ID: <87eexeu8mo.fsf@HIDDEN>
MIME-Version: 1.0
Content-Type: multipart/signed; boundary="=-=-=";
 micalg=pgp-sha256; protocol="application/pgp-signature"
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.2.x-3.x [generic]
 [fuzzy]
X-Received-From: 217.70.183.195
X-Spam-Score: 0.9 (/)
X-Debbugs-Envelope-To: submit
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

--=-=-=
Content-Type: text/plain
Content-Transfer-Encoding: quoted-printable

=2D-pure seems to be the more sensible behaviour.  "Impure" environments
can have unexpected behaviours, so it makes sense to only allow them
when the user explicitly asks for it.

=2D-=20
Pierre Neidhardt
https://ambrevar.xyz/

--=-=-=
Content-Type: application/pgp-signature; name="signature.asc"

-----BEGIN PGP SIGNATURE-----

iQEzBAEBCAAdFiEEUPM+LlsMPZAEJKvom9z0l6S7zH8FAl3tGc8ACgkQm9z0l6S7
zH/MHQgApSwFQkblgyaCyxB1Sg11edxeCLCPTDaJClGB9KCfvxpQUXTniTxvwPD/
5y/P12V+MinvUKRm3zHucKkurbfikL9GkTw1A589fvrAqiRbM86aoImkumttJp5u
6DQIkRY6WMlB+yGx3T/reFe/Be3G4fNnXCe6POPap98jWQY2vJPOPNsMPtXliS5a
iOzOHxCbElpIIUejyl0vbQkzrNXqn5Y95yn2Ymy1FahTjHwmscziYRZsnY2Km+W4
Ew15gj7wzBPmCq1QeJ9jsoFynOV7pXZnOdA9RBOSZu0kGvXFZkVXdTtrqv8/Lg31
mS9FNKno/LsaFqqm4jOBm96Ze3OhIw==
=MXkn
-----END PGP SIGNATURE-----
--=-=-=--




Acknowledgement sent to Pierre Neidhardt <mail@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-guix@HIDDEN. Full text available.
Report forwarded to bug-guix@HIDDEN:
bug#38529; Package guix. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Mon, 30 Dec 2019 21:45:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.